/***********************************************************************
*
* ļ        SharedMemory_Linux.cpp
* ģĿģʵLinux/UNIX¹ڴ
* ߼ڣ  wang_jin 2008-05-18
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "GDLog/GDTrace.h"
//#include "Common/ConvertString.h"


CSharedMemoryManager::CSharedMemoryManager()
{
	m_nSharedMemoryID = -1;
	m_pBaseAddress = NULL;
	m_pSMData = NULL;
}

CSharedMemoryManager::~CSharedMemoryManager()
{
}

//ʼ:ȡùڴ
long CSharedMemoryManager::CreateMemory( long nKey, long nMaxSize, bool* pbOwner )
{
	CGDTrace trace( LOG_L6, "CSharedMemoryManager:CreateMemory(%x,%d)", nKey, nMaxSize );

	bool bOwner = false;
	m_nSharedMemoryKey=nKey;
	m_nMaxSize=nMaxSize;

	if ( -1 == m_nSharedMemoryID )
	{
		// Դڴ
		m_nSharedMemoryID = shmget(
			m_nSharedMemoryKey,
			1024*nMaxSize,
			IPC_CREAT|IPC_EXCL|0666);
		if ( -1 == m_nSharedMemoryID )
		{
			CGDTrace::GDTrace( LOG_NOT, "SharedMemory exist; Open SharedMemory!" );

			// 򿪹ڴ棬򷵻Ѵڹڴ
			m_nSharedMemoryID = shmget(
				m_nSharedMemoryKey,
				1024*nMaxSize,
				IPC_CREAT|0666);
			if ( -1 == m_nSharedMemoryID )
			{
				int nErr = errno;
				CGDTrace::GDTrace( LOG_ERR, "shmget(%x,%d) errno=[%d]", 
					m_nSharedMemoryKey, nMaxSize, nErr );
				GDETrace( "򿪹ڴʧ[%d][%s]", nErr, GetErrText(nErr) );
				return MSG_MEM_CREATEFILE_FAIL;
			}

			CGDTrace::GDTrace( LOG_NOT, "I am not owner!" );
		}
		else
		{
			CGDTrace::GDTrace( LOG_NOT, "Create SharedMemory success! I am owner!" );
			bOwner = true;
		}
	}

	if ( pbOwner ) *pbOwner = bOwner;

	// ӳ
	m_pBaseAddress = shmat( m_nSharedMemoryID, 0, 0 );
	if ( (void*)-1 == m_pBaseAddress )
	{
		CGDTrace::GDTrace( LOG_NOT, "Map addr failed[%d]", errno );
		return trace.SetRetValue( MSG_MEM_MAPFILE_FAIL );
	}

	m_pSMData = (SharedMemoryData*)m_pBaseAddress;

	// ӳɹ
	if ( bOwner ) // ˭˭ʼ
	{
		// 洢ڴСϢ
		m_pSMData->nSize = 1024*m_nMaxSize - sizeof(SharedMemoryData);
		m_pSMData->nOffset = sizeof(SharedMemoryData); // ¼Եַ
	}

	return NO_ERROR;
}

long CSharedMemoryManager::CreateMemory( const char* sKey, long nMaxSize, bool* pbOwner )
{
	CGDTrace trace( LOG_L6, "CSharedMemoryManager:CreateMemory(%s,%d)", sKey, nMaxSize );	
	key_t key = ftok( sKey, 'W' );
	return CreateMemory(key,nMaxSize,pbOwner);	
}

// ()
long CSharedMemoryManager::CreateMemory( long nMaxSize )
{
	CGDTrace trace( LOG_L6, "CSharedMemoryManager:CreateMemory()");
	long nRet = CreateMemory( m_nSharedMemoryKey, nMaxSize );
	return trace.SetRetValue( nRet );
}

long CSharedMemoryManager::ReleaseMemory()
{
	// CGDTrace trace( LOG_L6, "CSharedMemoryManager:ReleaseMemory()");
	
	if(m_nSharedMemoryID!=-1)
	{
		shmdt((char*)m_pBaseAddress);

		// ɾڴ
		//shmctl(m_nSharedMemoryID,IPC_RMID,0);
	}
	return 0;
	// return trace.SetRetValue( 0 );
}
