/********
 
 ********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

/**********************
 TAG ṹ
 ֵ  ֵ
 **********************/
int f_packTLV(char **pBody, char *pValue, int tag)
{
    int len;

    *(*pBody) = tag;
    *pBody += 1;

    if( pValue == NULL )
        len = 0;
    else
        len = strlen(pValue);

    sprintf(*pBody, "%04d", len);
    *pBody += 4;

    if( len > 0 )
    {
        strcpy(*pBody, pValue);
        *pBody += len;
    }

    return(len);
}

/**********************************
 ʼTAG ṹռ
 ֵ  -1ʧ   0ɹ
 **********************************/
int f_iniTAG(void)
{
    int i;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        /* ؼֳ */
        u_TAGs[i].klen = strlen(u_TAGs[i].key);

        /* ڴ */
        if( (u_TAGs[i].pv = (char *)malloc(u_TAGs[i].vlen + 1)) == NULL ) return(-1);
    }

    return(0);
}

/**************************
 λTAG
 ֵ  -1ʧ   >=0±
 **************************/
int f_seekTAG(int atag)
{
    int i;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;
        if( u_TAGs[i].tag == atag ) return(i);
    }

    return(-1);
}

/**********************************
 ݹؼλTAG
 ֵ  -1ʧ   >=0±
 **********************************/
int f_seekTAGbyKey(int agroup, char *pkey)
{
    int i;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;
        if( agroup > 0 && u_TAGs[i].group != agroup ) continue;

        if( strncmp(pkey, u_TAGs[i].key, u_TAGs[i].klen) == 0 ) return(i);
    }

    return(-1);
}

/***********************
 TAG ֵ
 ֵ  -1ʧ  0ɹ
 ***********************/
int f_setTAG(int atag, char *pV)
{
    int i;

    if( (i = f_seekTAG(atag)) < 0 ) return(-1);

    if( strlen(pV) > u_TAGs[i].vlen ) return(-1);
    strcpy(u_TAGs[i].pv, pV);

    return(0);
}

/************************
 TLV ṹ
 ֵ  -1ʧ   0ɹ
 ************************/
int f_unpackTLV(char *pBuf, int alen)
{
    int   tag, length, i;
    char *p = pBuf;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;
        *(u_TAGs[i].pv) = 0;
        u_TAGs[i].bSet = 0;
    }

    for( i = 0; p - pBuf < alen; p += length )
    {
        tag = *p;
        p += 1;

        sscanf(p, "%4d", &length);
        p += 4;

        /* λTAG */
        if( (i = f_seekTAG(tag)) < 0 ) continue;

        /* ֵ */
        if( length > u_TAGs[i].vlen )
        {
            z_logv(g_logfile, "tag=%d, length=%d, vlen=%d", tag, length, u_TAGs[i].vlen);
            return(-1);
        }

        strncpy(u_TAGs[i].pv, p, length);
        u_TAGs[i].pv[length] = 0;
        u_TAGs[i].bSet = 1;
    }

    return(0);
}

/**********************
 ļ
 ֵ  -1ʧ 0ɹ
 **********************/
int f_updateCFG(char *pFile, int aGroup)
{
    FILE *fp, *fp1;

    int   i, b, tag;
    char  szFileN[512];

    static char szBuf[1024];

    snprintf(szFileN, sizeof(szFileN), "%s.__tmp", pFile);

    /* ļ */
    if( (fp = fopen(pFile, "r")) == NULL ) return(-1);

    /* ʱļд */
    if( (fp1 = fopen(szFileN, "w")) == NULL )
    {
        fclose(fp);
        return(-1);
    }

    b = 0;
    while( ! feof(fp) )
    {
        szBuf[sizeof(szBuf) - 2] = '\n';
        if( fgets(szBuf, sizeof(szBuf), fp) == NULL ) break;

        /* й */
        if( szBuf[sizeof(szBuf) - 2] && szBuf[sizeof(szBuf) - 2] != '\n' )
        {
            b = -1;
            break;
        }

        for( i = 0, tag = -1; i < MAXN_TAG; i++ )
        {
            if( u_TAGs[i].tag == 0 ) break;
            if( u_TAGs[i].group != aGroup ) continue;

            /* ؼƥ */
            if( strncmp(szBuf, u_TAGs[i].key, u_TAGs[i].klen) == 0 )
            {
                tag = 1;
                break;
            }
        }

        if( tag > 0 )   /* Ϣ */
            fprintf(fp1, "%s=%s\n", u_TAGs[i].key, u_TAGs[i].pv);

        else            /* ¼ */
            fputs(szBuf, fp1);
    }
    fclose(fp);
    fclose(fp1);

    if( b < 0 ) return(-1);

    if( rename(szFileN, pFile) < 0 ) return(-1);
    return(0);
}

/**********************
 Ȩļ
 ֵ  -1ʧ 0ɹ
 **********************/
int f_addAuth(char *pNo, char *pBelong)
{
    char szBuf[64], szAuthFile[256];

    struct passwd *psd;

    /* ȨϢ */
    if( strcmp(u_pkthead.uid, "0") )    /* ͨû */
    {
        sprintf(szBuf, "%s,%s", u_pkthead.uid, pBelong);
    }
    else
    {
        /* ȡûID */
        if( (psd = getpwnam(pBelong)) == NULL )
        {
            z_logv(g_logfile, "û'%s'", pBelong);
            return(-1);
        }

        sprintf(szBuf, "%ld,%s", (long)(psd->pw_uid), pBelong);
    }

    /* Ȩļ */
    if( z_getkeyv(u_szPlatCfg, AUTHFILE, szAuthFile, sizeof(szAuthFile) - 1) )
    {
        return(0);
    }

    if( z_updatekeyv(szAuthFile, SG_AUTH_BEG, pNo, szBuf, NULL) < 0 )
    {
        return(-1);
    }
    if( chmod(szAuthFile, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH) < 0 )
    {
        return(-1);
    }

    return(0);
}

