/**********************************
 UDP ղ¼ܼ־
 **********************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "zvdef.h"
#include "zvar.h"
#include "gcps.h"
#include "z.h"

static    int    t_nid_sw_cycle = 15;           /* ļл() */

int f_log_switch(char *a_pMsg);

int main(int argc, char **argv)
{
    int  r,
         on,
         sktfd;                         /* ׽ */

    char spno[65],                      /* ̱ */
         szValue[16];

#if (OS == 3)     /* HP */
    int clilen;
#else
    socklen_t clilen;
#endif
    struct sockaddr_in client, server;

    static char buf1[1024];

    r = GC_daemon_init(u_pcfgfile, spno, NULL, NULL, NULL);
    if( r )
    {
        printf("󣺳ʼʧ%d", r);
        return(0);
    }

    /* ļ· */
    if( z_getkeyv(u_pcfgfile, "DIRNID", u_niddir, sizeof(u_niddir) - 1) )
        strcpy(u_niddir, ANIDDIR);

    /* ־ļ */
    if( z_getkeyv(u_pcfgfile, "DIRLOG", u_logdir, sizeof(u_logdir) - 1) )
        strcpy(u_logdir, ALOGDIR);

    snprintf(u_logfile, sizeof(u_logfile), "%s/%s%s", u_logdir, LOGPREFIX, spno);

    /* ȡò */
    r = f_para_read();

    z_logsetsz(u_logmsize);
    /* z_logsetday(1); */
    z_logsetbox(u_logloops);
    z_loglogin(u_logfile, u_logloops);

    if( r < 0 )
    {
        z_logv(u_logfile, "󣺶ȡòʧ");
        return(1);
    }

    /* ļл() */
    if( z_getkeyv(u_pcfgfile, "NID_SWITCH_CYCLE", szValue, sizeof(szValue) - 1) == 0 )
        t_nid_sw_cycle = (int) strtol(szValue, (char **)NULL, 10);

    /* UDP  */
    if( (sktfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0 )
    {
        z_logv(u_logfile, "socket() failed");
        return(1);
    }

    /* Set socket option */
    on = 1;

    if( setsockopt(sktfd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on)) < 0 )
    {
        z_logv(u_logfile, "setsockopt() failed=%.64s", strerror(errno));
        return(1);
    }

    server.sin_family      = AF_INET;
    server.sin_port        = htons(u_udpport);
    server.sin_addr.s_addr = INADDR_ANY;        /* Server's Internet Address */

    if( bind(sktfd, (struct sockaddr *)&server, sizeof(server)) < 0 )
    {
        z_logv(u_logfile, "bind() failed");
        return(1);
    }

    /*  */
    while( 1 )
    {
        if( (r = GC_detectfd(sktfd, 0, 10)) == -2 )
        {
            /* лļ */
            f_log_switch(NULL);
            continue;
        }
        else if( r < 0 )
        {
            z_logv(u_logfile, "socket error");
            return(1);
        }

        clilen = sizeof(client);
        if( recvfrom(sktfd, buf1, sizeof(buf1) - 1, 0, (struct sockaddr *)&client, &clilen) < 0 )
        {
            z_logv(u_logfile, "recvfrom() failed");
            return(1);
        }

        z_logv(u_logfile, "Port <%d>", ntohs(client.sin_port));

        /* ¼ */
        f_log_switch(buf1);
    }

    close(sktfd);
    return(0);
}

/**************************************
 ¼ݣҪʱлļ
 ڲchar *a_pMsg    
 **************************************/
int f_log_switch(char *a_pMsg)
{
    FILE *fp;

    int   iSeq, iHH, iMM;

    char  szCurDate[16], szStartDate[16], szEndDate[16];

    static char szStdFile[1024], szTmpFile[1024];

    NID_PKT    *pPkt;
    NID_NORMAL *pNIDNormal = NULL;
    NID_WARN   *pNIDWarn = NULL;

    static int iLastSeq = -1;

    /* ȡǰ */
    z_get_dt(szCurDate, 14, "f", 0);
    sscanf(szCurDate + 8, "%2d%2d", &iHH, &iMM);

    /* ǰ */
    iSeq = iHH * (60 / t_nid_sw_cycle) + iMM / t_nid_sw_cycle;

    /* лļ */
    if( iSeq != iLastSeq )
    {
        if( iLastSeq != -1 )
        {
            z_logv(u_logfile, "rename -> %.8s.%02d", szCurDate, iSeq);

            sprintf(szTmpFile, "%s/%s", u_niddir, NID_FILE_NORMAL);
            sprintf(szStdFile, "%s.%8.8s.%02d", szTmpFile, szCurDate, iSeq);
            rename(szTmpFile, szStdFile);

            sprintf(szTmpFile, "%s/%s", u_niddir, NID_FILE_WARN);
            sprintf(szStdFile, "%s.%8.8s.%02d", szTmpFile, szCurDate, iSeq);
            rename(szTmpFile, szStdFile);
        }

        iLastSeq = iSeq;
    }

    /*  */
    if( a_pMsg == NULL ) return(0);

    pPkt = (NID_PKT *)a_pMsg;

    switch( pPkt->cType )
    {
    case NID_T_NORMAL:

        sprintf(szTmpFile, "%s/%s", u_niddir, NID_FILE_NORMAL);
        pNIDNormal = (NID_NORMAL *) &(pPkt->uData.sNormal);
        break;

    case NID_T_WARN:

        sprintf(szTmpFile, "%s/%s", u_niddir, NID_FILE_WARN);
        pNIDWarn = (NID_WARN *) &(pPkt->uData.sWarn);
        break;

    default:
        return(0);
    }

    /* 򿪵ǰļ */
    if( (fp = fopen(szTmpFile, "a")) == NULL ) return(-1);

    if( pNIDWarn )
    {
        fprintf(fp, "%s+%s+%s+%s+%s+%d+%s+%s+%s+%s\n",
            szCurDate,
            pNIDWarn->szNodeId, pNIDWarn->szBelong, pNIDWarn->szProcId,
            pNIDWarn->szFileName, pNIDWarn->iWarnLevel, pNIDWarn->szWarnType,
            pNIDWarn->szWarnId, pNIDWarn->szWarnMsg, pNIDWarn->szDeviceId);
    }
    else if( pNIDNormal )
    {
        z_get_dt(szStartDate, 14, "f", pNIDNormal->tStartTv.tv_sec);
        z_get_dt(szEndDate, 14, "f", pNIDNormal->tEndTv.tv_sec);

        fprintf(fp, "%s+%s+%ld+%s+%d+%s+%d+%s+%s\n",
            pNIDNormal->szProcId, pNIDNormal->szFileName, pNIDNormal->iFileSize,
            szStartDate, (int)(pNIDNormal->tStartTv.tv_usec),
            szEndDate, (int)(pNIDNormal->tEndTv.tv_usec),
            pNIDNormal->szFileTime, pNIDNormal->szDeviceId);
    }

    fclose(fp);
    return(0);
}
