//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#include <commctrl.h>
#include <mmsystem.h>
#pragma hdrstop

#include "Main.h"
#include "MonOper.h"
#include "Filter.h"
#include "Config.h"
#include "SeqAdjust.h"
#include "ShowLog.h"
#include "Fpub.h"
#include "ListThr.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

// ش
TFrmMonOper *MonOperForms[ N_MONOPER ] = {NULL, NULL};

// ˢ߳
ListThr *g_ListThr = NULL;

static  char szTraceBuf[256];

//---------------------------------------------------------------------------
__fastcall TFrmMonOper::TFrmMonOper(TComponent* Owner) : TForm(Owner)
{
        m_last_start_no = 1;            // ʼšɼ
        m_last_show_rows = 1;
        m_start_no = 1;
        m_show_rows = 1;

        m_filter_rows = 0;              // ϹĿ
        m_total_rows = 0;               // ɼܼĿ
        m_last_select = -1;             // ϴѡITEM
        m_listing = 0;                  // Ƿˢ

        m_filter_szDesc[0] = 0;         // 
        m_filter_szNo[0] = 0;           // š
        m_filter_warn = -1;             // 澯
        m_filter_status = -1;           // ״̬

        Timer1->Interval = 1;
        HorzScrollBar->Visible = false;
        //Enabled = false;
}

//---------------------------------------------------------------------------
void __fastcall TFrmMonOper::FormShow(TObject *Sender)
{
        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        // ˢ̣߳ʱˢ¼Ϣ
        g_ListThr = new ListThr(false, this);
}

//---------------------------------------------------------------------------
// ر
void __fastcall TFrmMonOper::FormClose(TObject *Sender, TCloseAction &Action)
{
        // رմ壬'MDIChild'͵ĴС
        Action = caFree;

        // delete쳣
        // delete MonOperForms[m_win_id - 1];
        MonOperForms[m_win_id - 1] = NULL;

        // ֹͣˢ߳
        if( g_ListThr )
        {
                // ֹ̣߳ȴֹ
                g_ListThr->Terminate();
                g_ListThr->WaitFor();

                delete g_ListThr;
                g_ListThr = NULL;
        }
}

//---------------------------------------------------------------------------
// Сҳ
void __fastcall TFrmMonOper::FormResize(TObject *Sender)
{
        int b, k, rows;

        // ҳ
        rows = ListView1->VisibleRowCount;
        if( rows <= 0 ) return;

        b = m_start_no / rows;

        k = m_start_no % rows;
        if( k == 1 ) b ++;
        else if( k ) b += 2;

        EditPageNo->Text = b;
}

//---------------------------------------------------------------------------
// ʱˢ
void __fastcall TFrmMonOper::Timer1Timer(TObject *Sender)
{
        SYSTEMTIME tm;
        char t[16];

        GetLocalTime(&tm);
        GetTimeFormat(0, 0, &tm, "HH':'mm':'ss ", t, sizeof(t));

        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        Timer1->Interval = 10000;

        List();
}

//---------------------------------------------------------------------------
// ˢ
void __fastcall TFrmMonOper::BtnRefreshClick(TObject *Sender)
{
        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        List();
}

//---------------------------------------------------------------------------
// ҳ
void __fastcall TFrmMonOper::BtnFirstPageClick(TObject *Sender)
{
        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        m_start_no = 1;
        EditPageNo->Text = 1;

        List();
}

//---------------------------------------------------------------------------
// ǰһҳ
void __fastcall TFrmMonOper::BtnPrevPageClick(TObject *Sender)
{
        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        m_start_no -= m_show_rows;
        if( m_start_no < 1 ) m_start_no = 1;

        List();
}

//---------------------------------------------------------------------------
// һҳ
void __fastcall TFrmMonOper::BtnNextPageClick(TObject *Sender)
{
        int  nn;

        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        // ϴĻɼǰĻɼС
        nn = m_show_rows > m_last_show_rows ? m_last_show_rows : m_show_rows;

        sprintf(szTraceBuf, "last_start=%d, last_visible_rows=%d, current_visible_rows=%d, total=%d",
                m_last_start_no, m_last_show_rows, m_show_rows, m_total_rows);
        // ShowMessage(szTraceBuf);

        // βҳ󣬲ٹ
        nn += m_last_start_no;
        if( nn <= m_total_rows ) m_start_no = nn;

        List();
}

//---------------------------------------------------------------------------
// βҳ
void __fastcall TFrmMonOper::BtnLastPageClick(TObject *Sender)
{
        int  nTotalPages;

        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        // ҳ
        nTotalPages = m_total_rows / m_show_rows;
        if( m_total_rows % m_show_rows ) nTotalPages ++;

        m_start_no = (nTotalPages - 1) * m_show_rows + 1;

        List();
}

//---------------------------------------------------------------------------
// תָҳ
void __fastcall TFrmMonOper::EditPageNoKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
        int  nPageNo, nTotalPages;

        if( Key != VK_RETURN ) return;

        m_show_rows = ListView1->VisibleRowCount;
        if( m_show_rows <= 0 ) return;

        // תΪ
        try
        {
                nPageNo = EditPageNo->Text.ToInt();
        } catch( ... )
        {
                return;
        }

        // ҳ
        nTotalPages = m_total_rows / m_show_rows;
        if( m_total_rows % m_show_rows ) nTotalPages ++;

        if( nPageNo >= 1 && nPageNo <= nTotalPages )
                m_start_no = (nPageNo - 1) * m_show_rows + 1;

        List();
}

//---------------------------------------------------------------------------
// ؽˢ
int __fastcall TFrmMonOper::List(void)
{
        int b, k;

        TShape *pShape;

        // ҳ
        b = m_start_no / m_show_rows;

        k = m_start_no % m_show_rows;
        if( k == 1 ) b ++;
        else if( k ) b += 2;

        EditPageNo->Text = b;

        sprintf(szTraceBuf, "start_no=%d, rows=%d, total=%d",
                m_start_no, m_show_rows, m_total_rows);
        // ShowMessage(szTraceBuf);

        // Ƿˢ
        if( m_listing == 1 ) return(1);

        // ¼ǰѡеĿ
        m_last_select = ListView1->Items->IndexOf(ListView1->Selected);

        m_listing = 1;
        b = List1();
        m_listing = 0;

        char szBuf[8] = {0};
        m_skt.GetHeadN(szBuf, 3);               // 

        // л״ָ̬ʾ
        pShape = (m_win_id == 1 ? FrmMain->Shape1 : FrmMain->Shape2);

        if( b == 0 )
        {
                pShape->Brush->Color = clGreen;
                pShape->Tag = 1;
        }
        else if( b == R_DENY && szBuf[0] == E_NOTRUN )
        {
                pShape->Brush->Color = clRed;
                pShape->Tag = 2;
        }

        try
        {
                ListView1->Selected = ListView1->Items->Item[m_last_select];
        }
        catch (...)
        {
        }

        // Ҫť󣬲ԶѡϴѡеĿ
        ListView1->SetFocus();

        if( m_win_id == 1 )
                FrmMain->LblNum1->Caption = String(m_filter_rows) + "/" + m_total_rows;
        else
                FrmMain->LblNum2->Caption = String(m_filter_rows) + "/" + m_total_rows;

        return(b);
}

//---------------------------------------------------------------------------
// ʾ
void __fastcall ListShow(TFrmMonOper *pFrm, TSocket *pSkt)
{
        int   iLineSeq,                 // 
              iColSeq,                  // 
              iLineSplit,               // вֱ־
              iColSplit;                // вֱ־

        static char szLine[1024];       // 

        char  szVal[64],
              szCol[256],               // ĳһ
             *pLine,                    // ָ
             *pCol,                     // ָ
             *pReply;

        TListItem * ListItem;           // б

        // 
        pFrm->ListView1->Items->Clear();

        // ܼĿͷ5ֶ
        pSkt->GetHeadN(szVal, 5);
        pFrm->m_total_rows = (int) strtol(szVal, (char **)NULL, 10);

        pReply = pSkt->GetReply() + pSkt->GetHeadLen();

        // ϹĿ(ǰ10ֽ)
        sscanf(pReply, "%10d", &(pFrm->m_filter_rows));

        // 澯ͷ4ֶ
        if( ! g_WarnFile.IsEmpty() )
        {
                pSkt->GetHeadN(szVal, 4);
                if( szVal[0] == '1' ) PlaySound(g_WarnFile.c_str(), NULL, SND_ASYNC | SND_FILENAME);
        }

        // жȡ
        iLineSeq = pFrm->m_start_no;
        pLine = pReply + 10;

        do {
                iLineSplit = GC_get_fieldv(&pLine, szLine, NULL, sizeof(szLine) - 1, D_LINE);
                if( szLine[0] == 0 ) break;

                ListItem = pFrm->ListView1->Items->Add();
                ListItem->Caption = IntToStr(iLineSeq);

                pCol = szLine;
                iColSeq = 1;

                strcpy(szVal, "000");

                // ָ
                do {
                        iColSplit = GC_get_fieldv(&pCol, szCol, NULL, sizeof(szCol) - 1, D_COL);

                        switch( iColSeq )
                        {
                        case CS_SEQCTRL:
                                szVal[0] = szCol[0];
                                break;

                        case CS_STATUS:
                                /* ״̬ǡ */
                                if( strcmp(szCol, ST_OK) ) szVal[1] = '1';
                                break;

                        case CS_ERROR:
                                /* дϢ */
                                if( szCol[0] ) szVal[1] = '1';
                                break;
                        }

                        ListItem->SubItems->Add(szCol);
                        iColSeq ++;
                }
                while( iColSplit );

                // 
                if( (iLineSeq - pFrm->m_start_no) % 2 == 1 ) szVal[2] = '1';

                ListItem->Data = (void *)( atoi(szVal) );
                iLineSeq ++;
        }
        while( iLineSplit );
}

//---------------------------------------------------------------------------
// 󣬽ռݣʾ
int __fastcall TFrmMonOper::List1(void)
{
        char *pBody,
              szVal[64],
              szBody[512];      // 

        // 䱨ͷ
        m_skt.SetHeadN(TC_MON, 2);

        // ʼţɼ
        if( m_start_no < 1 || m_start_no > m_total_rows ) m_start_no = 1;

        // ¼ϴʼšɼ
        m_last_start_no = m_start_no;
        m_last_show_rows = m_show_rows;

//---------------------------------------------------------------------------
        // ʽTLV(Tag(1)Length(4))

        pBody = szBody;

        // ʼ
        sprintf(szVal, "%d", m_start_no);
        f_packTLV(&pBody, szVal, TAG_MONSTARTSEQ);

        // ɼ
        sprintf(szVal, "%d", m_show_rows);
        f_packTLV(&pBody, szVal, TAG_MONSHOWROWS);

        // ɼ
        f_packTLV(&pBody, m_filter_szDesc, TAG_DESCRIPTION);

        // ɼš
        f_packTLV(&pBody, m_filter_szNo, TAG_NO);

        // Ƿ澯
        sprintf(szVal, "%d", m_filter_warn);
        f_packTLV(&pBody, szVal, TAG_MONWARNNOT);

        // ״̬Ƿ
        sprintf(szVal, "%d", m_filter_status);
        f_packTLV(&pBody, szVal, TAG_MONSTATOK);

        *pBody = 0;
//---------------------------------------------------------------------------

        // 󣬲ȡӦ
        if( SktComm(m_skt, m_win_id, szBody, StatusBar1) ) return(-1);

        // ʾ
        ListShow(this, &m_skt);

        return(0);
}

//---------------------------------------------------------------------------
// ͻʾ״̬ǡд
void __fastcall TFrmMonOper::ListView1CustomDrawItem(TCustomListView *Sender,
      TListItem *Item, TCustomDrawState State, bool &DefaultDraw)
{
        char szVal[16];

        sprintf(szVal, "%03d", (int)(Item->Data));

        if( szVal[1] == '1' )
        {
                Sender->Canvas->Font->Color = clRed;
        }
        if( szVal[2] == '1' )
        {
                Sender->Canvas->Brush->Color = TColor(0x00FFFFE0);
        }

        DefaultDraw = true;
}

//---------------------------------------------------------------------------
// һɼ㣬
int __fastcall TFrmMonOper::SimpleReq1(char *code, int aRead)
{
        int   b;

        char *pNo, *pName,
             *pBody, szBody[64];

        if( ListView1->SelCount <= 0 ) return(-1);

        // ȡɼ
        // pNo = ListView1->Selected->SubItems[0][1].c_str();
        pNo = ListView1->Selected->SubItems->Strings[CS_NO - 1].c_str();

        // ȡû
        pName = ListView1->Selected->SubItems->Strings[CS_NAME - 1].c_str();

        // 䱨ͷ
        m_skt.SetHeadN(code, 2);

        pBody = szBody;

        // ɼš
        f_packTLV(&pBody, pNo, TAG_NO);

        // ûơ
        f_packTLV(&pBody, pName, TAG_BELONG);
        *pBody = 0;

        b = SktComm(m_skt, m_win_id, szBody, StatusBar1, aRead);

        switch( b )
        {
        case R_OK:
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                ErrDlg("ʧ");
                break;
        }

        // ˢ
        if( b == R_OK )
        {
                if( aRead )
                {
                        m_show_rows = ListView1->VisibleRowCount;
                        if( m_show_rows > 0 ) List();
                }
        }

        return(b);
}

//---------------------------------------------------------------------------
// ֹͣʾ
void __fastcall TFrmMonOper::N1Click(TObject *Sender)
{
        int i, b;

        TProgressBar *ProgressBar;

        N1->Enabled = false;
        ToolButton1->Enabled = false;

        if( SimpleReq1(TC_STOP, 0) != R_OK ) return;

        // ̽ӦϢʾ
        b = ReadProgress(m_skt, this, StatusBar1);

        // ˢ
        if( b == R_OK )
        {
                m_show_rows = ListView1->VisibleRowCount;
                if( m_show_rows > 0 ) List();
        }
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmMonOper::N2Click(TObject *Sender)
{
        N2->Enabled = false;
        ToolButton2->Enabled = false;

        SimpleReq1(TC_START, 1);
}

//---------------------------------------------------------------------------
// л澯
void __fastcall TFrmMonOper::N3Click(TObject *Sender)
{
        char *pCode;
        char *pWarn;

        if( ListView1->SelCount <= 0 ) return;

        // ȡ澯
        pWarn = ListView1->Selected->SubItems->Strings[CS_WARN - 1].c_str();

        if( strcmp(pWarn, "") == 0 )
                pCode = TC_WARNOFF;
        else
                pCode = TC_WARNON;

        SimpleReq1(pCode, 1);
}

//---------------------------------------------------------------------------
// ɼô
void __fastcall TFrmMonOper::N4Click(TObject *Sender)
{
        char *pNo, *pName, *pStat;

        if( ListView1->SelCount <= 0 ) return;

        // ȡɼ
        pNo = ListView1->Selected->SubItems->Strings[CS_NO - 1].c_str();

        // ȡû
        pName = ListView1->Selected->SubItems->Strings[CS_NAME - 1].c_str();

        // ȡ״̬
        pStat = ListView1->Selected->SubItems->Strings[CS_STATUS - 1].c_str();

        FrmConfig = new TFrmConfig(this);
        FrmConfig->Font = g_Font;

        FrmConfig->EditBelong->Text = pName;
        FrmConfig->EditNo->Text = pNo;
        FrmConfig->Tag = m_win_id;

        // ť
        if( strcmp(pStat, ST_STOP) != 0 )
        {
                FrmConfig->BtnStart->Enabled = false;
                //FrmConfig->BtnStart->Visible = false;
        }

        FrmConfig->ShowModal();

        delete FrmConfig;
        FrmConfig = NULL;

        ListView1->SetFocus();
}

//---------------------------------------------------------------------------
// 򿪹˴
void __fastcall TFrmMonOper::BtnFilterClick(TObject *Sender)
{
        FrmFilter = new TFrmFilter(this);
        FrmFilter->Font = g_Font;
        FrmFilter->ShowModal();

        delete FrmFilter;
        FrmFilter = NULL;

        m_start_no = 1;
        ListView1->SetFocus();
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmMonOper::N5Click(TObject *Sender)
{
        char *pNo, *pName, szVal[16], szMsg[128];

        if( ListView1->SelCount <= 0 ) return;

        // ȡɼ
        pNo = ListView1->Selected->SubItems->Strings[CS_NO - 1].c_str();

        sprintf(szVal, "%03d", (int)(ListView1->Selected->Data));

        if( szVal[0] == '0' )
        {
                sprintf(szMsg, "ɼ'%s'ſ", pNo);
                ErrDlg(szMsg);
                return;
        }

        // ȡû
        pName = ListView1->Selected->SubItems->Strings[CS_NAME - 1].c_str();

        FrmSeqAdjust = new TFrmSeqAdjust(this);
        FrmSeqAdjust->Font = g_Font;

        FrmSeqAdjust->EditNo->Text = pNo;
        FrmSeqAdjust->EditBelong->Text = pName;
        FrmSeqAdjust->m_serv_no = m_win_id - 1;

        FrmSeqAdjust->ShowModal();

        delete FrmSeqAdjust;
        FrmSeqAdjust = NULL;

        ListView1->SetFocus();
}

//---------------------------------------------------------------------------
// ־ѯ
void __fastcall TFrmMonOper::QryLog(int id)
{
        char *pNo, *pName;

        if( ListView1->SelCount <= 0 ) return;

        // ȡɼ
        pNo = ListView1->Selected->SubItems->Strings[CS_NO - 1].c_str();

        // ȡû
        pName = ListView1->Selected->SubItems->Strings[CS_NAME - 1].c_str();

        FrmShowLog = new TFrmShowLog(this);
        FrmShowLog->Font = g_Font;
        FrmShowLog->Memo1->Font = g_Font;

        FrmShowLog->EditNo->Text = pNo;
        FrmShowLog->EditBelong->Text = pName;

        FrmShowLog->Tag = id;
        FrmShowLog->m_serv_no = m_win_id - 1;
        FrmShowLog->RadioGrpType->Visible = false;
        FrmShowLog->RadioGrpType->Enabled = false;
        FrmShowLog->RadioGrpType->ItemIndex = -1;

        FrmShowLog->ShowModal();

        delete FrmShowLog;
        FrmShowLog = NULL;

        ListView1->SetFocus();
}

// ־ѯ
void __fastcall TFrmMonOper::N6Click(TObject *Sender)
{
        QryLog(1);
}

//---------------------------------------------------------------------------
// ˫־ѯ
void __fastcall TFrmMonOper::ListView1DblClick(TObject *Sender)
{
        QryLog(-1);
}

//---------------------------------------------------------------------------
// ˵
void __fastcall TFrmMonOper::PopupMenu1Popup(TObject *Sender)
{
        char *pStat, szVal[16];

        if( ListView1->SelCount <= 0 )
        {
                N1->Enabled = false;
                N2->Enabled = false;
                N3->Enabled = false;
                N4->Enabled = false;
                N5->Enabled = false;
                N6->Enabled = false;
                ToolButton1->Enabled = false;
                ToolButton2->Enabled = false;
                ToolButton3->Enabled = false;
                ToolButton4->Enabled = false;
                ToolButton5->Enabled = false;
                ToolButton6->Enabled = false;
        }
        else
        {
                ToolBar1->Enabled = true;
        
                // ŵť
                sprintf(szVal, "%03d", (int)(ListView1->Selected->Data));

                if( szVal[0] == '0' )
                {
                        ToolButton5->Enabled = false;
                        N5->Enabled = false;
                }
                else
                {
                        ToolButton5->Enabled = true;
                        N5->Enabled = true;
                }

                // ȡ״̬
                pStat = ListView1->Selected->SubItems->Strings[CS_STATUS - 1].c_str();

                // ͣť
                if( strcmp(pStat, ST_STOP) == 0 )
                {
                        N1->Enabled = false;
                        N2->Enabled = true;
                        N5->Enabled = false;
                        ToolButton1->Enabled = false;
                        ToolButton2->Enabled = true;
                        ToolButton5->Enabled = false;
                }
                else
                {
                        N1->Enabled = true;
                        N2->Enabled = false;
                        ToolButton1->Enabled = true;
                        ToolButton2->Enabled = false;
                }

                N3->Enabled = true;
                N4->Enabled = true;
                N6->Enabled = true;
                ToolButton3->Enabled = true;
                ToolButton4->Enabled = true;
                ToolButton6->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFrmMonOper::StatusBar1DrawPanel(TStatusBar *StatusBar,
      TStatusPanel *Panel, const TRect &Rect)
{
        ProgressBarRect = Rect;         // ĳߴ
}
//---------------------------------------------------------------------------

