/************
 ļ
 ************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include "z.h"

#define   MAXL_CALL     65536          /* 󳤶 */
#define   MAXL_FILE     4194304        /* ļ󳤶 */

static struct s_tagdefine              /* TAG  */
{
    int   T;                           /*  */
    int   T_begindate;                 /* ʼ */
    int   T_begintime;                 /* ʼʱ */
    int   T_endtime;                   /* ʱ */
    int   T_duration;                  /* ʱ */
} s_tags[] =
{
    {0xa0, 0x88, 0x89, 0x8a, 0x8b},
    {0xa1, 0x89, 0x8a, 0x8b, 0x8c},
    {0xa2, 0x89, 0x8a, 0x8b, 0x8c},
    {0xa3, 0x8d, 0x8e, 0x8f, 0x90},
    {0xa4, 0x8a, 0x8b, 0x8c, 0x8d},
    {0xff, 0xff, 0xff, 0xff, 0xff}      /*  */
};

static char tl_begindate[10],           /* ʼ */
            tl_begintime[10],           /* ʼʱ */
            tl_endtime[10];             /* ʱ */

static int  tl_duration;                /* ʱ */

/* ͳƷ */
int hd_analy(char *file);

/* һʱ䡢ʱ */
void hd_one(char *, int);

int Tag_Length(char **p);

int main(int argc, char **argv)
{
    if( argc != 2 ) return(0);

    return( hd_analy(argv[1]) );
}

/******************************
 ˵ͳƷ
 ڲchar *file  ļ
 ******************************/
int hd_analy(char *file)
{
    FILE  *fp;

    int    b,
           len,                          /*  */
           lenlast = 0;

    char  *p, *plast, tmstr[21];

    static char fbuf[ MAXL_FILE + 1 ];

    struct stat st;
    time_t itv;

    /* ȡļС */
    if( stat(file, &st) < 0 ) return(-1);
    else if( st.st_size > MAXL_FILE ) return(-1);

    if( (fp = fopen(file, "r")) == NULL ) return(-1);

    if( fread(fbuf, 1, st.st_size, fp) != st.st_size )
    {
        fclose(fp);
        return(-1);
    }
    fclose(fp);

    b = 0;
    plast = NULL;
    tl_duration = 0;

    memset(tl_begindate, 0, sizeof(tl_begindate));
    memset(tl_begintime, 0, sizeof(tl_begintime));
    memset(tl_endtime, 0, sizeof(tl_endtime));

    p = fbuf;
    do
    {
        /* һɣ2048000̶Сļ2K߽紦0 */
        while( *p == 0 && *(p + 1) != 0 ) p++;

        len = Tag_Length(&p);

        if( len == 0 ) continue;
        else if( len > MAXL_CALL )      /*  */
        {
            b = -1;
            break;
        }

        if( (unsigned char)*p >= 0xa0 && (unsigned char)*p <= 0xa4 )
        {
            plast = p;
            lenlast = len;
        }

        p += len;
    }
    while( p - fbuf < st.st_size );

    if( plast && lenlast )
    {
        hd_one(plast, lenlast);

        snprintf(tmstr, sizeof(tmstr), "%s%2.2s%2.2s%2.2s",
            tl_begindate, tl_begintime, tl_begintime + 3, tl_begintime + 6);

        if( z_adigit(tmstr) )
        {
            /* ݿʼʱ䡢ʱʱ */
            itv = z_next_dt(tmstr, tl_duration);

            z_get_dt(tmstr, 17, "%Y%m%d %T", itv);

            /*
             * printf("\nlbd: %s, lbt: %s, ld: %d, lst: %s\n",
             *     tl_begindate, tl_begintime, tl_duration, tl_endtime);
             */

            printf("%s", tmstr);
        }
    }

    return(b);
}

/**********************
 һʱ䡢ʱ
 **********************/
void hd_one(char *buf1, int plen)
{
    char *p;

    int   tno, len,
          f_begindate,                  /* ʼڱ־ */
          f_begintime,                  /* ʼʱ־ */
          f_endtime,                    /* ʱ־ */
          f_duration;                   /* ʱ־ */

    /*  */
    for( tno = 0; ; tno ++ )
    {
        if( s_tags[tno].T == buf1[0] ) break;
        else if( s_tags[tno].T == 0xff ) return;
    }

    /* λ */
    p = buf1;
    Tag_Length(&p);

    f_begindate = f_begintime = f_endtime = f_duration = 0;

    /* , p[0]Ϊ tag */
    do {
        /* ʼ */
        if( f_begindate == 0 && *p == s_tags[tno].T_begindate )
        {
            snprintf(tl_begindate, sizeof(tl_begindate), "20%02d%02d%02d", *(p+2), *(p+3), *(p+4));
            f_begindate = 1;
        }

        /* ʼʱ */
        else if( f_begintime == 0 && *p == s_tags[tno].T_begintime )
        {
            snprintf(tl_begintime, sizeof(tl_begintime), "%02d:%02d:%02d", *(p+2), *(p+3), *(p+4));
            f_begintime = 1;
        }

        /* ʱ */
        else if( f_endtime == 0 && *p == s_tags[tno].T_endtime )
        {
            snprintf(tl_endtime, sizeof(tl_endtime), "%02d:%02d:%02d", *(p+2), *(p+3), *(p+4));
            f_endtime = 1;
        }

        /* ʱʽ̶3 ֽڣΪʱ֡ */
        else if( f_duration == 0 && *p == s_tags[tno].T_duration )
        {
            tl_duration= *(p+2) * 3600 + *(p+3) * 60 + *(p+4);
            f_duration = 1;
        }

        /* ҵд */
        if( f_begindate && f_endtime && f_begintime && f_duration ) return;

        len = Tag_Length(&p);
        p += len;
    } while( p - buf1 < plen );

    return;
}

/*
 * . ʶ(b8,b7)
 *   00    Universal
 *   01    Application
 *   10    Context-specific
 *   11    Private

 * . ʶP/Cλ(b6)
 *   0     Primitive, ԭ
 *   1     Constructed, ϣڲԪ(Primitive)

 * . עΪûзb6
 */
int Tag_Length(char **p)
{
    int i, n, c, len = 0;

    c = *((*p)++);                      /* Tag */

    if( (c & 0x1F) == 0x1F )            /* ֽTag */
    {
        do {
            c = *((*p)++);
        } while( (c & 0x80) );
    }
/* ========= end of Tag ========= */

    c = *((*p)++);
    switch( (c & 0x80) )
    {
    case 0:                             /* ֽLength */
        len = c;
        break;

    case 0x80:
        n = (c & 0x7F);                 /* n ֽLength, n=0 ʾȷ */

        for( i = 0, len = 0; i < n; i++ )
        {
            c = *((*p)++);
            len += (c << (8 * (n - i - 1)));
        }
        break;
    }
/* ======== end of Length ======== */

    return(len);
}
