

#ifndef __SPICE_CLIENT_PORT_CHANNEL_H__
#define __SPICE_CLIENT_PORT_CHANNEL_H__

#if !defined(__SPICE_CLIENT_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client.h> can be included directly"
#endif

#include <gio/gio.h>
#include "spice-channel.h"

G_BEGIN_DECLS

#define SPICE_TYPE_PORT_CHANNEL            (spice_port_channel_get_type())
#define SPICE_PORT_CHANNEL(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), SPICE_TYPE_PORT_CHANNEL, SpicePortChannel))
#define SPICE_PORT_CHANNEL_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), SPICE_TYPE_PORT_CHANNEL, SpicePortChannelClass))
#define SPICE_IS_PORT_CHANNEL(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), SPICE_TYPE_PORT_CHANNEL))
#define SPICE_IS_PORT_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), SPICE_TYPE_PORT_CHANNEL))
#define SPICE_PORT_CHANNEL_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), SPICE_TYPE_PORT_CHANNEL, SpicePortChannelClass))

typedef struct _SpicePortChannel SpicePortChannel;
typedef struct _SpicePortChannelClass SpicePortChannelClass;
typedef struct _SpicePortChannelPrivate SpicePortChannelPrivate;


struct _SpicePortChannel {
    SpiceChannel parent;

    
    SpicePortChannelPrivate *priv;
    
};


struct _SpicePortChannelClass {
    SpiceChannelClass parent_class;

    
    
};

GType spice_port_channel_get_type(void);

void spice_port_channel_write_async(SpicePortChannel *port,
                                    const void *buffer, gsize count,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);
gssize spice_port_channel_write_finish(SpicePortChannel *port,
                                       GAsyncResult *result, GError **error);
void spice_port_channel_event(SpicePortChannel *port, guint8 event);


#ifndef SPICE_DISABLE_DEPRECATED
G_DEPRECATED_FOR(spice_port_channel_write_async)
void spice_port_write_async(SpicePortChannel *port,
                            const void *buffer, gsize count,
                            GCancellable *cancellable,
                            GAsyncReadyCallback callback,
                            gpointer user_data);
G_DEPRECATED_FOR(spice_port_channel_write_finish)
gssize spice_port_write_finish(SpicePortChannel *port,
                               GAsyncResult *result, GError **error);
G_DEPRECATED_FOR(spice_port_channel_event)
void spice_port_event(SpicePortChannel *port, guint8 event);
#endif

G_END_DECLS

#endif 

