

#ifndef __SPICE_CLIENT_USBREDIR_CHANNEL_PRIV_H__
#define __SPICE_CLIENT_USBREDIR_CHANNEL_PRIV_H__

#include <libusb.h>
#include <usbredirfilter.h>
#include "spice-client.h"

G_BEGIN_DECLS


void spice_usbredir_channel_set_context(SpiceUsbredirChannel *channel,
                                        libusb_context       *context);

void spice_usbredir_channel_disconnect_device_async(SpiceUsbredirChannel *channel,
                                                    GCancellable *cancellable,
                                                    GAsyncReadyCallback callback,
                                                    gpointer user_data);

gboolean spice_usbredir_channel_disconnect_device_finish(SpiceUsbredirChannel *channel,
                                                         GAsyncResult         *res,
                                                         GError              **err);


void spice_usbredir_channel_connect_device_async(
                                        SpiceUsbredirChannel *channel,
                                        libusb_device        *device,
                                        SpiceUsbDevice       *spice_device,
                                        GCancellable         *cancellable,
                                        GAsyncReadyCallback   callback,
                                        gpointer              user_data);
gboolean spice_usbredir_channel_connect_device_finish(
                                        SpiceUsbredirChannel *channel,
                                        GAsyncResult         *res,
                                        GError              **err);

void spice_usbredir_channel_disconnect_device(SpiceUsbredirChannel *channel);

libusb_device *spice_usbredir_channel_get_device(SpiceUsbredirChannel *channel);

void spice_usbredir_channel_lock(SpiceUsbredirChannel *channel);

void spice_usbredir_channel_unlock(SpiceUsbredirChannel *channel);

void spice_usbredir_channel_get_guest_filter(
                          SpiceUsbredirChannel               *channel,
                          const struct usbredirfilter_rule  **rules_ret,
                          int                                *rules_count_ret);

G_END_DECLS

#endif 

