/***********************************************************************
*
* ļ DataManager.cpp
* ģĿģʵƽ̨޹عڴ
* ߼ڣ  wang_jin 2008-05-18
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ 
*
***********************************************************************/

#include "DataManager.h"
#include "MemoryManager.h"

#include "Common/Common.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"

#include <stdio.h> // for sprintf

#ifdef WIN32
#	include "MemoryManager_Win32.cpp"
#else
#	include "MemoryManager_Linux.cpp"
#endif


CSharedDataManager::CSharedDataManager()
{
	m_pSMData = NULL;
}

CSharedDataManager::~CSharedDataManager()
{
}

// 빲ڴ
long CSharedDataManager::CreateMemory( long nKey, long nTotalSize, long nSize )
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:CreateMemory(%x,%d,%d)", nKey, nTotalSize,nSize);
	
	m_nKey = nKey;
	m_bOwner = false;
	
	long nRet = m_smMgr.CreateMemory( nKey, nTotalSize, &m_bOwner );
	
	if ( NO_ERROR == nRet )
	{
		// ؽṹַָָ
		m_pSMData = m_smMgr.GetBaseAddress();
		if ( nSize )
		{
			// ̬ڴ - ҪԤݿ
			ITEMINFO* pItemInfo = NULL;
			
			// ָָӦϢֱӵַ
			m_pHeadInfo = (ITEMHEAD*) GetRealAddress( m_pSMData->nOffset );
			if ( m_bOwner ) // ֻҪʱųʼڴ
			{
				m_pHeadInfo->rootItem = ( m_pSMData->nOffset + sizeof(ITEMHEAD) ); // ¼Եַ
				m_pHeadInfo->lastFreeItem = 0;
				for ( int nItemInfo = m_pSMData->nOffset + sizeof(ITEMHEAD) + nSize; nItemInfo < (m_pSMData->nSize - nSize); nItemInfo += nSize )
				{
					pItemInfo = (ITEMINFO*) GetRealAddress( nItemInfo );
					pItemInfo->nPrevFreeItem = m_pHeadInfo->lastFreeItem;
					pItemInfo->nNextFreeItem = 0;
					
					if ( m_pHeadInfo->lastFreeItem )
					{
						ITEMINFO* pLastFreeItem = (ITEMINFO*) GetRealAddress( m_pHeadInfo->lastFreeItem );
						pLastFreeItem->nNextFreeItem = nItemInfo;
					}
					m_pHeadInfo->lastFreeItem = nItemInfo;
				}
			}
			else // for DEBUG
			{
				// ǰΪߣжЧ
				trace.GDTrace( LOG_DBG, "SMBase=[%x]HeadInfo=[%d]RootItem=[%x]", m_pSMData, m_pSMData->nOffset, GetRoot() );
			}
		}
		else
		{
			// ڴ
			// ָָӦϢֱӵַ
			m_pBlock = (INFOBLOCK*) GetRealAddress( m_pSMData->nOffset );
			if ( m_bOwner ) // ֻҪʱųʼڴ
			{
				m_pBlock->nFillFull = 0;
				m_pBlock->nMaxSize = m_pSMData->nSize - sizeof(INFOBLOCK);
				m_pBlock->nReadHead = 
				m_pBlock->nReadTail = 
				m_pBlock->nWriteHead = 
				m_pBlock->nWriteTail = 0;
			}
		}

	}
	
	return trace.SetRetValue( nRet );
} 

// 빲ڴ
long CSharedDataManager::CreateMemory( const char* sKey, long nTotalSize, long nSize )
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:CreateMemory(%s,%d,%d)", sKey, nTotalSize,nSize);
	
	strcpy(m_sKey,sKey);
	m_bOwner = false;
	
	long nRet = m_smMgr.CreateMemory( sKey, nTotalSize, &m_bOwner );
	
	if ( NO_ERROR == nRet )
	{
		// ؽṹַָָ
		m_pSMData = m_smMgr.GetBaseAddress();
		if ( nSize )
		{
			// ̬ڴ - ҪԤݿ
			ITEMINFO* pItemInfo = NULL;
			
			// ָָӦϢֱӵַ
			m_pHeadInfo = (ITEMHEAD*) GetRealAddress( m_pSMData->nOffset );
			if ( m_bOwner ) // ֻҪʱųʼڴ
			{
				m_pHeadInfo->rootItem = ( m_pSMData->nOffset + sizeof(ITEMHEAD) ); // ¼Եַ
				m_pHeadInfo->lastFreeItem = NULL;
				for ( int nItemInfo = m_pSMData->nOffset + sizeof(ITEMHEAD) + nSize; nItemInfo < (m_pSMData->nSize - nSize); nItemInfo += nSize )
				{
					pItemInfo = (ITEMINFO*) GetRealAddress( nItemInfo );
					pItemInfo->nPrevFreeItem = m_pHeadInfo->lastFreeItem;
					pItemInfo->nNextFreeItem = 0;
					
					if ( m_pHeadInfo->lastFreeItem )
					{
						ITEMINFO* pLastFreeItem = (ITEMINFO*) GetRealAddress( m_pHeadInfo->lastFreeItem );
						pLastFreeItem->nNextFreeItem = nItemInfo;
					}
					m_pHeadInfo->lastFreeItem = nItemInfo;
				}
			}
			else // for DEBUG
			{
				// ǰΪߣжЧ
				trace.GDTrace( LOG_DBG, "SMBase=[%x]HeadInfo=[%d]RootItem=[%x]", m_pSMData, m_pSMData->nOffset, GetRoot() );
			}
		}
		else
		{
			// ڴ
			// ָָӦϢֱӵַ
			m_pBlock = (INFOBLOCK*) GetRealAddress( m_pSMData->nOffset );
			if ( m_bOwner ) // ֻҪʱųʼڴ
			{
				m_pBlock->nFillFull = 0;
				m_pBlock->nMaxSize = m_pSMData->nSize - sizeof(INFOBLOCK);
				m_pBlock->nReadHead = 
					m_pBlock->nReadTail = 
					m_pBlock->nWriteHead = 
					m_pBlock->nWriteTail = 0;
			}
		}
		
	}
	
	return trace.SetRetValue( nRet );
} 

// ͷŹڴ
long CSharedDataManager::ReleaseMemory()
{
	// CGDTrace trace( LOG_L6, "CSharedDataManager:ReleaseMemory(%x)", this->m_nKey );
	long bRet = m_smMgr.ReleaseMemory();
	return bRet;	//trace.SetRetValue( bRet );
}

// 
long CSharedDataManager::SetData( void* pBuf, long nSize )
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:SetData([void*],%d)", nSize );
	
	if ( NULL == m_pSMData )
	{
		// ڴЧ
		return trace.SetRetValue( -1001 );
	}
	
	if ( m_pSMData->nSize < nSize )
	{
		// ռ䲻㣬
		long nRet = 0;
		nRet = m_smMgr.ReleaseMemory();
		nRet = m_smMgr.CreateMemory( nSize );
		if ( nRet )
		{
			return trace.SetRetValue( nRet );
		}
		m_pSMData = m_smMgr.GetBaseAddress();
	}
	
	memcpy( GetRealAddress( m_pSMData->nOffset ), pBuf, nSize );
	
	return trace.SetRetValue( NO_ERROR );
}

// ȡ
long CSharedDataManager::GetData( void* pBuf, long& nSize )
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:GetData([void*],%d)", nSize );
	
	if ( NULL == m_pSMData )
	{
		// ڴЧ 
		return trace.SetRetValue( -1 );
	}
	
	if ( NULL == pBuf || 0 == nSize )
	{
		// ̽С
		nSize = m_pSMData->nSize;
		return trace.SetRetValue( -2 );
	}
	
	memcpy( pBuf, GetRealAddress( m_pSMData->nOffset ), nSize );
	
	if ( nSize < m_pSMData->nSize )
	{
		// ռ䲻
		return trace.SetRetValue( m_pSMData->nSize );
	}
	
	return trace.SetRetValue( NO_ERROR );
}

//Ϣ
long CSharedDataManager::PutBlock( void* pMsg, int nSize )
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:PutBlock([void*],%d)", nSize );
	
	if ( NULL == m_pSMData )
	{
		CGDLog::WriteErrLog( "1102:CSharedDataManager:PutBlock() NULL == m_pSMData " );
		return trace.SetRetValue( -1002 );
	}
	
	// жǷд--㹻ռ
	if ( m_pBlock->nFillFull ) // дת
	{
		if ( m_pBlock->nWriteHead + sizeof(int) + nSize > m_pBlock->nWriteTail )
		{
			CGDLog::WriteErrLog( "1103:CSharedDataManager:PutBlock()[if] return MSG_MEM_NOSPACE" );
			return trace.SetRetValue( MSG_MEM_NOSPACE );
		}
	}
	else
	{
		if ( m_pBlock->nWriteHead + sizeof(int) + nSize > m_pBlock->nWriteTail + m_pBlock->nMaxSize ) //D
		{
			CGDLog::WriteErrLog( "1104:CSharedDataManager:PutBlock()[else] return MSG_MEM_NOSPACE" );
			return trace.SetRetValue( MSG_MEM_NOSPACE );
		}
	} 
	void* pStart = NULL;
	void* pBase = (void*) ( (char*)m_pBlock + sizeof(INFOBLOCK) );
	// ִд
	if ( m_pBlock->nWriteHead + sizeof(int) + nSize <= m_pBlock->nMaxSize ) //D
	{
		// ֱд
		pStart = (void*)( (char*)pBase + m_pBlock->nWriteHead );
		memcpy( pStart, &nSize, sizeof(int) );
		m_pBlock->nWriteHead += sizeof(int);
		pStart = (void*)( (char*)pBase + m_pBlock->nWriteHead );
		memcpy( pStart, pMsg, nSize );
		m_pBlock->nWriteHead += nSize;
		if( m_pBlock->nWriteHead == m_pBlock->nMaxSize )
		{
			m_pBlock->nWriteHead = 0;
			m_pBlock->nFillFull = 1;
		}
	}
	else
	{
		// ֶд
		int nFirst = m_pBlock->nMaxSize - m_pBlock->nWriteHead;
		if( nFirst >= 4 )
		{
			// ֱд
			pStart = (void*)( (char*)pBase + m_pBlock->nWriteHead );
			memcpy( pStart, &nSize, sizeof(int) );
			pStart = (char*)pStart + sizeof(int);
			if( nFirst > 4 )
			{
				memcpy( pStart, pMsg, nFirst - 4 );
			}
			pStart = pBase;
			memcpy( pStart, (char*)pMsg + nFirst - 4, nSize - nFirst + 4 );
			pStart = (char*)pStart + nSize - nFirst + 4;
		}
		else
		{
			// ȷֶд
			pStart = (void*)( (char*)pBase + m_pBlock->nWriteHead );
			memcpy( pStart, &nSize, nFirst );
			pStart = pBase;
			memcpy( pStart, &nSize + nFirst, 4 - nFirst );
			pStart = (char*)pStart + 4 - nFirst;
			memcpy( pStart, pMsg, nSize );
			pStart = (char*)pStart + nSize;
		}
		// λϢдڴ
		m_pBlock->nWriteHead += sizeof(int) + nSize;
		m_pBlock->nWriteHead %= m_pBlock->nMaxSize;
		m_pBlock->nFillFull = 1;
	}

	return trace.SetRetValue( NO_ERROR );
}

// ȡϢ
long CSharedDataManager::GetBlock( void* pMsg, int& nSize )
{
	if ( NULL == m_pSMData )
	{
		CGDLog::WriteErrLog( "1105:CSharedDataManager:GetBlock() [NULL == m_pSMData]" );
		return  -1;
	}
	
	int nMsgLen = 0;
	
	// жǷɶ--
	static bool bNoMsg = false;
	if ( ( m_pBlock->nReadHead == m_pBlock->nReadTail ) && 0 == m_pBlock->nFillFull )
	{
		if ( bNoMsg ) // ϢϢ״̬ʱż¼һϢ
		{
			CGDLog::WriteErrLog( "1106:CSharedDataManager:GetBlock() return MSG_MEM_NOMSG" );
			bNoMsg = true;
		}
		return MSG_MEM_NOMSG;
	}

	bNoMsg = false;
	CGDTrace trace( LOG_L6, "CSharedDataManager:GetBlock([void*],%d)", nSize );
		
	void* pStart = NULL;
	void* pBase = (void*) ( (char*)m_pBlock + sizeof(INFOBLOCK) );
	// ȡϢ
	if ( m_pBlock->nReadHead + sizeof(int) <= m_pBlock->nMaxSize ) //D
	{
		// ֱӶȡ
		pStart = (void*)( (char*)pBase + m_pBlock->nReadHead );
		memcpy( &nMsgLen, pStart, sizeof(int) );
		m_pBlock->nReadHead += sizeof(int);
		if( m_pBlock->nReadHead == m_pBlock->nMaxSize )
		{
			m_pBlock->nReadHead = 0;
			m_pBlock->nFillFull = 0;
		}
	}
	else
	{
		// ֶζȡ
		int nFirst = m_pBlock->nMaxSize - m_pBlock->nReadHead;
		pStart = (void*)( (char*)pBase + m_pBlock->nReadHead );
		memcpy( &nMsgLen, pStart, nFirst);
		pStart = (char*)pBase;
		memcpy( &nMsgLen + nFirst, pStart, sizeof(int) - nFirst);
		pStart = (char*)pStart + sizeof(int) - nFirst;
		m_pBlock->nReadHead += sizeof(int);
		m_pBlock->nReadHead %= m_pBlock->nMaxSize;
		m_pBlock->nFillFull = 0;
	}
	
	assert( nMsgLen > 0 );
	if ( nMsgLen > nSize )
	{
		CGDLog::WriteErrLog( "1107:CSharedDataManager:GetBlock() return MSG_QUE_UNKNOWN_ERROR" );
		// Ϣ洢ռ䲻
		return trace.SetRetValue( MSG_QUE_UNKNOWN_ERROR );
	}
	
	// ȡϢ
	if ( m_pBlock->nReadHead + nMsgLen <= m_pBlock->nMaxSize ) //D
	{
		// ֱӶȡϢ
		pStart = (void*)( (char*)pBase + m_pBlock->nReadHead );
		memcpy( pMsg, pStart, nMsgLen );
		m_pBlock->nReadHead += nMsgLen;
		if( m_pBlock->nReadHead == m_pBlock->nMaxSize )
		{
			m_pBlock->nReadHead = 0;
            m_pBlock->nFillFull = 0;
		}
	}
	else
	{
		// ֶζȡϢ
		int nFirst = m_pBlock->nMaxSize - m_pBlock->nReadHead;
		pStart = (void*)( (char*)pBase + m_pBlock->nReadHead );
		memcpy( pMsg, pStart, nFirst );
		pStart = (char*)pBase;
		memcpy( (char*)pMsg + nFirst, pStart, nMsgLen - nFirst );
		pStart = (char*)pStart + nMsgLen - nFirst;
		
		// λϢдڴ
		m_pBlock->nReadHead += nMsgLen;
		m_pBlock->nReadHead %= m_pBlock->nMaxSize;
		m_pBlock->nFillFull = 0;
	}
	
	return trace.SetRetValue( NO_ERROR );
}


void* CSharedDataManager::GetRoot()
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:GetRoot()" );
	return GetRealAddress( m_pHeadInfo->rootItem ); // ֱӵַ
}

void* CSharedDataManager::New()							// ̬
{
	//CGDTrace trace( LOG_L6, "CSharedDataManager:New()" );
	ITEMINFO* pLastFreeItem = NULL;
	if ( m_pHeadInfo->lastFreeItem )
	{
		pLastFreeItem = (ITEMINFO*) GetRealAddress( m_pHeadInfo->lastFreeItem );
		if ( pLastFreeItem->nPrevFreeItem )
		{
			ITEMINFO* pPrevFreeItem = (ITEMINFO*) GetRealAddress( pLastFreeItem->nPrevFreeItem );
			pPrevFreeItem->nNextFreeItem = NULL;
			m_pHeadInfo->lastFreeItem = pLastFreeItem->nPrevFreeItem;
		}
		else
		{
			m_pHeadInfo->lastFreeItem = NULL;
		}
	}
	
	return pLastFreeItem; // ֱӵַ
}

void CSharedDataManager::Delete( void* pBuf )			// ̬ͷ ֱӵַ
{
	CGDTrace trace( LOG_L6, "CSharedDataManager:Delete()" );

	ITEMINFO* pItemInfo = (ITEMINFO*)pBuf;
	pItemInfo->nPrevFreeItem = m_pHeadInfo->lastFreeItem; // ¼Եַ
	pItemInfo->nNextFreeItem = NULL;
	
	if ( m_pHeadInfo->lastFreeItem )
	{
		ITEMINFO* pTemp = (ITEMINFO*) GetRealAddress( m_pHeadInfo->lastFreeItem );
		pTemp->nNextFreeItem = GetOffset( pItemInfo ); // ¼Եַ
	}
	m_pHeadInfo->lastFreeItem = GetOffset( pItemInfo ); // ¼Եַ
}


