// FileTran_impl.cpp
#pragma warning(disable:4251)

#include "Base/App.h"
#include "GDLog/ThreadData.h"
#include <STAR/CORBA.h>

#include "Common/ExceptionError.h"
#include "Base/MonitorDef.h"
#include "Common/GDString.h"
#include "Base/FileOptEx.h"
#include "Base/RunInfor.h"
#include "FileOpt/FileOpt.h"
#include "FileTran/FileTran_impl.h"
#include "GDLog/GDTrace.h"
#include "Common/Common.h"
#include "Common/GDFile.h"

using namespace InforGuard;


void FileTran_impl::Check() throw(InforGuard::ExceptionError)
{
	return; // ʲôҲҪ˿պڼ·
}

CORBA::Long FileTran_impl::GetFileBlock(InforGuard::netCallData& callData,
										const char* filename,
										CORBA::LongLong off,
										InforGuard::OctetSeq_out out,
										CORBA::Long& len)
										throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "fileserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sTmpFileName = filename;
	CGDString::MakeSureLocalPath(sTmpFileName);

	// ļ
	FILE * fp = CGDFile::open( sTmpFileName.c_str(), "rb" );
	if ( fp )
	{
		// liu_yfeng Ϊִ֧ļΪfsetpos
		if ( off > 0 )
		{
			fsetpos( fp, (const fpos_t*)&off );
		}

		out = new OctetSeq;
		out->length( len );
		len = fread( out->get_buffer(), 1, len, fp ); 

		CGDFile::close( fp );

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	else
	{
		// ļʧ
		ErrCode errCode = GetLastError();
		// ׳쳣
		InforGuard::ExceptionError e;
		e.nErrCode = errCode;
		char sBuf[512] = {0};
		if ( errCode == 5 )
		{
			sprintf( sBuf, "FileTran_impl:GetFileBlock(). CGDFile:open(%s)ʧ[%d][%s][ܾ]", 
				sTmpFileName.c_str(), e.nErrCode, GetErrText(e.nErrCode) );
		}
		else
		{
			sprintf( sBuf, "FileTran_impl:GetFileBlock(). CGDFile:open(%s)ʧ[%d][%s]", 
				sTmpFileName.c_str(), e.nErrCode, GetErrText(e.nErrCode) );
		}
		e.vErrText.length(1);
		e.vErrText[0] = CORBA::string_dup(sBuf);
		e._raise();
	}

	return 0;
}


CORBA::Long FileTran_impl::PutFileBlock(InforGuard::netCallData& callData,
										const char* filename,
										CORBA::LongLong off,			
										const InforGuard::OctetSeq& buf,
										CORBA::Long& len)
										throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "fileserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sTmpFileName = filename;
	CGDString::MakeSureLocalPath(sTmpFileName);

	// ļд
	FILE * fp = NULL;

	if ( off == 0 )
	{
		fp = CGDFile::open( sTmpFileName.c_str(), "wb" );
	}
	else
	{
		fp = CGDFile::open( sTmpFileName.c_str(), "ab" );
	}

	if ( fp )
	{
		// liu_yfeng Ϊִ֧ļΪfsetpos
		if ( off )
		{
#ifdef WIN32
			fsetpos( fp, (const fpos_t*)&off );
#elif defined AIX
			fsetpos( fp, (const fpos_t*)&off );
#elif defined SunOS
			fsetpos( fp, (const fpos_t*)&off );
#elif defined HPUX
			fsetpos( fp, (const fpos_t*)&off );
#elif defined HPUXIA
			fsetpos( fp, (const fpos_t*)&off );
#else
			fpos_t nOffset = {0};
			nOffset.__pos = off;
			fsetpos( fp, &nOffset );
#endif
		}

		if ( len > 0 )
		{
			long realen = 0;
			realen = fwrite( buf.get_buffer(), 1, len, fp );
			if (realen != len)
			{
				// дļʧ
				CGDFile::close( fp );
				CExceptionError ex;
				ex.m_nErrCode = GetLastError();
				ex.AddErrText("%s",GetErrText(ex.m_nErrCode));              //wu_binǰ̨Ϣ

				ex.AddErrText( "дʧ[%s][%d][%s]", sTmpFileName.c_str(), ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
				ex.AddErrText( "FileTran_impl::PutFileBlock(%s)", sTmpFileName.c_str() );
				// ׳쳣
				InforGuard::ExceptionError e;
				CNetTran::ConvertException( ex, e );
				e._raise();
			}
		}
		
		CGDFile::close( fp );

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	else
	{
		// дļʧ
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText("%s",GetErrText(ex.m_nErrCode));              //wu_binǰ̨Ϣ

		ex.AddErrText( "дļʧ[%s][%d][%s]", sTmpFileName.c_str(), ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
		ex.AddErrText( "FileTran_impl::PutFileBlock(%s)", sTmpFileName.c_str() );
		// ׳쳣
		InforGuard::ExceptionError e;
		CNetTran::ConvertException( ex, e );
		e._raise();
	}

	return 0;
}

#ifdef WIN32
#	include <imagehlp.h>
#	pragma comment(lib,"imagehlp")
#endif

CORBA::Long FileTran_impl::MakeDirectory(InforGuard::netCallData& callData,
										 const char* sFileName,
										 CORBA::Boolean bTmp )
										 throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "fileserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sParam;
	sParam = sParam
		+ "sFileName[" + sFileName
		+ "]bTmp[" + ( bTmp?"1":"0" )
		+ "]";

	CGDTrace trace( LOG_L6, "FileTran_impl:MakeDirectory(%s)", sParam.c_str() );

	string sTmpFileName = sFileName;

	try
	{
#ifndef WIN32
		// жǷ
		int nSplit = sTmpFileName.find_first_of('|');
		if ( nSplit > 0 )
		{
			string sCmd = "ln -s ";
			sCmd += sTmpFileName.substr(0, nSplit);
			sCmd += " ";
			sCmd += sTmpFileName.substr(nSplit + 1);
			trace.GDTrace( LOG_NOT, "create link[%s]", sCmd.c_str() );
			system( sCmd.c_str() );
			return 0;
		}
#endif
		CGDString::MakeSureLocalPath(sTmpFileName);
		if ( bTmp ) // ʱĿ¼
		{
			CFileOpt::MakeSureDirExist( sTmpFileName.c_str() );
		}
		else // Ŀ¼
		{
			// ļ
			CFileOptEx::MakeSureDirExistLegally( sTmpFileName.c_str() );
		}

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "FileTran_impl:MakeDirectory(%s)", sParam.c_str() );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	return 0;
}

CORBA::Long FileTran_impl::MoveFileIn(InforGuard::netCallData& callData,
									  const char* srcfile,
									  const char* dstfile,
									  const char* delfile,
									  CORBA::Boolean bTopPath)
									  throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "fileserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sParam;
	sParam = sParam
		+ "srcfile[" + srcfile
		+ "]dstfile[" + dstfile
		+ "]delfile[" + delfile
		+ "]bTopPath[" + ( bTopPath?"1":"0" )
		+ "]";
	
	CGDTrace trace( LOG_L6, "FileTran_impl:MoveFileIn(%s)", sParam.c_str() );

	int nRet = -1;
	string sTmpSrcFile = srcfile;
	string sTmpDstFile = dstfile;
	string sTmpDelFile = delfile;

	CGDString::MakeSureLocalPath(sTmpSrcFile);
	CGDString::MakeSureLocalPath(sTmpDstFile);
	CGDString::MakeSureLocalPath(sTmpDelFile);

	char tmpDelDir[GD_MAX_PATH] = {0};
	CFileOpt::GetParentDir(delfile, tmpDelDir);
	CFileOpt::MakeSureDirExist(tmpDelDir);

	bool bMonitor = CAppConfig::Instance().IsFileMonitoring(dstfile);

	try
	{
#if 0 // Ż at 2010-01-05 by wang_jin ʱŻ at 2008-11-27 by wang_jin at 2008-11-21 ŻWindowsƽ̨ļ

#	if defined WIN32 || defined INOTIFY_SUPPORT// ضĿ¼ֱ
        if( bTopPath )
        {
            nRet = CFileOptEx::MoveAllIntoWorkspace( bMonitor, sTmpSrcFile.c_str(), sTmpDstFile.c_str(), sTmpDelFile.c_str() );
        }
        else
        {
            nRet = CFileOptEx::MoveFileInLegally( bMonitor, sTmpSrcFile.c_str(), sTmpDstFile.c_str(), sTmpDelFile.c_str() );
        }
#	else // ضĿ¼ֱ
		nRet = CFileOptEx::MoveFileInLegally( bMonitor, sTmpSrcFile.c_str(), sTmpDstFile.c_str(), sTmpDelFile.c_str() );
#	endif

#else

		CFileOptEx::MoveFileIntoWorkspace( bTopPath, sTmpSrcFile.c_str(), sTmpDstFile.c_str(), sTmpDelFile.c_str() );
		nRet = 0;

#endif
		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "FileTran_impl:MoveFileIn(%s)", sParam.c_str() );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	return trace.SetRetValue( nRet );
}

CORBA::Long FileTran_impl::MoveFileOut(InforGuard::netCallData& callData,
									   const char* srcfile,
									   const char* dstfile)
									   throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "fileserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sParam;
	sParam = sParam
		+ "srcfile[" + srcfile
		+ "]dstfile[" + dstfile
		+ "]";
	
	CGDTrace trace( LOG_L6, "FileTran_impl:MoveFileOut(%s)", sParam.c_str() );
	
	int nRet = 0;
	string sTmpSrcFile = srcfile;
	string sTmpDstFile = dstfile;

	CGDString::MakeSureLocalPath(sTmpSrcFile);
	CGDString::MakeSureLocalPath(sTmpDstFile);

	try
	{
		nRet = CFileOptEx::MoveFileOutLegally( sTmpSrcFile.c_str(), sTmpDstFile.c_str() );
		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "FileTran_impl:MoveFileOut(%s)", sParam.c_str() );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	
	return nRet;
}

CORBA::Long FileTran_impl::RenameFile(InforGuard::netCallData& callData,
									  const char* oldfile,
									  const char* newfile, 
									  CORBA::Long attr)
									  throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "fileserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sParam;
	sParam = sParam 
		+ "oldfile[" + oldfile
		+ "]newfile[" + newfile
		+ "]attr[" + CGDString::ltoa( attr )
		+ "]";
	
	CGDTrace trace( LOG_L6, "FileTran_impl:RenameFile(%s)", sParam.c_str() );

	int nRet = 0;
	string sTmpOldFile = oldfile;
	string sTmpNewFile = newfile;

	CGDString::MakeSureLocalPath(sTmpOldFile);
	CGDString::MakeSureLocalPath(sTmpNewFile);

	try
	{
		nRet = CFileOptEx::RenameLegally( 
			sTmpOldFile.c_str(), 
			sTmpNewFile.c_str(), 
			attr );

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "FileTran_impl:RenameFile(%s)", sParam.c_str() );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	return nRet;
}

CORBA::Long FileTran_impl::QueryBasePath(CORBA::String_out basepath) throw(InforGuard::ExceptionError)
{
    CGDTrace trace( LOG_L6, "FileTran_impl:QueryBasePath()" );

    basepath = CORBA::string_dup("");

    int nRet = 0;
  
    try
    {
        const char* curPath = GetInforGuardPath();
		if( curPath && (strlen(curPath) > 0) )
		{
			basepath = CORBA::string_dup(curPath);
			trace.SetOutParam( curPath );
		}
    }
    catch ( CExceptionError & ex )
    {
        ex.AddErrText( "FileTran_impl:QueryBasePath" );
        // ת쳣ʽ
        InforGuard::ExceptionError e;
        CNetTran::ConvertException(ex, e);
        e._raise();
    }

    return nRet;
}


CORBA::Long FileTran_impl::isFileExist(const char* filePath, 
									   CORBA::Long &fileSize) 
									   throw(InforGuard::ExceptionError)
{
    CGDTrace trace( LOG_L6, "FileTran_impl:isFileExist()" );
	CORBA::Long nRet = 9999;//ĬϷһֵ
	bool bExist = false;
			
	try
	{
		bExist = CFileOpt::IsExist(filePath);
		if (bExist == true)
		{//ļڵĻѷֵת㣬ʾļڣļС
			nRet = 0;
	    	fileSize = CFileOpt::GetFileSize(filePath);
		}
		else nRet = 1; //ļڷ1ûпļûжȨ޵
	}
	catch ( CExceptionError & ex )
    {
        ex.AddErrText( "FileTran_impl:isFileExist" );
        // ת쳣ʽ
        InforGuard::ExceptionError e;
        CNetTran::ConvertException(ex, e);
        e._raise();
    }

    return nRet;
}
