/******************************************************************************
*
* ļ              FileTree_UNIX.cpp
* ģĿģ      ļĿ¼ƽ̨ʵ
* ߼ڣ        liu_yfeng 2008-06-01
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            wang_jin 2008-07-18
*
******************************************************************************/

#include "FileOpt/FileTree.h"
#include "FileOpt/FileTreeImpl.h"
#include "GDLog/GDLog.h"

#include <string.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <assert.h>


CFileTreeImpl::CFileTreeImpl( const string& path ) : _path( path )
{
}


CFileTreeImpl::~CFileTreeImpl()
{
}


bool CFileTreeImpl::isExistImpl()
{
	// ֯Ŀ¼
	char szNodePath[ GD_MAX_PATH ] = {0};
	sprintf( szNodePath, "%s%c", _path.c_str(), C_PATHLASH );
	
	// Ŀ¼
	DIR * dp = NULL;
	struct dirent * dirp = NULL;
	dp = opendir( szNodePath );
	if( NULL == dp )
	{
		return false;
	}
	dirp = readdir(dp);
	if( NULL == dirp )
	{
		return false;
	}

	closedir(dp);

	return true;
}


PPATHNODE CFileTreeImpl::getTreeImpl() throw( CExceptionError )
{
	char szTempPath[ GD_MAX_PATH ] = {0};

	if ( _path.empty() ) return NULL;

	strcpy( szTempPath, _path.c_str() );
	if ( szTempPath[ strlen(szTempPath) - 1 ] == C_PATHLASH )
	{
		szTempPath[ strlen(szTempPath) - 1 ] = 0;
	}

	return createTree( "", szTempPath, NULL, 0 );
}


PPATHNODE CFileTreeImpl::createTree( char* szRoot, char* szPath, PPATHNODE dad, time_t nLastTime ) throw( CExceptionError )
{
	// ֯Ŀ¼
	char szNodePath[ GD_MAX_PATH ] = {0};
	if ( NULL == dad )
		sprintf( szNodePath, "%s%c", szPath, C_PATHLASH );
	else
		sprintf( szNodePath, "%s%c%s%c", szRoot, C_PATHLASH, szPath, C_PATHLASH );

	// Ŀ¼
	DIR * dp = NULL;
	struct dirent * dirp = NULL;
	dp = opendir(szNodePath);
	if( dp == NULL )
	{
		CExceptionError ex;
		ex.m_nErrCode = GetLastError();
		ex.AddErrText("%s",GetErrText(ex.m_nErrCode));              //wu_binǰ̨Ϣ

		ex.AddErrText( "Ŀ¼ʧ[%s][%d][%s]", szNodePath, ex.m_nErrCode, GetErrText( ex.m_nErrCode ) );
		ex.AddErrText( "CFileTreeImpl:createTree(%s,%s)", szRoot, szPath );
		throw ex;
	}
	dirp = readdir(dp);
	if( dirp == NULL ) return NULL;
	szNodePath[strlen(szNodePath)-1]=0;

	// 
	PPATHNODE root=new PATHNODE;
	memset(root,0,sizeof(PATHNODE));
	int nLen=strlen(szPath);
	root->szName=new char[nLen+1];
	memcpy(root->szName,szPath,nLen);
	root->szName[nLen]=0;
	root->time_createTime = nLastTime;
	
	// ӽ
	CExceptionError exs;
	char cFileName[ GD_MAX_PATH ] = {0};
	int nStep = 0;
	do
	{
		//ЧĿ¼ͽݹ
		struct stat statbuf;
		memset(&statbuf, 0, sizeof(statbuf));
		char strCur[GD_MAX_PATH] = {0};
		sprintf(strCur, "%s/%s", szNodePath, dirp->d_name);

		if( lstat(strCur, &statbuf) )
		{
			break;
		}
		
		if ( S_ISDIR(statbuf.st_mode) )
		{
			strcpy(cFileName,dirp->d_name);

			if( strcmp(cFileName,".") && strcmp(cFileName,"..") )
			{
				if( isRepeatedDir(cFileName, root->son) )
				{
					CGDLog::WriteErrLog("Dir[%s] repeated! Ignore...", cFileName);
					continue;
				}

				PPATHNODE node = NULL;
				switch ( nStep )
				{
				case 0:
					// һӽ
					try
					{
						node = createTree( szNodePath, cFileName, root, statbuf.st_mtime );
					}
					catch ( CExceptionError & ex )
					{
						exs.AppendFrom( ex );
						break;
					}
					nStep++;
					root->son=node;
					break;
				case 1:
					// ڶӽ
					try
					{
						node = createTree( szNodePath, cFileName, root, statbuf.st_mtime );
					}
					catch ( CExceptionError & ex )
					{
						exs.AppendFrom( ex );
						break;
					}
					nStep++;
					if(strcmp(node->szName,root->son->szName)>0)
					{	// ǰ
						node->bro=root->son;
						root->son=node;
					}
					else
					{
						root->son->bro=node;
					}
					break;
				default:
					// ӽ
					try
					{
						node = createTree( szNodePath, cFileName, root, statbuf.st_mtime );
					}
					catch ( CExceptionError & ex )
					{
						exs.AppendFrom( ex );
						break;
					}
					if(node)
					{
						if(strcmp(node->szName,root->son->szName)>0)
						{
							node->bro=root->son;
							root->son=node;
						}
						else if(strcmp(node->szName,root->son->bro->szName)>0)
						{
							node->bro=root->son->bro;
							root->son->bro=node;
						}
						else
						{
							PPATHNODE prev=root->son;
							PPATHNODE next=prev->bro;
							while(next->bro)
							{
								if(strcmp(node->szName,next->bro->szName)>0)
									break;
								prev=next;
								next=prev->bro;
							}
							node->bro=next->bro;
							next->bro=node;
						}
					}//if
				}//switch
			}//ifĿ¼Ч
		}//ifĿ¼
		else
		{
			strcpy(cFileName,dirp->d_name);

			if( isRepeatedFile(cFileName, root->list) )
			{
				CGDLog::WriteErrLog("File[%s] repeated! Ignore...", cFileName);
				continue;
			}

			// ļ
			PFILENODE file=new FILENODE;
			file->szName=new char[strlen(cFileName)+1];
			strcpy(file->szName,cFileName);
			file->size_Size = statbuf.st_size;
			file->time_LastWriteTime = statbuf.st_mtime;

			// 

			if(!root->list)
			{
				file->link=NULL;
				root->list=file;
			}
			else
			{
				PFILENODE list=root->list;
				PFILENODE link=list->link;
				if(strcmp(file->szName,list->szName)>0)
				{
					file->link=root->list;
					root->list=file;
				}
				else
				{
					while(link)
					{
						if(strcmp(file->szName,link->szName)>0)
							break;
						list=link;
						link=list->link;
					}
					file->link=list->link;
					list->link=file;
				}
			}
		}

	} while( (dirp=readdir(dp)) );
	closedir(dp);

	return root;
}

bool CFileTreeImpl::isRepeatedDir(const char* name, PPATHNODE pList)
{
	while( pList )
	{
		if( strcmp(name, pList->szName) == 0 )
		{
			return true;
		}

		pList = pList->bro;
	}

	return false;
}

bool CFileTreeImpl::isRepeatedFile(const char* name, PFILENODE pList)
{
	while( pList )
	{
		if( strcmp(name, pList->szName) == 0 )
		{
			return true;
		}

		pList = pList->link;
	}

	return false;
}

