/***********************************************************************
*
* ļ  FileOptEx.cpp
* ģĿģʵֺϷļ
* ߼ڣ  wang_jin 2008-04-11
* 汾 1.0
* ȨϢCVICSE Middleware
* ļ¼by wang_jin at 2009-8-16 at 
*
***********************************************************************/

#pragma warning(disable:4251)

#include <STAR/CORBA.h>

#include "Base/App.h"
#include "Base/FileListEx.h"
#include "Base/FileOptEx.h"
#include "Base/MonitorDef.h"
#include "Base/MonitorManager.h"
#include "Base/RunInfor.h"
#include "Base/Tool.h"
#include "Base/Toolbox.h"
#include "Common/AppError.h"
#include "Common/Common.h"
#include "Common/DateTime.h"
#include "Common/GDString.h"
#include "FileOpt/FileOpt.h"
#include "GDLock/GDLock.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDThreadPool/Thread.h"

#ifdef Linux
#include "FileProtect/FileProtect.h"
#endif

#ifdef WIN32
#	include <sys/stat.h> 
#	include <direct.h>
#else
#	include <dirent.h>
#	include <errno.h>
#endif

#include <time.h>
#include <set>

using namespace std;

map<string, EVENT_S> CFileOptEx::m_queLegalFileEvt;
CThreadMutex CFileOptEx::m_mutex;

CFileOptEx::CFileOptEx()
{
}

CFileOptEx::~CFileOptEx()
{
}

// ɱļ
unsigned long CFileOptEx::GetDustSerialNo()
{
	CGDTrace trace( LOG_L6, "CFileOptEx:GetDustSerialNo()" );
	
	static unsigned long nSerialNo = time(NULL) << 10; // Ʊظ(ֻҪƽ11024¼2^24ڲظԼ194)
	static CThreadMutex mutex;
	
	CThreadLock lock(mutex);
	return trace.SetRetValue( nSerialNo++ );
}

// ļļбѭ
long CFileOptEx::MoveFileListIn(bool bMonitor,
								const char* srcfile,
								const char* dstfile,
								const char* delfile)
								throw(CExceptionError)
{
	string sParam;
	sParam = sParam 
		+ "srcfile[" + srcfile
		+ "]dstfile[" + dstfile
		+ "]delfile[" + delfile
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveFileListIn(%s)", sParam.c_str() );
	
	CExceptionError exErr;
	long nErrCount = 0; // 쳣
	
#ifdef WIN32
	string dustDir = CToolbox::GetGDDustPath( dstfile );
#else
	string dustDir = CToolbox::GetGDDustPath( GetInforGuardPath() ); // Ŀ¼
#endif
	
	int nRet = 0;
	
	FileList fileListSrc;
	FileList fileListDst;
	
	try
	{
		nRet = CFileListEx().CreateListEx( srcfile, fileListSrc, CFileListEx::NO_POLICY ); // ʱĿ¼ʹòԴļб
		nRet = CFileListEx().CreateListEx( dstfile, fileListDst, CFileListEx::FILE_POLICY ); // ĿĿ¼ʹòԹųļ
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveFileListIn(%s)", sParam.c_str() );
		throw ex;
	}
	
	// vector 洢dstбеӦļset,Աٲɾ
	set<string> dstFileSet;
	for ( FileList::iterator itDstfile = fileListDst.begin(); itDstfile != fileListDst.end(); ++itDstfile )
	{
		dstFileSet.insert( (*itDstfile).name );
	}
	
	GDPrint( "ƶļʼ\n" );
	
	int nSrcPathLen = strlen( srcfile );
	
	// ļ
	for ( FileList::iterator itSrc = fileListSrc.begin(); itSrc != fileListSrc.end(); ++itSrc )
	{
		const char * sFile = (*itSrc).name.c_str();
		
		// װĿ·([Դļ][Դļ·]滻Ϊ[Ŀļ·])
		string sDstFile = sFile;
		sDstFile.replace( 0, nSrcPathLen, dstfile );
		
		try
		{
			if ( (*itSrc).isfolder ) // Ŀ¼
			{
				MakeSureDirExistLegally( sDstFile.c_str() ) ;
			}
			else // ļ
			{
				MoveFileIntoLegally( bMonitor, sFile, sDstFile.c_str(), dustDir.c_str() ); // ???dustDir
			}
		}
		catch ( CExceptionError & ex )
		{
			nErrCount++;
			exErr.AppendFrom( ex ); // ۻ쳣
			
			if (nErrCount > 500 )
			{
				throw exErr; // 쳣ֹ࣬
			}
		}
		
		// dstбеӦļ
		set<string>::iterator itset = dstFileSet.find( sDstFile );
		if ( itset != dstFileSet.end() )
		{
			dstFileSet.erase(itset);
		}
	}
	
	GDPrint( "ƶļ\n" );
	
	int nDstPathLen = strlen( dstfile );
	
	// dstļ
	char dustfile[GD_MAX_PATH] = {0};
	for ( set<string>::iterator itset = dstFileSet.begin(); itset != dstFileSet.end(); ++itset )
	{
		const char * sFile = (*itset).c_str();
		string sOptionFile = sFile;
		sOptionFile.replace( 0, nDstPathLen, delfile );
		
		sprintf(dustfile, "%s%d", dustDir.c_str(), GetDustSerialNo());
		
		try
		{
			MoveFileOutLegally( sFile, dustfile );
		}
		catch ( CExceptionError & ex )
		{
			nErrCount++;
			exErr.AppendFrom( ex ); // ۻ쳣
			
			if (nErrCount > 500 )
			{
				throw exErr; // 쳣ֹ࣬
			}
		}
	}
	
	if ( nErrCount > 0 ) // ֻҪ쳣׳
	{
		throw exErr;
	}
	
	return trace.SetRetValue( nRet );
}

// ϷļעϷ¼ִ
long CFileOptEx::MoveFileIntoLegally(bool bMonitor, 
									 const char* sSrcFileName,
									 const char* sDstFileName,
									 const char* sDustFileName )
									 throw(CExceptionError)
{
	string sParam;
	sParam = sParam 
		+ "bMonitor[" + ( bMonitor?"1":"0" )
		+ "]sSrcFileName[" + sSrcFileName
		+ "]sDstFileName[" + sDstFileName
		+ "]sDustFileName[" + sDustFileName
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveFileIntoLegally(%s)", sParam.c_str());
	
	long nRet = 0;
	
	// жԴļǷ
	bool bFolder = false;
	try
	{
		if ( ! CFileOpt::IsExist( sSrcFileName, &bFolder ) )
		{
			// Դļڣ쳣
			CExceptionError ex;
			ex.m_nErrCode = GetLastError();
			ex.AddErrText( "%s",GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
			ex.AddErrText( "ļ[%s]", sSrcFileName );
			throw ex;
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveFileIntoLegally(%s,%s,%s)", sSrcFileName, sDstFileName, sDustFileName );
		throw ex;
	}
	
	EVENT_S newEvt = {0};
	std::string strTmpFileName = sSrcFileName;
	
	try
	{
		// жĿļǷ
		bool bDir = false;
		if ( CFileOpt::IsExist( sDstFileName, &bDir ) )
		{
			// ĿļڣҪƳļĿ¼
			if ( bMonitor )
			{
				// עɾ+½¼
#ifdef WIN32
				newEvt.event_type = ( MONITOR_EVENT_WATCHER_DELETE << 8 ) + MONITOR_EVENT_WATCHER_CREATE;
#elif defined INOTIFY_SUPPORT
				if ( bFolder )
				{
					// Ŀ¼
					newEvt.event_type = ( MONITOR_EVENT_NOFIER_MOVEOUT << 8 ) + MONITOR_EVENT_NOFIER_CREATE;
				}
				else
				{
					// ļ
					newEvt.event_type = MONITOR_EVENT_NOFIER_CHANGE;
				}
#endif
				strcpy( newEvt.o_filepath, sDstFileName );
				
				if ( newEvt.event_type )
				{
					nRet = CFileOptEx::RegisterLegalEvent( newEvt );
				}
			}
			
#ifdef WIN32			
			// ߳ȼΪ
			SetThreadPriority( ::GetCurrentThread(), 
				THREAD_PRIORITY_TIME_CRITICAL // Time-criticalʵʱ
				);
#endif
			// ƳĿ¼
			string sDstPath;
			CTool::GetFilePath( sDstPath, sDustFileName );
			if( !CFileOpt::IsExist( sDstPath.c_str() ) )
			{
				CFileOpt::MakeSureDirExist( sDstPath.c_str() );
			}
			nRet = CFileOpt::MoveFileOrFolder( sDstFileName, sDustFileName );
			if ( nRet )
			{
				if ( newEvt.event_type )
				{					
					// ʧܺע¼
					CFileOptEx::EraseLegalEvent( newEvt ); // ???
				}
				return trace.SetRetValue( nRet );
			}
			
			if ( bDir )
			{
				// ʱĿ¼кϲ
				nRet = CFileOpt::CombinFileOrFolder(sSrcFileName, sDustFileName, strTmpFileName);
			}
		}
		else
		{
			// ĿļڣֻҪ룬ļĿ¼
			
			// ȷĿ¼
			string sDstPath;           
			CTool::GetFilePath( sDstPath, sDstFileName );
			if( !CFileOpt::IsExist( sDstPath.c_str() ) )
			{
				nRet = MakeSureDirExistLegally( sDstPath.c_str() );
			}
			
			if ( bMonitor )
			{
				//  ½¼ Ϸ¼
#ifdef WIN32
				newEvt.event_type = MONITOR_EVENT_WATCHER_CREATE;
#elif defined INOTIFY_SUPPORT
				if ( bFolder )
				{
					newEvt.event_type = MONITOR_EVENT_NOFIER_CREATE;
				}
				else
				{
					newEvt.event_type = MONITOR_EVENT_NOFIER_CHANGE;
				}
#endif
				strcpy( newEvt.o_filepath, sDstFileName );
				if ( newEvt.event_type )
				{
					nRet = CFileOptEx::RegisterLegalEvent( newEvt );
				}
			}
		}
		// 
		nRet = CFileOpt::MoveFileOrFolder( strTmpFileName.c_str(), sDstFileName );
#ifdef WIN32
		// ߳ȼΪ
		SetThreadPriority( ::GetCurrentThread(), 
			THREAD_PRIORITY_NORMAL // Normal
			);
#endif
		
		CGDTrace::GDTrace( LOG_NOT, "ļ[%s][%s]->[%s]", (0==nRet)?"ɹ":"ʧ", sDustFileName, sDstFileName );
		
		if ( nRet )
		{
			// ʧܺע¼
			CFileOptEx::EraseLegalEvent( newEvt );
			return trace.SetRetValue( nRet );
		}
	}
	catch ( CExceptionError & ex )
	{
		// ʧܺע¼
		CFileOptEx::EraseLegalEvent( newEvt );
		
		ex.AddErrText( "CFileOptEx:MoveFileIntoLegally(%s).", sParam.c_str() );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );
}

// ϷƳļעϷ¼ִƳ
long CFileOptEx::MoveFileOutLegally( const char* sSrcFile, const char* sDstFile ) throw(CExceptionError)
{
	string sParam;
	sParam = sParam
		+ "srcfile[" + sSrcFile
		+ "]dstfile[" + sDstFile
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveFileOutLegally(%s)", sParam.c_str() );
	
	int nRet = 0;
	
	bool bFileDriver = false;//ļ add by dai_hyan 2010-2-22 
#ifdef Linux 
	bFileDriver = IsProtect( sSrcFile );
#endif
	
	try
	{
		// жԴļǷ
		if ( CFileOpt::IsExist( sSrcFile ) )
		{
			// ԴļڣƳļĿ¼
			EVENT_S newEvt = {0};
			try
			{
#ifdef Linux
				bool bMonitor = CAppConfig::Instance().IsFileMonitoring( sSrcFile );	//жĿǷ񱻼ءadd by wubin 20100314
				if( bFileDriver && bMonitor )//ļ add by dai_hyan 2010-2-22 
				{
					nRet = ProtectMoveFileOutLegally( true,sSrcFile, sDstFile );
					return trace.SetRetValue( nRet );
					
				}
#endif
				//  Ƴɾ¼ Ϸ¼
#ifdef WIN32
				newEvt.event_type = MONITOR_EVENT_WATCHER_DELETE;
#else
				newEvt.event_type = MONITOR_EVENT_NOFIER_MOVEOUT;
#endif
				strcpy( newEvt.o_filepath, sSrcFile );
				nRet = CFileOptEx::RegisterLegalEvent( newEvt );
				
				// ƶ
				nRet = CFileOpt::MoveFileOrFolder( sSrcFile , sDstFile );
				
				CGDTrace::GDTrace( LOG_NOT, "Ƴļ[%s][%s]", (0==nRet)?"ɹ":"ʧ", sSrcFile );
				
				if ( nRet )
				{
					// ʧܺע¼
					CFileOptEx::EraseLegalEvent( newEvt );
					
					return trace.SetRetValue( nRet );
				}
			}
			catch ( CExceptionError & ex )
			{
				// ʧܺע¼
				CFileOptEx::EraseLegalEvent( newEvt );
				
				ex.AddErrText( "CFileOptEx:MoveFileOutLegally(%s)", sParam.c_str() );
				throw ex;
			}
		}
		else
		{
			// Դļڣûʲôϵ(ʡ)
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveFileOutLegally(%s)", sSrcFile );
		// ¼־
		CGDLog::WriteErrLog("1015:Ƴļʧ(%s)\n%s", sSrcFile, ex.GetErrText().c_str() );
	}
	catch ( ... )
	{
		// ¼־
		CGDLog::WriteErrLog("1016:CFileOptEx:MoveFileOutLegally(%s) catch(...)", sSrcFile );
	}
	
	return trace.SetRetValue( nRet );
}

// ϷĿ¼򴴽עٴݹ鴦
long CFileOptEx::MakeSureDirExistLegally( const char* sDir ) throw( CExceptionError )
{	
	string sParam = sDir;
	CGDTrace trace( LOG_L6, "CFileOptEx:MakeSureDirExistLegally(sDir[%s])", sParam.c_str() );
	
	long nRet = 0;
	
	bool bFileDriver = false;//ļ add by dai_hyan 2010-2-22 
#ifdef Linux 
	bFileDriver = IsProtect( sDir );
#endif	
	
	try
	{
		bool bFolder = true;
		if ( CFileOpt::IsExist( sDir, &bFolder ) )
		{
			// 
			if ( bFolder )
			{
				return trace.SetRetValue( 0 );
			}
			else
			{
				// Ŀ¼ǣͬļ
				CExceptionError ex;
				ex.m_nErrCode = 0x1000 + 0x801;
				ex.AddErrText( "Ŀ¼ʱͬļ[%s]", sDir );
				throw ex;
			}
		}
		else
		{
#ifdef Linux
			bool bMonitor = CAppConfig::Instance().IsFileMonitoring( sDir );	//жĿǷ񱻼ءadd by wubin 20100314			
			if( bFileDriver && bMonitor )//ļ add by dai_hyan 2010-2-22 
			{
				nRet = ProtectMakeSureDirExistLegally( sDir );
				return trace.SetRetValue( nRet );
			}
#endif
			// ڣϼĿ¼
			int nLen = strlen( sDir );
			while ( nLen>=3 && sDir[nLen-2] != C_PATHLASH ) nLen--;
			if ( nLen < 3 )
			{
				// Ŀ¼Ч
				CExceptionError ex;
				ex.m_nErrCode = 0x1000 + 0x801;
				ex.AddErrText( "Ŀ¼ʱĿ¼Ч[%s]", sDir );
				ex.AddErrText( "MakeSureDirExistLegally(%s)", sDir );
				throw ex;
			}
			
			string sBasePath = sDir;
			sBasePath = sBasePath.substr( 0, nLen - 2 );
			nRet = MakeSureDirExistLegally( sBasePath.c_str() );
			if ( nRet )
			{
				return trace.SetRetValue( nRet );
			}
			
			//  ½Ŀ¼¼ Ϸ¼
			EVENT_S newEvt = {0};
#ifdef WIN32
			newEvt.event_type = MONITOR_EVENT_WATCHER_CREATE;
#else
			newEvt.event_type = MONITOR_EVENT_NOFIER_CREATE;
#endif
			strcpy( newEvt.o_filepath, sDir );
			nRet = CFileOptEx::RegisterLegalEvent( newEvt );
			
			// Ŀ¼
			nRet = CFileOpt::MakeDir( sDir ); // ֵΪϵͳ
			if ( nRet )
			{
				// ʧܺע¼
				CFileOptEx::EraseLegalEvent( newEvt );
			}
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MakeSureDirExistLegally(%s)", sDir );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );
}

// ϷעϷ¼ִ
long CFileOptEx::RenameLegally( const char * sOldFileName, const char * sNewFileName, int nAttr ) throw(CExceptionError)
{
	string sParam;
	sParam = sParam 
		+ "OldName[" + sOldFileName
		+ "]NewName[" + sNewFileName
		+ "]Attr[" + CGDString::ltoa( nAttr, 16 )
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:RenameLegally(%s)", sParam.c_str() );
	
	long nRet = 0;
	
	bool bFileDriver = false;//ļ add by dai_hyan 2010-2-22 
#ifdef Linux 
	bFileDriver = IsProtect( sNewFileName );
#endif
	
	EVENT_S newEvt = {0};
	try
	{
#ifdef Linux
		bool bMonitor = CAppConfig::Instance().IsFileMonitoring( sOldFileName );	//жĿǷ񱻼ءadd by wubin 20100314
		if( bFileDriver && bMonitor )//ļ add by dai_hyan 2010-2-22 
		{
			nRet = ProtectRenameLegally( sOldFileName, sNewFileName, nAttr );
			return trace.SetRetValue( nRet );
		}
#endif
		//  ָ¼ Ϸ¼
#ifdef WIN32
		newEvt.event_type = MONITOR_EVENT_WATCHER_RENAME;
#else
		newEvt.event_type = MONITOR_EVENT_NOFIER_RENAME;
#endif
		strcpy( newEvt.o_filepath, sOldFileName );
		strcpy( newEvt.n_filepath, sNewFileName );
		newEvt.attr_flag = nAttr;
		nRet= CFileOptEx::RegisterLegalEvent( newEvt );
		
		// ִ
		nRet = ::rename( sOldFileName, sNewFileName );
		if ( nRet )
		{
			// ʧܺע¼
			CFileOptEx::EraseLegalEvent( newEvt );
		}
	}
	catch ( CExceptionError & ex )
	{
		// ʧܺע¼
		CFileOptEx::EraseLegalEvent( newEvt );
		
		ex.AddErrText( "CFileOptEx:RenameLegally(%s)", sParam.c_str() );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );
}

// עϷ¼
long CFileOptEx::RegisterLegalEvent( EVENT_S& evt )
{
	CGDTrace trace( LOG_L6, "CFileOptEx:RegisterLegalEvent(%x,%s)", evt.event_type, evt.o_filepath );
	
	if( CApp::Instance().MonitorManager().NeedRegisterEvent( evt.o_filepath, evt.sDirId ) )
	{		
		map<string, EVENT_S>::iterator iter;
		
#ifndef WIN32
		string szTmpFilePath = evt.o_filepath;
#else
		string szTmpFilePath = evt.o_filepath;
		std::transform(szTmpFilePath.begin(),szTmpFilePath.end(),szTmpFilePath.begin(),tolower);
#endif
		CThreadLock lock( m_mutex );
		iter = CFileOptEx::m_queLegalFileEvt.find( szTmpFilePath );
		if ( iter != CFileOptEx::m_queLegalFileEvt.end() )
		{
			if ( time(NULL) - (iter->second).tNextDealTime < CAppOption::Instance().GetOption("handleevent.validtime", 30) )
			{
				if ( evt.event_type > 0xff ) (iter->second).event_type <<= 16;
				else (iter->second).event_type <<= 8;
				(iter->second).event_type += evt.event_type;
				CGDLog::WriteLegalList( "ע¼-[%x][%s]", (iter->second).event_type, evt.o_filepath );
				trace.GDTrace( LOG_L6, "ע¼-[%x][%s]", (iter->second).event_type, evt.o_filepath );
			}
			else
			{
				(iter->second).event_type = evt.event_type;
				CGDLog::WriteLegalList( "ע¼-[%x][%s]", (iter->second).event_type, evt.o_filepath );
				trace.GDTrace( LOG_L6, "ע¼-[%x][%s]", (iter->second).event_type, evt.o_filepath );
			}
			(iter->second).tNextDealTime = time(NULL); // ¼Ч
		}
		else
		{
			evt.tNextDealTime = time(NULL); // ¼Ч
			std::pair< std::map< string, EVENT_S >::iterator, bool > ret = 
				CFileOptEx::m_queLegalFileEvt.insert( make_pair(szTmpFilePath, evt) );
			if ( ret.second ) // OK
			{
				CGDLog::WriteLegalList( "ע¼-[%x][%s]", evt.event_type, evt.o_filepath );
				trace.GDTrace( LOG_L6, "ע¼-[%x][%s]", evt.event_type, evt.o_filepath );
			}
			else // Failure
			{
				GDErrCode errCode = GetLastError();
				CGDLog::WriteErrLog( "CFileOptEx:m_queLegalFileEvt.insert() err=[%d]", errCode );
				assert( 0 );
			}
		}
		CGDTrace::GDTrace( LOG_NOT, "CFileOptEx::RegisterLegalEvent(%x,%s)", evt.event_type, evt.o_filepath ); 
	}
	
	return trace.SetRetValue( 0 );
}

// ж¼ǷѾעĺϷ¼
bool CFileOptEx::IsLegalEvent( EVENT_S & evt )
{
	CGDTrace trace( LOG_L6, "CFileOptEx:IsLegalEvent(%x)", evt.event_type  );
	
	map<string, EVENT_S>::iterator iter;
	
#ifndef WIN32
	string szTmpFilePath = evt.o_filepath;
#else
	string szTmpFilePath = evt.o_filepath;
	std::transform(szTmpFilePath.begin(),szTmpFilePath.end(),szTmpFilePath.begin(),tolower);
#endif
	
	CThreadLock lock( m_mutex );
	iter = m_queLegalFileEvt.find(szTmpFilePath);
	
	if ( iter != m_queLegalFileEvt.end() )
	{
		int & type = (iter->second).event_type;
		int & action_type = evt.event_type;
		CGDLog::WriteLegalList( "ȶ¼[%x-%x][%s]", type, action_type, evt.o_filepath );
		trace.GDTrace( LOG_L6, "ȶ¼[%x][%x][%s]", type, action_type, evt.o_filepath );
		
		if ( type == action_type ) // ¼ͬ
		{
			m_queLegalFileEvt.erase( iter );
		}		
		else
		{
			char * p = (char*)&type;
			char * q = (char*)&action_type;
			
			for ( int pi=3, qi=3; pi>=0 && qi>=0; )
			{
				while ( *(p+pi) == 0 ) pi--;
				while ( *(q+qi) == 0 ) qi--;
				
				if ( *(p+pi) == *(q+qi) )
				{
					*(p+pi) = 0x0;
					*(q+qi) = 0x0;
					pi--;
					qi--;
				}
#ifdef WIN32
				else if ( (*(p+pi)==0x12) && (*(p+pi-1)==0x11) && (*(q+qi)==0x13) ) // Ϸеɾ½ϱ޸ƥ
#else
					else if ( (*(p+pi)==0x55) && (*(p+pi-1)==0x51) && (*(q+qi)==0x53) ) // Ϸеɾ½ϱ޸ƥ
#endif
				{
					*(p+pi) = 0x0;
					*(p+pi-1) = 0x0;
					*(q+qi) = 0x0;
					pi = pi - 2;
					qi--;
				}
#ifdef WIN32
				else if ( (*(p+pi)==0x11) && (*(p+pi-1)==0x12) ) // Ϸе½ɾ
#else
					else if ( (*(p+pi)==0x51) && (*(p+pi-1)==0x55) ) // Ϸе½ɾ
#endif
				{
					*(p+pi) = 0x0;
					*(p+pi-1) = 0x0;
					*(q+qi) = 0x0;
					pi = pi - 2;
				}
				else
				{
					return false;
				}
			}
			
			if ( type == 0 )
			{
				// ע¼
				m_queLegalFileEvt.erase( iter );
			}
			
			if ( action_type == 0 )
			{
				// ǰ¼Ϸ
				return trace.SetRetResult( true );
			}
			else
			{
				//ʣ¼Ƿ
				return trace.SetRetResult( false );
			}						
		}				
		return trace.SetRetResult( true );
	}	
	return trace.SetRetResult( false );
}

// ɾעĺϷ¼ʧܺ
bool CFileOptEx::EraseLegalEvent( EVENT_S& evt )
{
	CGDTrace trace( LOG_L6, "CFileOptEx:EraseLegalEvent(%d)", evt.event_type );
	if ( CFileOptEx::IsLegalEvent( evt ) )
	{
		return trace.SetRetResult( true );
	}
	CGDTrace::GDTrace( LOG_NOT, "CFileOptEx:EraseLegalEvent(%d,%s) - return false", evt.event_type, evt.o_filepath ); 
	return trace.SetRetResult( false );
}

// ļ̷ by wang_jin at 2008-11-21
void CFileOptEx::MoveFileIntoWorkspace( bool bTopPath, const char* sSrcPath, const char* sDstPath, const char* sDustPath ) throw ( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveFileIntoWorkspace(%d,%s,%s,%s)", bTopPath?1:0, sSrcPath, sDstPath, sDustPath );
	
	bool bFileDriver = false;//ļ add by dai_hyan 2010-2-22 
#ifdef Linux
	bFileDriver = IsProtect( sDstPath );
#endif
	
	try
	{
		if ( bTopPath && CAppConfig::Instance().IsFileMonitoring( sDstPath ) )
		{
#ifdef Linux
			if( bFileDriver )//ļ add by dai_hyan 2010-2-22 
			{
				ProtectMoveAllFileIn(sSrcPath, sDstPath, sDustPath);
			}
#endif
				// еĶĿ¼(WindowsƲ;Linux˲)
				MoveFileIntoLoop( sSrcPath, sDstPath, sDustPath );
		}
		else
		{
			if ( CFileOpt::IsExist( sSrcPath ) )
			{
				bool bMonitor = CAppConfig::Instance().IsFileMonitoring( sDstPath );
#ifdef WIN32
				if ( CFileOpt::IsExist( sDstPath ) )
				{
					long nRet = MoveFileIntoLegally( bMonitor, sSrcPath, sDstPath, sDustPath );
					if ( nRet )
					{
						MoveFileIntoLoop( sSrcPath, sDstPath, sDustPath );
					}
				}
				else
				{
					MoveFileInLegally( bMonitor, sSrcPath, sDstPath );
				}
#else
				if( bFileDriver && bMonitor )//ļ˼
				{
					ProtectMoveFileInLegally( bMonitor, sSrcPath, sDstPath, sDustPath );
				}
				else		//ԭļ	
				{
					if ( CFileOpt::IsDirectory( sSrcPath ) )
					{
						long nRet = MoveFileIntoLegally( bMonitor, sSrcPath, sDstPath, sDustPath );
						if ( nRet )
						{
							MoveFileIntoLoop( sSrcPath, sDstPath, sDustPath );
						}
					}
					else
					{
						if ( CFileOpt::IsExist( sDstPath ) )
						{
							MoveFileIntoLegally( bMonitor, sSrcPath, sDstPath ,sDustPath);
						}
						else
						{
							MoveFileInLegally( bMonitor, sSrcPath, sDstPath );
						}
					}
				}
#endif
			}
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveFileIntoWorkspace(%d,%s,%s,%s)", bTopPath?1:0, sSrcPath, sDstPath, sDustPath );
		throw ex;
	}
}

void CFileOptEx::MoveFileIntoLoop( const char* sSrcPath, const char* sDstPath, const char* sDustPath ) throw ( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveFileIntoLoop(%s,%s,%s)", sSrcPath, sDstPath, sDustPath );
	
	// Ŀ¼
	FileList fileListSrc;
	CFileListEx objFileListSrc;
	try
	{
		objFileListSrc.CreateListEx( sSrcPath, fileListSrc, CFileListEx::NO_POLICY, 
			CFileList::FILE_OPTION_LIST|CFileList::FILE_OPTION_DIRECTORY|CFileList::FILE_OPTION_FILE );
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveFileJoin(%s,%s,%s)", sSrcPath, sDstPath, sDustPath );
		throw ex;
	}
	// ѭ
	CExceptionError exs;
	FileList::iterator itSrc;
	for ( itSrc = fileListSrc.begin(), ++itSrc; itSrc != fileListSrc.end(); ++itSrc ) // ++Ŀ¼
	{
		string sSrcFile = (*itSrc).name;
		string sDstFile = sSrcFile;
		string sDustFile = sSrcFile;
		// װĿ·([Դļ][Դļ·]滻Ϊ[Ŀļ·])
		sDstFile.replace( 0, strlen(sSrcPath), sDstPath );
		sDustFile.replace( 0, strlen(sSrcPath), sDustPath );
		try
		{
			MoveFileIntoWorkspace( false, sSrcFile.c_str(), sDstFile.c_str(), sDustFile.c_str() );
		}
		catch ( CExceptionError & ex )
		{
			exs.m_nErrCode += ex.m_nErrCode;
			for ( int i=0; i<ex.m_vErrText.size(); i++ )
			{
				exs.AddErrText( ex.m_vErrText[i].c_str() );
			}
		}
	}
	if ( exs.m_nErrCode )
	{
		exs.AddErrText( "CFileOptEx:MoveFileIntoLoop(%s,%s,%s)", sSrcPath, sDstPath, sDustPath );
		throw exs;
	}
	rmdir( sSrcPath );
}

void CFileOptEx::MoveFileInLegally( bool bMonitor, const char* sSrcFileName, const char* sDstFileName ) throw ( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveFileInLegally(%s,%s)", sSrcFileName, sDstFileName );
	
	EVENT_S newEvt = {0};
	try
	{
		// ȷ·
		string sDstPath;
		CTool::GetFilePath( sDstPath, sDstFileName );
		if( ! CFileOpt::IsExist( sDstPath.c_str() ) )
		{
			MakeSureDirExistLegally( sDstPath.c_str() );
		}
		
		// 
#if defined WIN32 || defined INOTIFY_SUPPORT
		if ( bMonitor )
		{
#	ifdef WIN32
			newEvt.event_type = MONITOR_EVENT_WATCHER_CREATE;
#	else
			if( CFileOpt::IsDirectory( sSrcFileName ))
			{
				newEvt.event_type = MONITOR_EVENT_NOFIER_CHANGE;
			}
			else
			{
				newEvt.event_type = MONITOR_EVENT_NOFIER_CHANGE;
			}
#	endif
			strcpy( newEvt.o_filepath, sDstFileName );
			CFileOptEx::RegisterLegalEvent( newEvt );
		}
#endif
		CFileOpt::MoveFileOrFolder( sSrcFileName, sDstFileName );
	}
	catch ( CExceptionError & ex )
	{
#if defined WIN32 || defined INOTIFY_SUPPORT
		if ( bMonitor )
		{
			CFileOptEx::EraseLegalEvent( newEvt );
		}
#endif
		ex.m_nErrCode = 1;
		string tmp = sSrcFileName;
		ex.m_vErrText[0] = tmp + "|" + ex.m_vErrText[0];
		ex.AddErrText( "CFileOptEx:MoveFileInLegally(%s,%s)", sSrcFileName, sDstFileName );
		throw ex;
	}
	
	trace.SetRetText("OK");
}

long WINAPI CALLBACK CFileOptEx::CallbackFileMove( void* pUserData, string sFile, long nFileSize, bool bFolder ) throw ( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "sFile[" + sFile
		+ "]nFileSize[" + CGDString::ltoa( nFileSize )
		+ "]bFolder[" + ( bFolder?"1":"0" )
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:CallbackFileMove(%s)", sParam.c_str() );
	
	long nRet = 0;
	CFileOptEx* pft = (CFileOptEx*)pUserData;
	
	// װĿ·([Դļ][Դļ·]滻Ϊ[Ŀļ·])
	string sDstFile = sFile;
	sDstFile.replace( 0, pft->m_sSrcPath.length(), pft->m_sDstPath);
	string sOptionFile = sFile;
	sOptionFile.replace( 0, pft->m_sSrcPath.length(), pft->m_sOptionPath );
	
	// ļ
	try
	{
		nRet = pft->MoveFileIntoLegally( pft->m_bMonitor, sFile.c_str(), sDstFile.c_str(), sOptionFile.c_str() );
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:CallbackFileMove(%s)", sParam.c_str() );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );
}

////////////////////////////////////////////////////////////////////////////////

long CFileOptEx::MoveAllIntoWorkspace(  bool bMonitor, 
									  const char* sSrcPath, 
									  const char* sDstPath, 
									  const char* sDelDir)
									  throw( CExceptionError )
{
	string sParam;
	sParam = sParam 
		+ "bMonitor[" + ( bMonitor?"1":"0" )
		+ "]sSrcPath[" + sSrcPath
		+ "]sDstPath[" + sDstPath
		+ "]sDelDir[" + sDelDir
		+ "]";	
	CGDTrace trace( LOG_L6, "CFileOptEx:MoveAllIntoWorkspace(%s)", sParam.c_str() );
	long ret = 0;
	
	// ԴļĿ¼Ƿ
	bool bSrcDir = false;
	try
	{
		if( !CFileOpt::IsExist(sSrcPath, &bSrcDir) )
		{
			CExceptionError ex;
			ex.m_nErrCode = ENOENT;
			ex.AddErrText( "%s",GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
			ex.AddErrText( "Ӧô: ļ[%s][%d][%s]", sSrcPath, ex.m_nErrCode, GetErrText(ex.m_nErrCode) );
			ex.AddErrText( "CFileOptEx:MoveAllIntoWorkspace(%s,%s,%s)", sSrcPath, sDstPath, sDelDir );
			throw ex;
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveAllIntoWorkspace(%s,%s,%s)", sSrcPath, sDstPath, sDelDir );
		throw ex;
	}
	
	// ĿļĿ¼Ƿ
	bool bDstDir = false;
	bool bDstExist = false;
	try
	{
		bDstExist = CFileOpt::IsExist(sDstPath, &bDstDir);
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:MoveAllIntoWorkspace(%s,%s,%s)", sSrcPath, sDstPath, sDelDir );
		throw ex;
	}
	
	// ļĿ·
	if( !bSrcDir || !bDstExist )
	{
		CGDLog::WriteErrLog("1017:CFileOptEx:MoveAllIntoWorkspace Դ·ļĿ·!");
		
		return trace.SetRetValue( ret );
	}
	
	// Ƴ
	try
	{
		ret = TravelTopDir(bMonitor, FILE_MOVEALL_OUT, sDstPath, sDstPath, sDelDir);
		
		// ͣ1룬ֹ¼ϲ
		CDateTime::Sleep(1000);
		
		// 
		ret = TravelTopDir(bMonitor, FILE_MOVEALL_IN, sSrcPath, sDstPath, sDelDir);
		rmdir(sSrcPath);
	}
	catch( CExceptionError &  )
	{
		return CAppError::GD_APP_ERR_EXCEPTION_INFORGUARD;
	}
	
	return trace.SetRetValue( ret );
}

long CFileOptEx::TravelTopDir(bool            bMonitor,
							  FileMoveAction  eAction, 
							  const char*     sLocal, 
							  const char*     sRemote,
							  const char*     sDelDir)
							  throw( CExceptionError )
{
	string sParam;
	sParam = sParam 
		+ "bMonitor[" + ( bMonitor?"1":"0" )
		+ "]eAction[" + ( eAction==FILE_MOVEALL_IN?"FILE_MOVEALL_IN":eAction==FILE_MOVEALL_OUT?"FILE_MOVEALL_OUT":"FILE_MOVEALL_NONE" )
		+ "]sLocal[" + sLocal
		+ "]sRemote[" + sRemote
		+ "]sDelDir[" + sDelDir
		+ "]";	
	CGDTrace trace( LOG_L6, "CFileOptEx:TravelTopDir(%s)", sParam.c_str() );
	long ret = 0;
	
	if( eAction == FILE_MOVEALL_OUT )
	{
		
	}
	
	bool bFinished = false;
	
	char topPath[GD_MAX_PATH] = {0};
	char localPath[GD_MAX_PATH] = {0};
	char remotePath[GD_MAX_PATH] = {0};
	
	strcpy(remotePath, sRemote);
	int remoteLen = strlen(remotePath);
	strcpy(localPath, sLocal);
	int localLen = strlen(localPath);
	
#ifdef WIN32 
	
	WIN32_FIND_DATA FileData;
	HANDLE hSearch;
	
	if(remotePath[remoteLen-1] != '\\')
	{
		strcat(remotePath, "\\");
	}
	
	if(localPath[localLen-1] != '\\')
	{
		strcat(localPath, "\\");
	}
	sprintf(topPath, "%s*.*", localPath);
	
	hSearch = FindFirstFile((LPCTSTR)topPath, &FileData);
	if( hSearch == INVALID_HANDLE_VALUE )
	{
		bFinished = true; //Ŀ¼ûļ
	}
	
	while( !bFinished )
	{
		char strCur[GD_MAX_PATH] = {0};
		sprintf(strCur, "%s%s", localPath, FileData.cFileName);
		
		if( strcmp(FileData.cFileName, ".") 
			&& strcmp(FileData.cFileName, "..") )
		{
			if( eAction == FILE_MOVEALL_IN )
			{
				char strRmt[GD_MAX_PATH] = {0};
				sprintf(strRmt, "%s%s", remotePath, FileData.cFileName);
				ret = MoveFileIntoLegally(bMonitor, strCur, strRmt, sDelDir);
			}
			else if( eAction == FILE_MOVEALL_OUT )
			{
				if( ! CAppConfig::Instance().IsIncludePolicy(strCur) )
				{
					// ڲ漰ݣֶͬԵļĿ¼Ƴ
					// ⲻ걸ĽĿǰɽ
					char strDust[GD_MAX_PATH] = {0};
					sprintf(strDust, "%s%d", sDelDir, GetDustSerialNo());
					ret = MoveFileOutLegally( strCur, strDust );
				}
			}
		}
		
		if ( !FindNextFile( hSearch, &FileData ) )
		{
			bFinished = true;
		}
	}
	
	FindClose(hSearch);
	
#else
	
	if(remotePath[remoteLen-1] != '/')
	{
		strcat(remotePath, "/");
	}
	
	if(localPath[localLen-1] != '/')
	{
		strcat(localPath, "/");
	}
	sprintf(topPath, "%s", localPath);
	
	DIR *dp = opendir(topPath);
	if( !dp )
	{
		CGDLog::WriteErrLog("1061:TravelTopDir: open dir error [%s][%s]", topPath, strerror(errno));
		
		int ret = -1;
		if( errno )
		{
			ret = errno;
		}
		
		return ret;
	}
	
	// Now traverse the directory
	struct dirent *dirp = NULL;
	while( (dirp = readdir(dp)) != NULL )
	{
		char strCur[GD_MAX_PATH] = {0};
		sprintf(strCur, "%s%s", localPath, dirp->d_name);
		// If has error, Ignore
		
		// Ignore "." and ".." directory. 
		if( !strcmp(".", dirp->d_name) || !strcmp("..", dirp->d_name) )
		{
			continue;
		}
		if( strcmp(dirp->d_name, ".") 
			&& strcmp(dirp->d_name, "..") )
		{
			if( eAction == FILE_MOVEALL_IN )
			{
				char strRmt[GD_MAX_PATH] = {0};
				sprintf(strRmt, "%s%s", remotePath, dirp->d_name);
				ret = MoveFileIntoLegally(bMonitor, strCur, strRmt, sDelDir);
			}
			else if( eAction == FILE_MOVEALL_OUT )
			{
				if( ! CAppConfig::Instance().IsIncludePolicy(strCur) )
				{
					// ڲ漰ݣֶͬԵļĿ¼Ƴ
					// ⲻ걸ĽĿǰɽ
					char strDust[GD_MAX_PATH] = {0};
					sprintf(strDust, "%s%d", sDelDir, GetDustSerialNo());
					ret = MoveFileOutLegally( strCur, strDust );
				}
			}
			
		}
		
	} // End of while
	
	closedir(dp);
	
#endif
	
	return trace.SetRetValue( ret );
}

//---------------ļ-------------------------

//жǷļ
#ifdef Linux
bool CFileOptEx::IsProtect ( const char* sFilePath)
{
	CGDTrace trace( LOG_L6, "CFileOptEx:IsProtect(sFilePath[%s])", sFilePath );
	bool bFileDriver = false;
	string sTmpFile = sFilePath;
	
	std::vector<WebSite> webSites;				
	CAppConfig::Instance().GetWebSites(webSites);
				
	std::vector<WebSite>::iterator itWebSite;
	for (itWebSite = webSites.begin(); itWebSite != webSites.end(); ++itWebSite)
	{
		std::vector<SiteDirectory>::iterator itDirectory;
		for (itDirectory = (*itWebSite).siteDirectorys.begin(); itDirectory != (*itWebSite).siteDirectorys.end(); ++itDirectory)
		{
			std::string sMonitorPath = (*itDirectory).localPath;
			if(((*itWebSite).policy.monitorPolicy.filedriver == 1) && (CAppConfig::Instance().IsFileInDirectory( sTmpFile,sMonitorPath )))
			{
				bFileDriver = true;
				break;
			}
		}
	}
	return trace.SetRetValue( bFileDriver );
}
//#endif

//add by zhangtao 2010.2.21
long CFileOptEx::ProtectMakeSureDirExistLegally( const char* sDir ) throw( CExceptionError )
{	
	string sParam = sDir;
	CGDTrace trace( LOG_L6, "CFileOptEx:ProctectMakeSureDirExistLegally(sDir[%s])", sParam.c_str() );
	
	long nRet = 0;
	long nTemp = 0;
	bool bMonitor = CAppConfig::Instance().IsFileMonitoring(sParam);	
	try
	{
		bool bFolder = true;
		if ( CFileOpt::IsExist( sDir, &bFolder ) )
		{
			// 
			if ( bFolder )
			{
				return trace.SetRetValue( 0 );
			}
			else
			{
				// Ŀ¼ǣͬļ
				CExceptionError ex;
				ex.m_nErrCode = 0x1000 + 0x801;
				ex.AddErrText( "Ŀ¼ʱͬļ[%s]", sDir );
				throw ex;
			}
		}
		else
		{
			// ڣϼĿ¼
			int nLen = strlen( sDir );
			while ( nLen>=3 && sDir[nLen-2] != C_PATHLASH ) nLen--;
			if ( nLen < 3 )
			{
				// Ŀ¼Ч
				CExceptionError ex;
				ex.m_nErrCode = 0x1000 + 0x801;
				ex.AddErrText( "Ŀ¼ʱĿ¼Ч[%s]", sDir );
				ex.AddErrText( "ProctectMakeSureDirExistLegally(%s)", sDir );
				ex.AddErrText( "ProtectMakeSureDirExist(%s)", sDir );
				throw ex;
			}
			
			string sBasePath = sDir;
			sBasePath = sBasePath.substr( 0, nLen - 2 );
			// ȷ·
			nRet = ProtectMakeSureDirExistLegally( sBasePath.c_str() );
			
			if ( nRet )
			{
				return trace.SetRetValue( nRet );
			}
						
			if( !CAppConfig::Instance().IsExcludeFile( sBasePath ) )
			{
				//صĿ¼ڴĿ¼֮ǰҪԸĿ¼-i
				nTemp = CFileProtect::chDirAttr( sBasePath.c_str(), false, false, false, "" );
				if ( nTemp > 0 )
				{
					nTemp = 0;
					CGDLog::WriteErrLog("CFileOptEx:ProtectMakeSureDirExistLegally:chDirAttr[%s] delete", sBasePath.c_str());
				}
			}
			// Ŀ¼
			nRet = CFileOpt::MakeDir( sDir ); // ֵΪϵͳ
			if( bMonitor )
			{
				//ڼ״̬£Ŀ¼ҪԸĿ¼´Ŀ¼+i
				if( !CAppConfig::Instance().IsExcludeFile( sBasePath ))
				{
					nTemp = CFileProtect::chDirAttr( sBasePath.c_str(), true, false, false, "" );
					if ( nTemp > 0 )
					{
						nTemp = 0;
						CGDLog::WriteErrLog("CFileOptEx:ProtectMakeSureDirExistLegally:chDirAttr[%s] add", sBasePath.c_str());
					}
				}
				if( !CAppConfig::Instance().IsExcludeFile( sDir ) )
				{
					nTemp = CFileProtect::chDirAttr( sDir, true, false, false, "" );
					if ( nTemp > 0 )
					{
						nTemp = 0;
						CGDLog::WriteErrLog("CFileOptEx:ProtectMakeSureDirExistLegally:chDirAttr[%s] add", sDir);
					}
				}
			}
			
			if ( nRet )
			{
				// ʧܺ¼־
				CGDLog::WriteErrLog( "CFileOptEx:ProtectMakeSureDirExist(%s)", sDir );
			}
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:ProctectMakeSureDirExistLegally(%s)", sDir );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );
}

long CFileOptEx::ProtectRenameLegally( const char * sOldFileName, const char * sNewFileName, int nAttr ) throw(CExceptionError)
{
	string sParam;
	sParam = sParam 
		+ "OldName[" + sOldFileName
		+ "]NewName[" + sNewFileName
		+ "]Attr[" + CGDString::ltoa( nAttr, 16 )
		+ "]";
	string sTempName = sOldFileName;
	CGDTrace trace( LOG_L6, "CFileOptEx:ProctectRenameLegally(%s)", sParam.c_str() );
	
	long nRet = 0;
	long nTemp = 0;
	bool bMonitor = CAppConfig::Instance().IsFileMonitoring(sTempName);	
	try
	{
		// ȡ·
		string sSuperPath;
		CTool::GetFilePath( sSuperPath, sOldFileName );
		string sWebSiteID;
		sWebSiteID = CAppConfig::Instance().GetWebsiteIdByLocalFileName( sSuperPath );
		
		if( !CAppConfig::Instance().IsExcludeFile( sSuperPath ) )
		{
			//ļĿ¼أ֮ǰҪԸĿ¼-i
			nTemp = CFileProtect::chDirAttr( sSuperPath.c_str(), false, false, false, "" );
			if ( nTemp > 0 )
			{
				nTemp = 0;
				CGDLog::WriteErrLog("CFileOptEx:ProtectRenameLegally:sSuperPath[%s] delete", sSuperPath.c_str() );
			}
		}
		if( !CAppConfig::Instance().IsExcludeFile( sOldFileName ) )
		{
			//ļأ֮ǰҪԸļ-i
			nTemp = CFileProtect::chDirAttr( sOldFileName, false, false, false, "" );
			if ( nTemp > 0 )
			{
				nTemp = 0;
				CGDLog::WriteErrLog("CFileOptEx:ProtectRenameLegally:sOldFileName[%s] delete", sOldFileName );
			}
		}
		// ִ
		nRet = ::rename( sOldFileName, sNewFileName );
		if( bMonitor )
		{
			if( !CAppConfig::Instance().IsExcludeFile( sSuperPath ) )
			{
				//ļĿ¼أ֮ҪԸĿ¼+i
				nTemp = CFileProtect::chDirAttr( sSuperPath.c_str(), true, false, false, "" );
				if ( nTemp > 0 )
				{
					nTemp = 0;
					CGDLog::WriteErrLog("CFileOptEx:ProtectRenameLegally:sSuperPath[%s] add", sSuperPath.c_str() );
				}
			}
			if( !CAppConfig::Instance().IsExcludeFile( sNewFileName ) )
			{
				//ļأ֮ҪԸļ+i
				nTemp = CFileProtect::chDirAttr( sNewFileName, true, false, false, "" );
				if ( nTemp > 0 )
				{
					nTemp = 0;
					CGDLog::WriteErrLog("CFileOptEx:ProtectRenameLegally:sSuperPath[%s] add", sNewFileName );
				}
			}
		}
		if ( nRet )
		{
			// ʧܺ¼־
			CGDLog::WriteErrLog( "CFileOptEx:ProtectRename(%s)", sParam.c_str() );
		}
	}
	catch ( CExceptionError & ex )
	{
		// ʧܺ¼		
		ex.AddErrText( "CFileOptEx:ProctectRename(%s)", sParam.c_str() );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );
}
//add at 2010.2.21

/************ļļ****************
 *****붥Ŀ¼ȫͬվ
 *****ʱûá
 *****add by wu_bin 2010-2-21
 ************************************************/
long CFileOptEx::ProtectMoveAllFileIn(const char* sSrcFileName,
									  const char* sDstFileName,
									  const char* sDelDir )
									  throw(CExceptionError)
{
	string sParam;
	sParam = sParam 
		+ "]sSrcFileName[" + sSrcFileName
		+ "]sDstFileName[" + sDstFileName
		+ "]sDelDir[" + sDelDir
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:ProtectMoveAllFileIn(%s)", sParam.c_str());
	
	long nRet = 0;
	
	// жԴļǷ
	try
	{
		bool bFolder = false;
		if ( ! CFileOpt::IsExist( sSrcFileName, &bFolder ) )
		{
			// Դļڣ쳣
			CExceptionError ex;
			ex.m_nErrCode = GetLastError();
			ex.AddErrText( "%s",GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
			ex.AddErrText( "ļ[%s]", sSrcFileName );
			throw ex;
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:ProtectMoveAllFileIn(%s,%s,%s)", sSrcFileName, sDstFileName, sDelDir );
		throw ex;
	}
	
	
	try
	{
		// жĿ·Ƿ
		if( CFileOpt::IsExist( sDstFileName ) )
		{
			nRet= CFileProtect::chDirAttr( sDstFileName, false, true, false, "" );
			if ( nRet )
			{
				CGDLog::WriteErrLog("CFileOptEx:ProtectMoveAllFileIn:chDirAttr[%s] delete", sDstFileName);
			}
			//Ŀ¼Ƶ
			nRet = CFileOpt::MoveFileOrFolder( sDstFileName, sDelDir );
		}
		else
		{
			string sDstPath;
			CTool::GetFilePath( sDstPath, sDstFileName );
			nRet = ProtectMakeSureDirExistLegally( sDstPath.c_str() );			
		}
		
		// ʱĿ¼ƵĿ¼
		nRet = CFileOpt::MoveFileOrFolder( sSrcFileName, sDstFileName );
		
		CGDTrace::GDTrace( LOG_NOT, "ļ[%s][%s]", (0==nRet)?"ɹ":"ʧ", sDstFileName );
		
		if ( nRet )
		{
			return trace.SetRetValue( nRet );
		}
	}
	catch ( CExceptionError & ex )
	{		
		ex.AddErrText( "CFileOptEx:ProtectMoveAllFileIn(%s).", sParam.c_str() );
		throw ex;
	}
	//Ŀ¼+i൱һμأ˴迼Ǽزԡ
	nRet = CFileProtect::chDirAttr( sSrcFileName, true, true, false, "" );
	if ( nRet )
	{
		CGDLog::WriteErrLog("CFileOptEx:ProtectMoveAllFileIn:chDirAttr[%s] add", sDstFileName);
	}
	//òԺȥųĿ¼i
	std::vector<WebSite> webSites;				
	CAppConfig::Instance().GetWebSites(webSites);
	std::string sTmpDstFileName = sDstFileName;			
	std::vector<WebSite>::iterator itWebSite;
	for (itWebSite = webSites.begin(); itWebSite != webSites.end(); ++itWebSite)
	{
		std::vector<SiteDirectory>::iterator itDirectory;
		for (itDirectory = (*itWebSite).siteDirectorys.begin(); itDirectory != (*itWebSite).siteDirectorys.end(); ++itDirectory)
		{
			//ȷļĸĿ¼ȡĿ¼DirectoryId
			if( CAppConfig::Instance().IsFileInDirectory( sTmpDstFileName, (*itDirectory).localPath ) )
			{
				//ųĿ¼ -i
				if (GetAppName() == "ma")
					CFileProtect::removeExcludeDirAttr( (*itDirectory).id.c_str() );       
			}
		}
	}
	
	return trace.SetRetValue( nRet );
}

									  
//뵥ļadd by wu_bin 2010-2-21
long CFileOptEx::ProtectMoveFileInLegally(bool bMonitor, 
										  const char* sSrcFileName,
										  const char* sDstFileName,
										  const char* sDelDir )
										  throw(CExceptionError)
{
	string sParam;
	sParam = sParam 
		+ "bMonitor[" + ( bMonitor?"1":"0" )
		+ "]sSrcFileName[" + sSrcFileName
		+ "]sDstFileName[" + sDstFileName
		+ "]sDelDir[" + sDelDir
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:ProtectMoveFileInLegally(%s)", sParam.c_str());
	
	long nRet = 0;
	
	bool bFolder = false;
	// жԴļǷ
	try
	{
		//bool bFolder = false;
		if ( ! CFileOpt::IsExist( sSrcFileName, &bFolder ) )
		{
			// Դļڣ쳣
			CExceptionError ex;
			ex.m_nErrCode = GetLastError();
			ex.AddErrText( "%s",GetErrText(ex.m_nErrCode) );              //wu_binǰ̨Ϣ
			ex.AddErrText( "ļ[%s]", sSrcFileName );
			throw ex;
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:ProtectMoveFileInLegally(%s,%s,%s)", sSrcFileName, sDstFileName, sDelDir );
		throw ex;
	}
	
	std::string strTmpFileName = sSrcFileName;
	string sDstPath;
	CTool::GetFilePath( sDstPath, sDstFileName );
	
	try
	{
		// ȷĿļ
		if( CFileOpt::IsExist( sDstFileName ) )
		{
			if (bMonitor)	//Ĭء
			{
				//زжϣ·Ƿų
				if( !CAppConfig::Instance().IsExcludeFile(sDstPath) )
				{
					//ļĿ¼أ-i
					nRet = CFileProtect::chDirAttr( sDstPath.c_str(), false, false, false, "" );
					if ( nRet )
					{
						CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileInLegally:chDirAttr[%s] delete", sDstPath.c_str());
					}
				}
				//زжϣǰļǷų
				if( !CAppConfig::Instance().IsExcludeFile(sDstFileName) )
				{
					//ǰļأ-i
					nRet = CFileProtect::chDirAttr( sDstFileName, false, false, false, "" );
					if ( nRet )
					{
						CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileInLegally:chDirAttr[%s] delete", sDstFileName);
					}
				}
			}
		}
		else
		{
			//Ŀļڣȷ丸·
			nRet = ProtectMakeSureDirExistLegally( sDstPath.c_str() );	
			if( nRet )
			{
				return trace.SetRetValue( nRet );
			}
			//زжϣ·Ƿų -i
			if( !CAppConfig::Instance().IsExcludeFile(sDstPath) )
			{
				//ļĿ¼أ-i
				//printf("·%s start ---i",sDstPath.c_str());
				nRet = CFileProtect::chDirAttr( sDstPath.c_str(), false, false, false, "" );
				if ( nRet )
				{
					CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileInLegally:chDirAttr[%s] delete", sDstPath.c_str());
				}
			}
		}
		
		// 
		nRet = CFileOpt::MoveFileOrFolder( strTmpFileName.c_str(), sDstFileName );
		
		CGDTrace::GDTrace( LOG_NOT, "ļ[%s][%s]", (0==nRet)?"ɹ":"ʧ", sDstFileName );
		if ( bMonitor )
		{
			//زжϣǰļǷų
			if( !CAppConfig::Instance().IsExcludeFile(sDstFileName) )
			{
				//ǰļأ+i
				nRet = CFileProtect::chDirAttr( sDstFileName, true, false, false, "" );
				if ( nRet )
				{
					CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileInLegally:chDirAttr[%s] add", sDstFileName);
				}
			}
			//زжϣ·Ƿų
			if( !CAppConfig::Instance().IsExcludeFile(sDstPath) )
			{
				//ļĿ¼أ+i
				nRet = CFileProtect::chDirAttr( sDstPath.c_str(), true, false, false, "" );
				if ( nRet )
				{
					CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileInLegally:chDirAttr[%s] add", sDstPath.c_str());
				}
			}			
		}
		
		if ( nRet )		//ʧֱӷ
		{
			return trace.SetRetValue( nRet );
		}
		
	}
	catch ( CExceptionError & ex )
	{
		
		ex.AddErrText( "CFileOptEx:ProtectMoveFileInLegally(%s).", sParam.c_str() );
		throw ex;
	}
	
	return trace.SetRetValue( nRet );	
}

// ϷƳļadd by wu_bin 2010-2-21
long CFileOptEx::ProtectMoveFileOutLegally( bool bMonitor, const char* sSrcFile, const char* sDstFile ) throw(CExceptionError)
{
	string sParam;
	sParam = sParam
		+ "srcfile[" + sSrcFile
		+ "dstfile[" + sDstFile
		+ "]";
	
	CGDTrace trace( LOG_L6, "CFileOptEx:ProtectMoveFileOutLegally(%s)", sParam.c_str() );
	
	int nRet = 0;
	
	try
	{
		// жԴļǷ
		if ( CFileOpt::IsExist( sSrcFile ) )
		{
			// ԴļڣƳļĿ¼
			try
			{
				string sSrcPath;
				CTool::GetFilePath( sSrcPath, sSrcFile );
				if ( bMonitor )
				{	//زжϣ·Ƿų
					if( !CAppConfig::Instance().IsExcludeFile(sSrcPath.c_str()) )
					{
						//ļĿ¼أ-i
						if ( strcmp( GetAppName(), "ma" ) == 0 )
						{
							nRet = CFileProtect::chDirAttr( sSrcPath.c_str(), false, false, false, "" );
							if ( nRet )
							{
								CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileOutLegally:chDirAttr[%s] delete", sSrcPath.c_str());
							}
						}
						
					}
					//زжϣǰļǷų
					if( !CAppConfig::Instance().IsExcludeFile(sSrcFile) )
					{
						//ǰļأ-i
						nRet = CFileProtect::chDirAttr( sSrcFile, false, false, false, "" );
						if ( nRet )
						{
							CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileOutLegally:chDirAttr[%s] delete", sSrcFile);
						}
					}							
				}
				
				// ƶ
				nRet = CFileOpt::MoveFileOrFolder( sSrcFile , sDstFile );
				
				CGDTrace::GDTrace( LOG_NOT, "Ƴļ[%s][%s]", (0==nRet)?"ɹ":"ʧ", sSrcFile );
				
				if ( bMonitor )
				{			
					//زжϣ·Ƿų
					if( !CAppConfig::Instance().IsExcludeFile(sSrcPath.c_str()) )
					{
						//ļĿ¼أ+i
						nRet = CFileProtect::chDirAttr( sSrcPath.c_str(), true, false, false, "" );
						if ( nRet )
						{
							CGDLog::WriteErrLog("CFileOptEx:ProtectMoveFileOutLegally:chDirAttr[%s] add", sSrcPath.c_str());
						}
					}	
				}
				
				if ( nRet )
				{
					// ʧֱܺӷ					
					return trace.SetRetValue( nRet );
				}
			}
			catch ( CExceptionError & ex )
			{				
				ex.AddErrText( "CFileOptEx:ProtectMoveFileOutLegally(%s)", sParam.c_str() );
				throw ex;
			}
		}
		else
		{
			// Դļڣûʲôϵ(ʡ)
		}
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CFileOptEx:ProtectMoveFileOutLegally(%s)", sSrcFile );
		// ¼־
		CGDLog::WriteErrLog("1015:Ƴļʧ(%s)\n%s", sSrcFile, ex.GetErrText().c_str() );
	}
	catch ( ... )
	{
		// ¼־
		CGDLog::WriteErrLog("1016:CFileOptEx:ProtectMoveFileOutLegally(%s) catch(...)", sSrcFile );
	}
	
	return trace.SetRetValue( nRet );
}
#endif
