/***********************************************************************
*
* ļ    GDLockLinux.cpp
* ģĿģʵֻLinux/UNIXƽ̨ļ໥̻߳⡢̻⣩
* ߼ڣ  wang_jin 2008-05-05
* 汾    1.0
* ȨϢ  CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "Common/Common.h"
#include "GDLock/GDLockLinux.h"


union semun
{
	int               val;    /* Value for SETVAL */
	struct semid_ds * buf;    /* Buffer for IPC_STAT, IPC_SET */
	unsigned short  * array;  /* Array for GETALL, SETALL */
	/* Linux specific part: */
#ifdef Linux
	struct seminfo  * __buf;  /* buffer for IPC_INFO */
#endif
};

// ̻߳

CThreadMutex::CThreadMutex()
{
	pthread_mutex_init( &m_mutex, NULL );
}

CThreadMutex::~CThreadMutex()
{
	pthread_mutex_destroy( &m_mutex );
}

void CThreadMutex::Lock()
{
	pthread_mutex_lock( &m_mutex );
}

void CThreadMutex::Unlock()
{
	pthread_mutex_unlock( &m_mutex );
}


// ̻

CProcessMutex::CProcessMutex()
{
	m_semkey = m_semid = -1;
	m_bLocked = false;
}

CProcessMutex::CProcessMutex( key_t key )
{
	m_semkey = key;
	m_semid = -1;
	m_bLocked = false;
}


CProcessMutex::~CProcessMutex()
{
	if ( m_bLocked ) // 
	{
		Unlock();
	}

	if ( IPC_PRIVATE == m_semkey ) // ˽ͷ(˽߳)
	{
		semctl( m_semid, 0, IPC_RMID, 0 );
		// ɾġ
		// ʹôź´ͼԴźвʱEIDRM
		// ִֻֽУһǾЧûIDsem_perm.cuidsem_perm.uidḶ̌
		// һǾгûȨĽ̡
	}
}


long CProcessMutex::Initialize( key_t key )
{
	if ( -1 != m_semid ) // Ѿʼóʼ
	{
		return 0;
	}
	
	m_semkey = key;
	
	// ȳԴ
	if ( (m_semid = semget( key, 1, 0 )) != -1 )
	{
		// 򿪲ҪʼҪȴ߳ʼ
		struct semid_ds seminfo = {0};
		union semun argn = {0};
		argn.buf = &seminfo;
		do
		{
			if ( semctl( m_semid, 0, IPC_STAT, argn ) == -1 )
			{
				// ʧ
				int nErr = errno;
				GDETrace( "ȴź[key=%x,id=%x]ʧ[err=%d][%s]", key, m_semid, nErr, GetErrText(nErr) );
				return nErr;
			}
			if ( argn.buf->sem_otime == 0 )
			{
				usleep(10000); // 10ms
			}
		}	while ( argn.buf->sem_otime == 0 );

		return 0;
	}
	else if ( errno == ENOENT )
	{
		// ʧܣźڣռ
		if ( (m_semid = semget( key, 1, IPC_CREAT|IPC_EXCL|0666 )) != -1 )
		{
			// ɹҪʼ
			struct semid_ds seminfo = {0};
			union semun argn = {0};
			
			argn.buf = &seminfo;
			argn.val = 1;
			
			semctl( m_semid, 0, SETVAL, argn );

			if ( Lock() && Unlock() )
			{
				return 0;
			}

			return -1;
		}
		else
		{
			// ʧ
			int nErr = errno;
			GDETrace( "ź[key=%x]ʧ[err=%d][%s]", key, nErr, GetErrText(nErr) );
			return nErr;
		}
	}
	else
	{
		// ʧ
		int nErr = errno;
		GDETrace( "ź[key=%x]ʧ[err=%d][%s]", key, nErr, GetErrText(nErr) );
		return nErr;
	}
}

bool CProcessMutex::Uninitialize()
{
	if ( m_bLocked ) // 
	{
		return Unlock();
	}
	return true;
}

bool CProcessMutex::Lock( unsigned int ms )
{
	if ( -1 == m_semid )
	{
		if ( Initialize( m_semkey ) )
		{
			return false;
		}
	}
	
	struct sembuf p = {0};
	p.sem_num = 0;
	p.sem_op = -1;
	p.sem_flg = SEM_UNDO; // p.sem_flg = IPC_NOWAIT|SEM_UNDO;
	
	if ( semop( m_semid, &p, 1 ) == -1 ) // 
	{
		int nErr = errno;
		GDETrace( "ź[key=%x,id=%x]ʧ[err=%d][%s][pid=%d]", m_semkey, m_semid, nErr, GetErrText(nErr), getpid() );
		return false;
	}

	m_bLocked = true;
	return true;
}

bool CProcessMutex::Unlock()
{
	if ( -1 == m_semid )
	{
		return false;
	}
	
	struct sembuf v = {0};
	v.sem_num = 0;
	v.sem_op = 1;
	v.sem_flg = SEM_UNDO; // p.sem_flg = IPC_NOWAIT|SEM_UNDO;
	
	if ( semop( m_semid, &v, 1 ) == -1 )
	{
		int nErr = errno;
		GDETrace( "ź[key=%x,id=%x]ʧ[err=%d][%s]", m_semkey, m_semid, nErr, GetErrText(nErr) );
		return false;
	}

	m_bLocked = false;
	return true;
}


// д( ̼ )( дȵ )

CProcessRWMutex::CProcessRWMutex()
{
	m_semkey = -1;
	m_rwMutexs = -1;
	m_LockMode = 0;
}

CProcessRWMutex::CProcessRWMutex( key_t key )
{
	m_semkey = key;
	m_semkey = -1;
	m_rwMutexs = -1;
	m_LockMode = 0;
}

CProcessRWMutex::~CProcessRWMutex()
{
}

const int RWMutexsNumber = 4;
const int RWMutex = 0;
const int RMutex = 1;
const int WMutex = 2;
const int CountMutex = 3;
long CProcessRWMutex::GetSem( key_t key, long& mutex )
{
	// ȳԴ
	if ( (mutex = semget( key, RWMutexsNumber, 0 )) != -1 )
	{
		// 򿪲ҪʼҪȴ߳ʼ
		struct semid_ds seminfo = {0};
		union semun argn = {0};
		argn.buf = &seminfo;
		for ( int i=0; i<RWMutexsNumber; i++ )
		{
			if ( semctl( mutex, i, IPC_STAT, argn ) == -1 )
			{
				// ʧ
				int nErr = errno;
				GDETrace( "ȴź[key=%x,id=%x]ʧ[err=%d][%s]", key, mutex, nErr, GetErrText(nErr) );
				return nErr;
			}
		}

		return 0;
	}
	else if ( errno == ENOENT )
	{
		// ʧܣźڣռ
		if ( (mutex = semget( key, RWMutexsNumber, IPC_CREAT|IPC_EXCL|0666 )) != -1 )
		{
			// ɹҪʼ
			struct semid_ds seminfo = {0};
			union semun argn = {0};
			
			argn.buf = &seminfo;
			argn.val = 1;
			
			for ( int i=0; i<RWMutexsNumber; i++ )
			{
				if ( semctl( mutex, i, SETVAL, argn ) == -1 )
				{
					// ʧ
					int nErr = errno;
					GDETrace( "ȴź[key=%x,id=%x]ʧ[err=%d][%s]", key, mutex, nErr, GetErrText(nErr) );
					return nErr;
				}
			}
			return 0;
		}
		else
		{
			// ʧ
			int nErr = errno;
			GDETrace( "ź[key=%x]ʧ[err=%d][%s]", key, nErr, GetErrText(nErr) );
			return nErr;
		}
	}
	else
	{
		// ʧ
		int nErr = errno;
		GDETrace( "ź[key=%x]ʧ[err=%d][%s]", key, nErr, GetErrText(nErr) );
		return nErr;
	}
}

long CProcessRWMutex::Initialize( key_t nKey )
{
	if ( -1 == nKey )
	{
		return -1;
	}

	m_semkey = nKey;
	
	/*
	IPC_CREAT: 򴴽µź򷵻Ѵڵź
	IPC_CREAT|IPC_EXCL򴴽µź򷵻ʧ
	IPC_EXCLû
	ʧܣ򷵻-1errno=EACCESS( ûȨ )
	EEXIST( źѾڣ޷ )
	EIDRM( źѾɾ )
	ENOENT( źڣͬʱûʹIPC_CREAT )
	ENOMEM( û㹻ڴ洴µź )
	ENOSPC(  )
	*/
	
	long nRet = -1;

	nRet = GetSem( m_semkey, m_rwMutexs );
	if ( nRet )
	{
		return nRet;
	}

	return 0;
}


long CProcessRWMutex::Uninitialize()
{
	if ( -1 != m_rwMutexs )
	{
		for ( int i=0; i<RWMutexsNumber; i++ )
		{
			semctl( m_rwMutexs, i, IPC_RMID, 0 );
		}
		m_rwMutexs = -1;
	}

	return 0;
}


long CProcessRWMutex::Lock( enumLockMode LockMode, unsigned long ms )
{
	// ûгʼʼ
	if ( NULL == m_rwMutexs )
	{
		long nRet = Initialize( m_semkey );
		if ( nRet )
		{
			return nRet;
		}
	}

	if ( LOCK_EXCL == LockMode )
	{
		P( RWMutex );
		P( WMutex );
	}
	else // ( LOCK_SHAR == LockMode )
	{
		P( RWMutex );
		P( RMutex );
		if ( INC() == 1 )
		{
			P( WMutex );
		}
		V( RMutex );
		V( RWMutex );
	}

	m_LockMode = LockMode;
	return 0;
}

long CProcessRWMutex::Unlock()
{
	if ( LOCK_EXCL == m_LockMode )
	{
		V( WMutex );
		V( RWMutex );
	}
	else // ( LOCK_SHAR == m_LockMode )
	{
		P( RMutex );
		if ( DEC() == 0 )
		{
			V( WMutex );
		}
		V( RMutex );
	}

	return NO_ERROR;
}

long CProcessRWMutex::P( int nIndex )
{
	struct sembuf askfor_res = {0};
	askfor_res.sem_num = nIndex;
	askfor_res.sem_op = -1;
	askfor_res.sem_flg = SEM_UNDO;
	int nErr = -1;
	do
	{
		nErr = semop( m_rwMutexs, &askfor_res, 1 );
	} while ( nErr && errno==EINTR );

	return nErr;
}

long CProcessRWMutex::V( int nIndex )
{
	struct sembuf free_res = {0};
	free_res.sem_num = nIndex;
	free_res.sem_op = 1;
	free_res.sem_flg = SEM_UNDO;
	return semop( m_rwMutexs, &free_res, 1 );
}

long CProcessRWMutex::INC()
{
	long semval = 0;
	union semun argn = {0};
	struct semid_ds seminfo = {0};

	semval = semctl( m_rwMutexs, CountMutex, GETVAL, 0 );

	semval ++;

	argn.buf = &seminfo;
	argn.val = semval;
	semctl( m_rwMutexs, CountMutex, SETVAL, argn );

	return semval;
}

long CProcessRWMutex::DEC()
{
	long semval = 0;
	union semun argn = {0};
	struct semid_ds seminfo = {0};

	semval = semctl( m_rwMutexs, CountMutex, GETVAL, 0 );
	semval --;

	argn.buf = &seminfo;
	argn.val = semval;
	semctl( m_rwMutexs, CountMutex, SETVAL, argn );

	return semval;
}


int CProcessRWMutex::GetValue( int nIndex )
{
	int nValue = semctl( m_rwMutexs, nIndex, GETVAL, 0 );
	if ( -1 == nValue )
	{
		GDETrace( "GetValue(%d,%d) return %d err=[%d]", m_rwMutexs, nIndex, nValue, errno );
	}
	else
	{
		//GDETrace( "GetValue(%d,%d) return %x", m_rwMutexs, nIndex, nValue );
	}
	return nValue;
}

int CProcessRWMutex::SetValue( int nIndex, int nValue )
{
	union semun argn = {0};
	struct semid_ds seminfo = {0};

	argn.buf = &seminfo;
	argn.val = nValue;

	int nRet = semctl( m_rwMutexs, nIndex, SETVAL, argn );
	if ( -1 == nRet )
	{
		GDETrace( "SetValue(%d,%d,%x) return %d err=[%d]", m_rwMutexs, nIndex, nValue, nRet, errno );
	}
	else
	{
		//GDETrace( "SetValue(%d,%d,%x) return %d", m_rwMutexs, nIndex, nValue, nRet );
	}
	return nRet;
}
