/***********************************************************************
*
* ļ        GDTrace.cpp
* ģĿģ¼־
* ߼ڣ  wang_jin 2009-03-01
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼	  
*
***********************************************************************/

#pragma warning ( disable : 4251 4786 )

#include "GDLog/GDTrace.h"
#include "GDLog/ThreadData.h"
#include "GDTraceEx.h"
#include <assert.h>
#include <stdarg.h>

#ifndef NO_ERROR
#	define NO_ERROR 0
#endif


enumLogLevel CGDTrace::m_nLevel = LOG_L6; // Ĭ־
int CGDTrace::m_nFileSize = 8; // MBytes
int CGDTrace::m_nFileCount = 9;
bool CGDTrace::m_bScroll = false;

CGDTrace::CGDTrace( enumLogLevel level, const char* fmt, ... )
: m_bLog(false)
{
	// ʼ־ã
	if ( CLogConfig::GetLogConfig( "" ) )
	{
		m_bLog = true;
	}
	
	if ( !m_bLog ) return;
	
	m_nCurLevel = level;
	if ( m_nLevel < m_nCurLevel ) return;

	// ¼
	m_sMethodName = fmt;
	m_sMethodName = m_sMethodName.substr( 0, m_sMethodName.find( '(', 0 ) );
	m_sOutParam = "-";

	// ¼־
	va_list args;
	va_start( args, fmt );
	CGDTraceEx::TraceIn( level, fmt, args );
	va_end( args );
}

CGDTrace::~CGDTrace()
{
	if ( !m_bLog ) return;
	if ( m_nLevel < m_nCurLevel ) return;
	
	// ¼־
	if ( ! m_sMethodName.empty() )
	{
		if ( ! m_sRetValue.empty() )
		{
			CGDTraceEx::TraceOut( LOG_INF, "%s(%s) return(%s)", m_sMethodName.c_str(), m_sOutParam.c_str(), m_sRetValue.c_str() );
		}
		else
		{
			CGDTraceEx::TraceOut( LOG_INF, "%s(%s)", m_sMethodName.c_str(), m_sOutParam.c_str() );
		}
	}
	else
	{
		CGDTraceEx::TraceOut( LOG_INF, "NoneName(-)" );
	}
}

void CGDTrace::GDTrace( enumLogLevel level, const char* fmt, ... )
{
	if ( m_nLevel < level ) return;
	
	// ¼־
	va_list args;
	va_start( args, fmt );
	CGDTraceEx::Trace( level, fmt, args );
	va_end( args );
}

void CGDTrace::SetOutParam( const char *format, ... )
{
	char sBuff[ 2048 ] = {0};

	va_list argList;
	va_start( argList, format );
	try	{ vsprintf( sBuff, format, argList ); } catch (...)
	{
		m_sOutParam = m_sMethodName; // ־ֺǶףʾز(>2048)
	}
	va_end( argList );

	m_sOutParam = sBuff;
}

bool CGDTrace::SetRetResult( bool bRet )
{
	if ( bRet )
		m_sRetValue = "true";
	else
		m_sRetValue = "false";

	return bRet;
}

string GetInforGuardReturnText( long nRet )
{
	char szTmp[32] = {0};

	switch ( nRet )
	{
	case NO_ERROR:
		return "NO_ERROR";
	case 8000:
		return "OK";
	case 8001:
		return "NOT_MATCH";
	case 8002:
		return "FILE_WITHOUT_MARK";
	case 8003:
		return "MARK_WITHOUT_FILE";
	case 8004:
		return "WITHOUT_BOTH";
	case 8005:
		return "FILE_ERROR";
	case 8006:
		return "MARK_ERROR";
	case 8007:
		return "BOTH_ERROR";
	case 8008:
		return "FILE_TRANING";
	default:
		sprintf( szTmp, "%d", nRet );
		return szTmp;
	}
}

long CGDTrace::SetRetValue( long nRet )
{
	m_sRetValue = GetInforGuardReturnText( nRet );

	return nRet;
}

const char* CGDTrace::SetRetText( const char* sRet )
{
	if ( sRet == NULL )
	{
		m_sRetValue = "NULL";
	}
	else
	{
		m_sRetValue = sRet;
	}
	
	return sRet;
}
