/***********************************************************************
*
* ļ			mod_guard.c
* ģĿģ	ʵlighttpd
* ߼ڣ	wang_jin 2009-10-12
* 汾			1.0
* ȨϢ		CVICSE Middleware
* ļ¼ 
*
***********************************************************************/

#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <iconv.h>

#include "base.h"
#include "log.h"
#include "buffer.h"

#include "plugin.h"

/************************************************************************/
/* InforGuard Start                                                     */
/************************************************************************/
#include <stdio.h>
#include <stdarg.h>
#include <time.h> /*64λ£Уcorestrftime()*/
#include <sys/stat.h>
#include <errno.h>
#ifndef WIN32
#	include <unistd.h> /* for readlink*/
#	include <ctype.h>
#endif

#ifdef HPUX
#	include <pthread.h>
#endif

#define bool unsigned char
#define false (char)0
#define true (char)1

#include "FileOpt/FileOptDef.h"
#include "GDVerifier/GDVerifier.h"

#define DEFAULT_TMPLOG_FILENAME "gd-apache.log"
#define TIME_LENGTH 32
#define MAX_SIZE 1048576

#ifndef GD_MAX_PATH
#	define GD_MAX_PATH 521
#endif

/* ʱ־*/
void TmpLog( const char* fmt, ... )
{
    char tmplog_path[ GD_MAX_PATH ] = {0};
    FILE *tmp_logfile = NULL;
    
#ifndef _WIN32
    sprintf( tmplog_path, "/tmp/%s", DEFAULT_TMPLOG_FILENAME );
#else
    sprintf( tmplog_path, "C:\\tmp\\%s", DEFAULT_TMPLOG_FILENAME );
#endif
	
    {
        /* жʱļ */
        struct stat statbuf;
        memset(&statbuf, 0, sizeof(statbuf));
        if( !stat(tmplog_path, &statbuf) )
        {
            if( statbuf.st_size > MAX_SIZE )
            {
                FILE* tmp_log = fopen(tmplog_path, "w");
                if( tmp_log )
                {
                    fclose(tmp_log);
                    tmp_log = NULL;
                }
            }
        }
    }
	
    tmp_logfile = fopen( tmplog_path, "a+" );
    if( tmp_logfile )
    {
        time_t nowtime = 0;
        struct tm * ptm = NULL;
        char time_string[ TIME_LENGTH ] = {0};
        
        va_list args;
        va_start( args, fmt );
        
        nowtime = time( NULL );
        ptm = localtime( &nowtime );

        /* Format is month day hour:minute:second (24 time) */
#if 1
        strftime( time_string, TIME_LENGTH, "%b %d %H:%M:%S", ptm );
#else
        sprintf( time_string, "%02d-%02d %02d:%02d:%02d", ptm->tm_mon+1, ptm->tm_mday, ptm->tm_hour, ptm->tm_min, ptm->tm_sec );
#endif
        
#if defined _WIN32
        fprintf( tmp_logfile, "%s [%u] - ", time_string, GetCurrentThreadId() );
#else
        fprintf( tmp_logfile, "%s [%u] - ", time_string, pthread_self() );
#endif
        
        vfprintf( tmp_logfile, fmt, args );
        va_end(args);
        
        fprintf( tmp_logfile, "\n" );
        fclose(tmp_logfile);
        tmp_logfile = NULL;
    }
}
/************************************************************************/
/* InforGuard End                                                       */
/************************************************************************/

typedef struct {
	array *index_file_list;
	buffer *error_handler_404;
} plugin_config;

typedef struct {
	PLUGIN_DATA;

	plugin_config **config_storage;

	plugin_config conf;
} plugin_data;

INIT_FUNC(mod_guard_init) {
	plugin_data *p;
	
	p = calloc(1, sizeof(*p));

	// ݾ崦
	p->conf.index_file_list = array_init();
	p->conf.error_handler_404 = buffer_init();
	
	return p;
}

FREE_FUNC(mod_guard_free) {
	plugin_data *p = p_d;

	UNUSED(srv);

	if (!p) return HANDLER_GO_ON;

	// ݾ崦
	if (p->config_storage) {
		size_t i;
		for (i = 0; i < srv->config_context->used; i++) {
			plugin_config *s = p->config_storage[i];
			
			array_free(s->index_file_list);
			buffer_free(s->error_handler_404);
			
			free(s);
		}
		free(p->config_storage);
	}
	
	free(p);

	return HANDLER_GO_ON;
}

SETDEFAULTS_FUNC(mod_guard_set_defaults) {
	plugin_data *p = p_d;
	size_t i = 0;

	config_values_t cv[] = {
		{ "index-file.names",			NULL, T_CONFIG_ARRAY,  T_CONFIG_SCOPE_CONNECTION }, /* 0 */
		{ "server.error-handler-404",	NULL, T_CONFIG_STRING, T_CONFIG_SCOPE_CONNECTION }, /* 1 */
		{ NULL,                         NULL, T_CONFIG_UNSET,  T_CONFIG_SCOPE_UNSET }
	};
	
	if (!p) return HANDLER_ERROR;
	
	p->config_storage = calloc(1, srv->config_context->used * sizeof(specific_config *));

	// ݾ崦
	for (i = 0; i < srv->config_context->used; i++) {
		plugin_config *s;
		
		s = calloc(1, sizeof(plugin_config));
		s->index_file_list = array_init();
		s->error_handler_404 = buffer_init();
		
		cv[0].destination = s->index_file_list;
		cv[1].destination = s->error_handler_404;
		
		p->config_storage[i] = s;
		
		if (0 != config_insert_values_global(srv, ((data_config *)srv->config_context->data[i])->value, cv)) {
			return HANDLER_ERROR;
		}
	}

	return HANDLER_GO_ON;
}

#define PATCH(x) p->conf.x = s->x;
static int mod_guard_patch_connection(server *srv, connection *con, plugin_data *p) {
	size_t i, j;
	plugin_config *s = p->config_storage[0];
	
	TmpLog( "mod_guard_patch_connection() callin" );

	// ݾ崦
	PATCH(index_file_list);
	PATCH(error_handler_404);

	/* skip the first, the global context */
	for (i = 1; i < srv->config_context->used; i++) {
		data_config *dc = (data_config *)srv->config_context->data[i];
		s = p->config_storage[i];
		
		/* condition didn't match */
		if (!config_check_cond(srv, con, dc)) continue;
		
		/* merge config */
		for (j = 0; j < dc->value->used; j++) {
			data_unset *du = dc->value->data[j];
			
			if (buffer_is_equal_string(du->key, CONST_STR_LEN("index-file.names"))) {
				PATCH(index_file_list);
			} else if (buffer_is_equal_string(du->key, CONST_STR_LEN("error-handler-404"))) {
				PATCH(error_handler_404);
			} 
		}
	}

	TmpLog( "mod_guard_patch_connection() callout" );
	
	return 0;
}
#undef PATCH

// ת:һֱתΪһֱ
int code_convert( char * from_charset, char * to_charset, char * inbuf, size_t inlen, char * outbuf, size_t outlen )
{
	iconv_t cd;
	int rc;
	char **pin = &inbuf;
	char **pout = &outbuf;
	
	cd = iconv_open(to_charset,from_charset);
	if (cd==0) return -1;
	memset(outbuf,0,outlen);
	if (iconv(cd,pin,&inlen,pout,&outlen)==-1) return -1;
	iconv_close(cd);
	return 0;
}
//UNICODEתΪGB2312
char* Unicode2Ansi(unsigned short unicode, char* outbuf, unsigned int inlen, unsigned int outlen )
{
	char * inbuf = (char *)&unicode;
	code_convert("utf-8","gb2312",inbuf,inlen,outbuf,outlen);
	return outbuf;
}
//GB2312תΪUNICODE
char* Ansi2Unicode(char* inbuf, char * outbuf, unsigned int outlen)
{
	code_convert("gb2312","utf-8",inbuf,strlen(inbuf),outbuf,outlen);
	return outbuf;
}

bool ConvertUTF82ANSI( char* sUtf8, char* sAnsi, size_t outlen )
{
	int rc;
	iconv_t cd = iconv_open("gb2312","utf-8");
	if (cd==0) return false;
	
	// UNICODE to ANSI;
	{
		char **pin = (char**)&sUtf8;
		char **pout = (char**)&sAnsi;
		size_t inlen = strlen(sUtf8);
		if (iconv(cd,pin,&inlen,pout,&outlen)==-1)
		{
			int eno = errno;
			TmpLog( "iconv() return(-1)[%d][%s]", eno, strerror(eno) );
			TmpLog( "%02x %02x %02x", sUtf8[0], sUtf8[1], sUtf8[2] );
			return -1;
		}
		TmpLog( "iconv() return(%s)", sAnsi );
	}

	iconv_close(cd);

	return true;
}

PHYSICALPATH_FUNC(mod_guard_url_handler) {
	plugin_data *p = p_d;

	char filename[520] = {0};
	char rootpath[520] = {0};
	int nRet = 0;
	int k;
	
	TmpLog( "mod_guard_url_handler() callin" );
	
	if (con->physical.path->used == 0) return HANDLER_GO_ON;

	mod_guard_patch_connection(srv, con, p);
	
	/*
	TmpLog( "request=[%s][URI:%s][ORIG-URI:%s][%d][%d][%s][%s][%s][%s]", 
		con->request.request->ptr, 
		con->request.uri->ptr, 
		con->request.orig_uri->ptr, 
		con->request.http_method, 
		con->request.http_version, 
		con->request.request_line->ptr, 
		con->request.http_range, 
		con->request.http_content_type, 
		con->request.pathinfo->ptr
		);
	TmpLog( "request_uri=[%s][%s][PATH:%s][PATH-RAW:%s][%s]", 
		con->uri.scheme->ptr,
		con->uri.authority->ptr,
		con->uri.path->ptr,
		con->uri.path_raw->ptr,
		con->uri.query->ptr
		);
	*/
	TmpLog( "physical=[PATH:%s][DIR:%s][ROOT:%s][REL-PATH:%s][%s]", 
		con->physical.path->ptr,
		con->physical.basedir->ptr,
		con->physical.doc_root->ptr,
		con->physical.rel_path->ptr,
		con->physical.etag->ptr
		);

#if 0
	/* жǷĿ¼ */
	if ( memcmp( con->physical.path->ptr, con->physical.basedir->ptr, con->physical.basedir->size ) != 0 )
	{
		/* Ŀ¼ */
		strncpy( rootpath, con->physical.path->ptr, con->physical.path->size - con->request.uri->size );
	}
	else
	{
		/* Ŀ¼ */
		strcpy( rootpath, con->physical.basedir->ptr );
	}
#endif

	/* ת */
#if 0
    TmpLog("UTF8:%s,%s",con->physical.path->ptr,con->physical.basedir->ptr);
	ConvertUTF82ANSI( con->physical.path->ptr, filename, sizeof(filename) );
	ConvertUTF82ANSI( con->physical.basedir->ptr, rootpath, sizeof(rootpath) );
    TmpLog("ANSI:%s,%s",filename,rootpath);
#else
	strcpy( filename, con->physical.path->ptr );
	strcpy( rootpath, con->physical.basedir->ptr );
#endif
	TmpLog( "file=%s;root=%s", filename, rootpath );

	/* ȻжǷָļƷ*/
	if ( filename[ strlen(filename) - 1 ] == '/' ) /* ĬҳĿ¼ҳ*/
	{
		/* ֤ҳ*/
		int k;
		for (k = 0; k < p->conf.index_file_list->used; k++)
		{
			char sDefaultPage[GD_MAX_PATH] = {0};
			data_string *ds = (data_string *)p->conf.index_file_list->data[k];
			if (ds->value->used == 0) continue;
			TmpLog( "index-file=[%s]", ds->value->ptr );

			strcpy( sDefaultPage, filename );
			strcat( sDefaultPage, ds->value->ptr );

			if ( k == 0 )
			{
				TmpLog( "mod_guard_url_handler1(%s,%s)", sDefaultPage, rootpath );
				nRet = Verify( 'A', sDefaultPage, rootpath );
			}
			else if ( nRet == 40404 )
			{
				TmpLog( "mod_guard_url_handler2(%s,%s)", sDefaultPage, rootpath );
				nRet = Verify( 'A', sDefaultPage, rootpath );
			}
			else
			{
				TmpLog( "mod_guard_url_handler3(%s,%s)", sDefaultPage, rootpath );
				Verify( 'A', sDefaultPage, rootpath );
			}
		}
	}
	else
	{
		TmpLog( "mod_guard_url_handler(%s,%s)", filename, rootpath );
		nRet = Verify( 'A', filename, rootpath );
	}
	
	if ( nRet && nRet != 40404 ) /*40404 ʾļ*/
	{
		TmpLog( "mod_guard_url_handler() callout1" );
		con->http_status = 403;
		return HANDLER_FINISHED;
	}
	TmpLog( "mod_guard_url_handler() callout2" );
	return HANDLER_GO_ON;
}

int mod_guard_plugin_init(plugin *p) {
	//TmpLog( "mod_guard_plugin_init() callin" );
	p->version     = LIGHTTPD_VERSION_ID;
	p->name        = buffer_init_string("guard");

	p->init        = mod_guard_init;
	p->cleanup     = mod_guard_free;
	p->set_defaults = mod_guard_set_defaults;
	p->handle_physical  = mod_guard_url_handler;

	p->data        = NULL;

	//TmpLog( "mod_guard_plugin_init() callout" );
	return 0;
}
