// NetFileTree_impl.cpp

#pragma warning( disable: 4786 )

#include <STAR/CORBA.h>

#include "Base/FileListEx.h"
#include "Base/Toolbox.h"
#include "Base/NetTran.h"
#include "Common/GDString.h"
#include "FileOpt/FileOpt.h"
#include "GDLog/ThreadData.h"
#include "GDLog/GDTrace.h"
#include "NetDirectory/NetDirectory_impl.h"

using namespace InforGuard;


void NetDirectory_impl::Check() throw(InforGuard::ExceptionError)
{
	return; // ʲôҲ·
}

CORBA::Long NetDirectory_impl::GetTree(InforGuard::netCallData& callData, 
								const InforGuard::HostChain& seqIpPort,
								const char* sTopFile,
								CORBA::Long mode,
								InforGuard::NetFileTreeNode_out treenode)
								throw(InforGuard::ExceptionError)
{
	assert( 0 );
	return 0;
}

CORBA::Long NetDirectory_impl::GetList(InforGuard::netCallData& callData, 
								const InforGuard::HostChain& seqIpPort,
								const char* sTopFile,
								CORBA::Long mode,
								InforGuard::NetFileList_out filelist)
								throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "dirserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sParam;
	sParam = sParam 
		+ "seqIpPort[" + CNetTran::HostChainToString(seqIpPort)
		+ "]sTopFile[" + sTopFile
		+ "]mode[" + CGDString::ltoa( mode )
		+ "]";

	CGDTrace trace( LOG_L6, "NetDirectory_impl:GetList(%s)", sParam.c_str() );

	CORBA::Long nRet = 0;
	try
	{
		// жǷ
		char sRealPath[GD_MAX_PATH] = {0};
		if ( CFileOpt::IsLink(sTopFile, sRealPath) )
		{
			// ӣͬ
			string sDstFileReal = sRealPath;
			string sDstFileLink = sTopFile;
			// by wang_jin at 2009-02-28
			sDstFileReal += "|";
			sDstFileReal += sDstFileLink;

			filelist = new NetFileList;
 			filelist->length(1);

            NetFileListNode curnode;
            curnode.name = CORBA::string_dup(sDstFileReal.c_str());
            curnode.size = 0;
            curnode.time = 0;
            curnode.isfolder = false;

			filelist[0] = curnode;
			trace.GDTrace( LOG_NOT, "GetList() return [50505] [%s]", sDstFileReal.c_str() );

			return trace.SetRetValue( 0 ); // طϢ
		}

		nRet = GetFileList(callData, seqIpPort, sTopFile, mode, filelist);

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{		
		ex.AddErrText( "NetDirectory_impl:GetList(%s,%x)", sTopFile, mode );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	return nRet;
}

// ǰ̨
CORBA::Long NetDirectory_impl::GetTreeEx(const InforGuard::HostChain& seqIpPort,
								const char* sTopFile,
								CORBA::Long mode,
								InforGuard::NetFileTreeNode_out treenode)
								throw(InforGuard::ExceptionError)
{
	InforGuard::netCallData callData;
	callData.nIndent = 0;
	callData.nRecSerial = 0;
	callData.nSerial = 0;
	callData.nSubSerial = 0;
	callData.nThreadId = 0;
	callData.sIp = CORBA::string_dup("");
	callData.sPort = CORBA::string_dup("");

	CORBA::Long nRet = 0;
	try
	{
		nRet = GetTree( callData, seqIpPort, sTopFile, mode, treenode );

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{		
		ex.AddErrText( "NetDirectory_impl:GetTreeEx(%s,%x)", sTopFile, mode );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	return nRet;
}

// ǰ̨
CORBA::Long NetDirectory_impl::GetListEx(const InforGuard::HostChain& seqIpPort,
								const char* sTopFile,
								CORBA::Long mode,
								InforGuard::NetFileList_out filelist)
								throw(InforGuard::ExceptionError)
{
	InforGuard::netCallData callData;
	callData.nIndent = 0;
	callData.nRecSerial = 0;
	callData.nSerial = 0;
	callData.nSubSerial = 0;
	callData.nThreadId = 0;
	callData.sIp = CORBA::string_dup("");
	callData.sPort = CORBA::string_dup("");

	CORBA::Long nRet = 0;
	try
	{
		nRet = GetFileList(callData, seqIpPort, sTopFile, mode, filelist, true );

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{		
		ex.AddErrText( "NetDirectory_impl:GetListEx(%s,%x)", sTopFile, mode );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}

	return nRet;
}


CORBA::Long NetDirectory_impl::GetFileList(InforGuard::netCallData& callData, 
								const InforGuard::HostChain& seqIpPort,
								const char* sTopFile,
								CORBA::Long mode,
								InforGuard::NetFileList_out filelist,
								bool bSort )
								throw(InforGuard::ExceptionError)
{
	CThreadData threadData;
	CThreadData::SetCurrentThreadLogFile( "dirserver", true );
	CThreadData::SetThreadSerial( callData.nSerial, callData.nSubSerial, callData.nRecSerial );

	string sParam;
	sParam = sParam 
		+ "seqIpPort[" + CNetTran::HostChainToString(seqIpPort)
		+ "]sTopFile[" + sTopFile
		+ "]mode[" + CGDString::ltoa( mode )
		+ "]";

	CGDTrace trace( LOG_L6, "NetDirectory_impl:GetFileList(%s)", sParam.c_str() );


	string sToIp;
	string sToPort;
	CORBA::Long nRet = 0;
	FileList orifilelist;
	string sTmpTopFile = sTopFile;
	CGDString::MakeSureLocalPath( sTmpTopFile );
	
	try
	{
		// ת
		if (CNetTran::IsTransmit( seqIpPort, sToIp, sToPort ))
		{
			NetDirectory_var ref;
			CNetTran::GetNetDirectoryObject( sToIp.c_str(), sToPort.c_str(), ref );

			InforGuard::netCallData callData;
			CNetTran::InitNetCallData( callData );
			nRet = ref->GetList( callData, seqIpPort, sTopFile, mode, filelist );
			CThreadData::SetThreadSerial( callData.nRecSerial );
			return nRet;
		}
		
		nRet = CFileListEx().CreateListEx( sTmpTopFile.c_str(), orifilelist, CFileListEx::NO_POLICY, mode, bSort );

		CThreadData::GetThreadSerial( (long*)&callData.nRecSerial );
	}
	catch ( CExceptionError & ex )
	{		
		ex.AddErrText( "NetDirectory_impl:GetFileList(%s,%x)", sTopFile, mode );
		// ת쳣ʽ
		InforGuard::ExceptionError e;
		CNetTran::ConvertException(ex, e);
		e._raise();
	}
    catch( InforGuard::ExceptionError& ex )
    {
		ex._raise();
    }
	catch( const CORBA::Exception& ex )
	{
		CExceptionError ee;
		ee.AddErrText( ex._to_string() );
		ee.AddErrText( "NetDirectory_impl:GetFileList(%s,%x)", sTopFile, mode );
		// ׳쳣
		InforGuard::ExceptionError e;
		CNetTran::ConvertException( ee, e );
		e._raise();
	}
	
	filelist = new NetFileList;
	
	if ( nRet == 0 )
	{
		long nCount = orifilelist.size();
 		filelist->length(nCount);

		//תΪsequence洢б
		FileList::iterator iter;
		int i = 0;
		for ( iter = orifilelist.begin(); iter != orifilelist.end(); ++iter, i++ )  
		{
			string name = (*iter).name;
			long size = (*iter).size;
			long time = (*iter).time;
			bool bFolder = (*iter).isfolder;

            NetFileListNode curnode;
            curnode.name = CORBA::string_dup(name.c_str());
            curnode.size = size;
            curnode.time = time;
            curnode.isfolder = bFolder;

			filelist[i] = curnode;
		}
	}
	
	return nRet;
}