/***********************************************************************
*
* ļ  NofierLinux.cpp
* ģĿģڻȡļ¼
* ߼ڣ  wang_jin at 2009-08-29
* 汾 1.0
* ȨϢCVICSE Middleware
* ļ¼ zhang_quan 2009-09-01
*
***********************************************************************/

#include "NofierLinux.h"

#include "Common/Common.h"
#include "Common/ExceptionError.h"
#include "Common/ParamList.h"
#include "Common/DateTime.h"
#include "Common/GDTimer.h"
#include "Common/ConvertString.h"
#include "FileOpt/FileOpt.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/RunLog.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"

#include <assert.h>
#ifdef WIN32
#	include <process.h> // for _beginthreadex
#	include <windows.h>
#	include <algorithm> // for std::sort
#	include <sstream>
#else
#	define InterlockedIncrement atomic_inc
#endif

#	include <pthread.h> // added by zhangquan for threadPriorConfig function
#	include <sched.h>
#	include <iostream>

#define IN_MOVED_FT_FROM 0x00010000               //form
#define IN_MOVED_FT_TO   0x00100000               //to


using namespace std;

std::map<std::string, CNofier::CDirInfo*> CNofier::m_dirmap;

int dispThreadPriorityPolicy(pthread_attr_t *attr)
{
    int rs, policy;
    rs = pthread_attr_getschedpolicy( attr, &policy );
    assert( rs == 0 );
    switch ( policy )
    {
#ifndef NODEBUG
    	case SCHED_FIFO:
    	    cout << "policy = SCHED_FIFO" << endl;
        	break;

	    case SCHED_RR:
    	    cout << "policy = SCHED_RR" << endl;
            break;

   	    case SCHED_OTHER:
            cout << "policy = SCHED_OTHER" << endl;
            break;

    	default:
        	cout << "policy = UNKNOWN" << endl;
        	break;
#endif
    }
	return policy;
}

bool threadPriorityConfig( pthread_attr_t *attr, char cPrior )
{
    struct sched_param sched;
    int rs;
	int iDefPolicy = SCHED_RR;

	pthread_attr_init( attr );
	int policy = pthread_attr_getschedpolicy( attr, &policy );
	if (iDefPolicy != policy)
	{
		policy = iDefPolicy;
		pthread_attr_setschedpolicy( attr, policy );
	}
//	dispThreadPriorityPolicy(attr);

	int iPriority = -1;
	switch (cPrior)
	{
		case 'h':
			iPriority = sched_get_priority_max( policy );
			break;
		case 'm':
			break;
		case 'l':
			iPriority = sched_get_priority_min( policy );
			break;
		default:
			cout << "no appropriate priority params" << endl;
			break;
	}
	sched.sched_priority = iPriority;
	pthread_attr_setschedparam( attr, &sched );
//	dispThreadPriorityPolicy(attr);
	return false;
}

UINT CNofier::m_dwDefaultFlags = 0;
unsigned int CNofier::CDirInfo::ReadDirectoryChanges()
{
	// ִͬI/O
	ssize_t nRet = 0;
	do
	{
		nRet = read( m_fd, m_evtBuf.buffer + m_evtBuf.offset, MAX_BUFFER - m_evtBuf.offset );
		if ( nRet == -1 )
		{
			// GDPrint("EINTR=4?%d,EAGAIN=11?%d,EWOULDBLOCK=11?%d\n", EINTR,EAGAIN,EWOULDBLOCK );
			ErrCode dwErr = GetLastError();
			if ( dwErr == EWOULDBLOCK )
			{
				break;
			}
			else
			{
				CGDLog::WriteErrLog( "CNofier:CompletionRoutine() read() error[%d]", dwErr );
				GDPrint( "%d=read(%x,%d,%d) errno=[%d] errtext=[%s]\n", nRet, m_fd, m_evtBuf.offset, MAX_BUFFER - m_evtBuf.offset, dwErr, strerror(dwErr) );
			}
		}
	} while (nRet == -1 && (errno == EINTR || errno == EWOULDBLOCK));
	
	return nRet;
}


CNofier::CNofier()
{
	m_dwDefaultFlags = 
	//	IN_ACCESS |			// 1	File was accessed
		IN_MODIFY |			// 2	File was modified
	//	IN_ATTRIB |			// 4	Metadata changed
		IN_CLOSE_WRITE |	// 8	Writable file closed
	//	IN_CLOSE_NOWRITE |	// 10	Unwritable file closed
	//	IN_OPEN |			// 20	File was opened
		IN_MOVED_FROM |		// 40	File was moved from X
		IN_MOVED_TO |		// 80	File was moved to Y
		IN_CREATE |			// 100	Subfile was created
		IN_DELETE |			// 200	Subfile was deleted
		0;
	
	m_nMilliSeconds = 800; // ¼󣬹500Ϊ¼
}

void CNofier::SetEventFlag( UINT nFlags )
{
	CGDTrace trace( LOG_L6, "CNofier::SetEventFlag(%d)", nFlags );
	
	m_dwDefaultFlags = nFlags;
}

void CNofier::SetEventDelay( int ms )
{
	CGDTrace trace( LOG_L6, "CNofier::SetEventFlag(%d)", ms );
	
	if ( ms <= 0 ) ms = 100;
	else if ( ms > 30000 ) ms = 30000;
	
	m_nMilliSeconds = ms;
}

CNofier::~CNofier()
{
	if ( m_nThreads > 0 )
	{
		Uninitialize();
	}
	
	// ɾ
	map < string, CEventInfo* >::iterator iter;
	for ( iter = m_evtmap.begin(); iter != m_evtmap.end(); )
	{
		delete (CEventInfo*) ( *iter ).second;
		m_evtmap.erase( iter++ );
	}
	m_filter.clear();
}

// ʼʧ쳣һ˳
bool CNofier::Initialize( const char * sParams )
{
	CGDTrace trace( LOG_L6, "CNofier:Initialize(%s)", sParams );
	
	// Բ
	CParamList pl( sParams, "|" );
	if ( sParams && *sParams )
	{		
		this->SetEventDelay( pl.GetNumValue( "delay" ) );
	}
	SetEventFlag( m_dwDefaultFlags );
	
	// ̸߳(˫)
	m_nThreads = sysconf( _SC_NPROCESSORS_ONLN );
		GDPrint( "nThreads=[%d]\n", m_nThreads );
	
	// epoll
	m_nEPFD = epoll_create( MAX_EPOLL_EVENTS / 2 );
	//	m_nEPFD = epoll_create(256);
	if ( m_nEPFD < 0 )
	{
		ErrCode dwErr = GetLastError();
		assert(0);
		GDPrint( "epoll_create failed: [%d]\n", GetLastError() );
		return trace.SetRetResult( false );
	}
	
	pthread_mutex_init( &m_cs, NULL );
	
#ifndef NDEBUG // ʼԶ̹()
	if (!pl.GetStringValue( "viewerip" ).empty())
	{
		if ( m_queue.init( pl.GetStringValue( "viewerip" ).c_str(), pl.GetNumValue( "viewerport" ), 0 ) )
		{
			GDPrint( "ʼɹ\n" );
		}
	}		
#endif
	
	pthread_mutex_init( &m_mutex, NULL );
	int nRet = pthread_cond_init( &m_cond, NULL );
	if ( nRet < 0 )
	{
		ErrCode dwErr = GetLastError();
		assert(0);
		GDPrint( "CreateEvent Failed: [%d]\n", dwErr );
		close( m_nEPFD );
		return trace.SetRetResult( false );
	}
	
	pthread_t hThread;
	
	// ߳(ֻһ߳)
//	int nThreadId = 0;
	int nThreadId = pthread_create( &hThread, NULL, CNofier::FilterRoutine, (void*)this );
	if ( nThreadId )
	{
		ErrCode dwErr = GetLastError();
		assert(0);
		GDPrint( "pthread_create failed: [%d]\n", dwErr );
		close( m_nEPFD );
		return trace.SetRetValue( 0 );
	}
	pthread_cond_wait( &m_cond, &m_mutex );
	
	
	// ߳(߳)
	//	GDPrint( "pThreadNo is %d\n", m_nThreads );
	for ( int ii=0; ii<m_nThreads; ii++ )
	{
		nThreadId = pthread_create( &hThread, NULL, CNofier::CompletionRoutine, (void*)this );
		if ( nThreadId )
		{
			ErrCode dwErr = GetLastError();
			assert(0);
			
			GDPrint( "pthread_create failed: [%d]\n", GetLastError() );
			close( m_nEPFD );
			return trace.SetRetResult( false );
		}
		
	}
	
	return trace.SetRetResult( true );
}

bool CNofier::WatchDirectory( CMonitorInformation& moniInfo )
{
	CGDTrace trace( LOG_L6, "CNofier:WatchDirectory(%s)", moniInfo.m_monitorPath.c_str() );

GDPrint("CNofier:watch dir [%s]\n", GetAppName());	
	
	// жǷѾ
	map< string, CDirInfo* >::iterator it = m_dirmap.find( moniInfo.m_sDirId );
	if ( it == m_dirmap.end() )
	{
//		GDPrint("watch dir =[%s]", moniInfo.m_monitorPath.c_str());
		CDirInfo* pDirInfo = new CDirInfo( moniInfo, m_dwDefaultFlags );
		strcpy( pDirInfo->m_szDirId, moniInfo.m_sDirId.c_str() );			//ӼĿ¼ID
		if ( pDirInfo )
		{
			if ( pDirInfo->StartMonitor( m_nEPFD ) )
			{
				m_dirmap.insert( make_pair( moniInfo.m_sDirId, pDirInfo ) );
				return trace.SetRetResult( true );
			}
			
			delete pDirInfo;
			pDirInfo = NULL;
		}
	}
	else
	{
		// Ŀ¼
		CDirInfo* pDirInfo = it->second;
		pDirInfo->SetPolicy( moniInfo );
	}
	
	return trace.SetRetResult( false );
}

bool CNofier::UnwatchDirectory( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CNofier:UnwatchDirectory(%s)", sDirId );
GDPrint("CNofier:un watch dir [%s]", GetAppName());	

	CDirInfo* pDirInfo = NULL;
	map < string, CDirInfo* >::iterator iter = m_dirmap.find( string(sDirId) );
	
	if ( iter != m_dirmap.end() )
	{
		pDirInfo = (CDirInfo*) iter->second;
		if ( pDirInfo->StopMonitor( m_nEPFD ) )
		{
			m_dirmap.erase( iter );
			delete pDirInfo;
			pDirInfo = NULL;
			return trace.SetRetResult( true );
		}
	}
	
	return trace.SetRetResult( false );
}

bool CNofier::Uninitialize()
{
	// ɺtrace
	CGDTrace trace( LOG_L6, "CNofier:Uninitialize()" );
	
	// ֪ͨ¼ȡ߳˳
	for ( int i=0; i<m_nThreads; i++ )
	{
	}
	
	// ֪ͨ¼߳˳
	m_bWorking = false;
	pthread_cond_wait( &m_cond, &m_mutex );
	
	pthread_cond_destroy( &m_cond );
	pthread_mutex_destroy( &m_mutex );
	
	close( m_nEPFD );
	m_nEPFD = 0;
	
	CDirInfo* pDirInfo = NULL;
	map < string, CDirInfo* >::iterator iter;
	for ( iter = m_dirmap.begin(); iter != m_dirmap.end(); ++iter )  
	{
		pDirInfo = (CDirInfo*) ( (*iter).second );
		if ( pDirInfo )
		{
			delete pDirInfo;
			pDirInfo = NULL;
		}
	}
	m_dirmap.clear();
	
	return trace.SetRetResult( true );
}

bool CNofier::IsWatchingDirectory( const char * szDir )
{
	CGDTrace trace( LOG_L6, "CNofier:IsWatchingDirectory(%s)", szDir );
	
	bool bRet = false;
	
	CDirInfo* pDirInfo = NULL;
	map < string, CDirInfo* >::iterator iter = m_dirmap.begin();
	while( iter != m_dirmap.end() )
	{
		pDirInfo = (CDirInfo*)iter->second;
		trace.GDTrace( LOG_L6, "IsWatchingDirectory([%s<-->%s][%s]", szDir, pDirInfo->m_szDir, pDirInfo->m_szDirId );
		if( strncmp(szDir, pDirInfo->m_szDir, strlen(pDirInfo->m_szDir)) == 0 )
		{
			bRet = true;
			break;
		}
		iter++;
	}
	
	return trace.SetRetResult(bRet);
}

bool CNofier::IsWatched( const char* sDirId )
{
    CGDTrace trace( LOG_L6, "CNofier:IsWatched(%s)", sDirId );
	
    // жǷѾ
    if ( sDirId[0] == '/' || sDirId[1] == ':' )
    {
        return trace.SetRetResult( IsWatchingDirectory( sDirId ) ); // ͨĿ¼жǷ(MA˲֧ظ)
    }
    std::map<std::string, CDirInfo*>::iterator iter = m_dirmap.find( sDirId );
    if ( iter == m_dirmap.end() ) // ûнĿ¼ض
    {
        return trace.SetRetResult( false );
    }
    else
    {
        return trace.SetRetResult( true );
    }
}

bool CNofier::IsWatchedByWebsiteId( const char * sWebsiteId )
{
    CGDTrace trace( LOG_L6, "CFileDiffer:IsWatchedByWebsiteId(%s)", sWebsiteId );
	
    // жǷѾ
    bool bRet = false;
	
    CDirInfo* pDirInfo = NULL;
    map < string, CDirInfo* >::iterator iter = m_dirmap.begin();
    while( iter != m_dirmap.end() )
    {
        pDirInfo = (CDirInfo*)iter->second;
        if( strcmp( sWebsiteId, pDirInfo->m_szDirId ) == 0 )
        {
            bRet = true;
            break;
        }
        iter++;
    }
    if ( !bRet ) // ûнĿ¼ض
    {
        return trace.SetRetResult( false );
    }
    else
    {
        return trace.SetRetResult( bRet );
    }
}

bool CNofier::GetMonitorEvent( EVENT_S& evt )
{
	// ȡ¼
	CEventInfo ei;
	if ( ! m_queue.pop_front( ei ) )
	{
		return false;
	}
	
	// 
	evt.event_type = ei.m_nAction;
	evt.attr_flag  = ei.m_nAttribute;
	evt.bInner     = ei.bInner;
	memcpy( &evt.evt_time, &ei.m_time, sizeof(GDDateTime) );
	strcpy( evt.o_filepath, ei.m_szFileName );
	strcpy( evt.n_filepath, ei.m_newFileName );
	//Ŀ¼ID by wu_bin
	strcpy( evt.sDirId, ei.m_szDirId );
	
	//ɺtrace
	string sMoniInfo = evt.toString();
	
	CGDTrace trace( LOG_L6, "CNofier:GetMonitorEvent(%s)", sMoniInfo.c_str() );
#ifdef WIN32
#ifndef NDEBUG
	if ( evt.event_type == MONITOR_EVENT_NOFIER_CREATE )
	{
		::InterlockedIncrement( &GnuAddCount[5] );
	}
	else if ( evt.event_type == MONITOR_EVENT_NOFIER_DELETE )
	{
		::InterlockedIncrement( &GnuRemoveCount[5] );
	}
	else if ( evt.event_type == MONITOR_EVENT_NOFIER_CHANGE )
	{
		::InterlockedIncrement( &GnuChangeCount[5] );
	}
	else if ( evt.event_type == MONITOR_EVENT_NOFIER_RENAME )
	{
		::InterlockedIncrement( &GnuRenameCount[5] );
	}
#endif
#endif
	return trace.SetRetResult( true );
}

void GetAnotherKey( string& sKey, const char * sOldFileName, const char * sNewFileName )
{
	int nFirstPos = sKey.find_last_of("/");
	
	if ( nFirstPos == string::npos )
	{
		nFirstPos = 0;
	}
	
	int nNameLen = sKey.length() - nFirstPos;
	int nNamePos = strlen(sOldFileName) - nNameLen;
	sKey.replace( nFirstPos, sKey.length(), sNewFileName + nNamePos );
}

// Ψһ߳ʵ¼ϲעⱣmaplistԪһԣ
// ¼˵
// ! ʾϵͳϱ¼
// $ ʾϱ¼
// + ʾϲ¼
// - ʾҺԵ¼
// . ʾֱӺԵ¼(Ŀ¼޸)
THREADPROC CNofier::FilterRoutine( void* lpParam )
{
	// watch־
	CThreadData::SetCurrentThreadLogFile( "watch", true ); // ߳()־
	
	// trace־
	CGDTrace trace( LOG_L6, "CNofier:FilterRoutine()" );
	
	CNofier* pNofier = (CNofier*)lpParam;
	string sNewKey;
	std::pair< std::map< string, CEventInfo* >::iterator, bool > ret;
	std::pair< std::map< __u32,  CEventInfo* >::iterator, bool > cookieRet;
	
	pthread_cond_signal( &pNofier->m_cond );
	
	CGDTimer watchTimer(30);  //üʱ
	CGDLog::WriteThreadState("CNofier:FilterRoutine started"); //wu_binд߳״̬
	// ˣǴӶж¼ɢбȴ¼ϲ˵ͬʱҪҪȴϲ¼¼
	
	map < string, CEventInfo* >::iterator mapiter;
	map < __u32, CEventInfo* >::iterator ckmapiter;
	pNofier->m_bWorking = true;
	while ( pNofier->m_bWorking )
	{
		if (watchTimer.IsTimeout())
		{
			CGDLog::WriteThreadState("CNofier:FilterRoutine loop-1 running(%d)...", watchTimer.GetMaxRunCount()); //wu_binд߳״̬
		}
		
		unsigned long dwNow = GetTickCount(); // ȡǰʱ䣬ںϲ¼ĩβ¼

		if ( ! pNofier->m_deque.empty() )
		{
			// 
			pthread_mutex_lock( &pNofier->m_cs );
			// ȡ
			CEventInfo* pei = (CEventInfo*)pNofier->m_deque.front();
			pNofier->m_deque.pop_front();
			// 
			pthread_mutex_unlock( &pNofier->m_cs );
			
			assert( pei->m_pFileExclude );
			dwNow = pei->m_nTickCount; // ȡʱ䣬ںϲ¼ʱԱ⴦ӳٲƫ
			
			// ѭΪ˶м״̬¼жκϲ
			while ( pei )
			{
				// ʼ¼
				CGDLog::WriteNofierEvent( "PEI:[%x][%s][%s][%s]", pei->m_nAction, pei->m_szKey, pei->m_szFileName, pei->m_newFileName );

				if (watchTimer.IsTimeout())
				{
					CGDLog::WriteThreadState("CNofier:FilterRoutine loop-2 running(%d)...", watchTimer.GetMaxRunCount()); //wu_binд߳״̬
				}

				CEventInfo* prv  = NULL;

				// ǰ¼
				mapiter = pNofier->m_evtmap.find( pei->m_szKey );
				if ( pNofier->m_evtmap.end() != mapiter )
				{
					// ǰ¼
					prv = (CEventInfo*)(mapiter->second);
					if ( !prv )
					{
						CGDLog::WriteNofierEvent("ERROR: NULL Pointer!!!");
						exit(-1);
					}
					// ǰ¼
					CGDLog::WriteNofierEvent( "PRV:[%x][%s][%s][%s]", prv->m_nAction, prv->m_szKey, prv->m_szFileName, prv->m_newFileName );
				}
				else
				{
					prv = NULL;
				}
				
				// Ŀ¼½ɾ¼
				if ( FILE_ATTRIBUTE_DIRECTORY == pei->m_nAttribute )
				{					
					if ( IN_CREATE == pei->m_nAction || IN_DELETE == pei->m_nAction )
					{
						// Ŀ¼½/ɾ¼ϲֱϱ½/ɾĿ¼
						if ( IN_CREATE == pei->m_nAction ) pei->m_nAction = MONITOR_EVENT_NOFIER_CREATE;
						if ( IN_DELETE == pei->m_nAction ) pei->m_nAction = MONITOR_EVENT_NOFIER_DELETE;
						
						// Ӧò
						try
						{
							if ( ! pei->m_pFileExclude->IsExcludeEvent( (eventType)pei->m_nAction, pei->m_szFileName ) )
							{
								pNofier->m_queue.push_back( *pei );
								CGDLog::WriteNofierEvent( "END:[%x][%s][%s]", pei->m_nAction, pei->m_szFileName, pei->m_newFileName );
							}
						}
						catch ( CExceptionError )
						{}
						catch ( ... )
						{}
						
						delete pei; // ɾԭʼ
						pei = NULL;
						
						// ǰ¼֮
						if ( prv )
						{
							CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction, prv->m_szFileName, prv->m_newFileName );
							pNofier->m_evtmap.erase( prv->m_szKey );
							pNofier->m_filter.remove( prv );
							delete prv;
							prv = NULL;
						}
						continue;
					}
				}

				if ( NULL == prv )
				{
					// ûǰ¼
					if ( IN_CLOSE_WRITE == pei->m_nAction )
					{
						// ֻйرд¼ʲôҲ˵ʲôҲ쳣
						delete pei;
						pei = NULL;
					}
					else
					{
						// ¼
						// ж¼ͣԴ
						if ( IN_MOVED_FROM == pei->m_nAction )
						{
							cookieRet = pNofier->m_cookiemap.insert( make_pair( pei->cookie, pei ) );
						}
						else if ( IN_MOVED_TO == pei->m_nAction )
						{
							ckmapiter= pNofier->m_cookiemap.find ( pei->cookie );
							
							if ( ckmapiter != pNofier->m_cookiemap.end() )
							{
								prv = (CEventInfo*)(ckmapiter->second);
								assert( prv->cookie == pei->cookie );
								assert( prv->m_nAction == IN_MOVED_FROM );
								pNofier->m_cookiemap.erase( prv->cookie );
								
								// ϳ
								prv->m_nAction = IN_MOVED_FROM|IN_MOVED_TO;
								strcpy( prv->m_newFileName, pei->m_szFileName );
								prv->m_nTickCount = pei->m_nTickCount;
								// ǰ(ֻ)
								ret = pNofier->m_evtmap.insert( make_pair( string( pei->m_szKey ), prv ) );
								delete pei;
								pei = NULL;
								// ǰ¼
								continue;
							}
						}

						ret = pNofier->m_evtmap.insert( make_pair( string( pei->m_szKey ), pei ) );
						if( ret.second )
						{
							pNofier->m_filter.push_back( pei ); // ¼
						}
						else
						{
							CGDLog::WriteErrLog( "2202:ϲ¼дʧ!" );
							mapiter = pNofier->m_evtmap.find( pei->m_szKey );
							if ( pNofier->m_evtmap.end() != mapiter )
							{
								assert(0);
							}
						}
					}
					pei = NULL;
					continue;
				}							
				
				// ǰ¼
				CGDLog::WriteNofierEvent( "CUR:[%x][%s][%s][%s]", pei->m_nAction, pei->m_szKey, pei->m_szFileName, pei->m_newFileName );

				// ж¼ͣԴ
				switch ( prv->m_nAction )
				{
					// ¼
				case IN_CREATE: // ǰ½
				case IN_CREATE|IN_CLOSE_WRITE:
					switch ( pei->m_nAction )
					{
					case IN_CREATE: // (ǰ½)ǰ()½ܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_DELETE: // (ǰ½)ǰɾġϲΪޡɾǰڣԵǰ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=0", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName);
						pNofier->m_evtmap.erase( prv->m_szKey );
						pNofier->m_filter.remove( prv );
						delete prv;
						prv = NULL;
						delete pei;
						pei = NULL;
						continue;
					case IN_MODIFY: // (ǰ½)ǰ޸ġԭ״½
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, prv->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_FROM: // (ǰ½)ǰƳϲΪޡɾǰڣԵǰ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=0", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName);
						pNofier->m_evtmap.erase( prv->m_szKey );
						pNofier->m_filter.remove( prv );
						delete prv;
						prv = NULL;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_TO: // (ǰ½)ǰ롪-ϲΪ½
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, prv->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_CLOSE_WRITE: // (ǰ½)ǰرա
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, prv->m_nAction | pei->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction |= pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					default:
						assert(0);
					}
					break;
				case IN_DELETE: // ǰɾ
					switch ( pei->m_nAction )
					{
					case IN_CREATE: 	// (ǰɾ)ǰ½ϲΪ޸
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MODIFY,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_MODIFY;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_TO: 	// (ǰɾ)ǰ롪ϲΪ޸
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MODIFY | IN_CLOSE_WRITE,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_MODIFY | IN_CLOSE_WRITE;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_FROM:	// (ǰɾ)ǰƳܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						prv->cookie = pei->cookie;
						cookieRet = pNofier->m_cookiemap.insert( make_pair( prv->cookie, prv ) );
						delete pei;
						pei = NULL;
						continue;
					case IN_DELETE:		// (ǰɾ)ǰɾܡǰ
					case IN_MODIFY:		// (ǰɾ)ǰ޸ġܡǰ
					case IN_CLOSE_WRITE:// (ǰɾ)ǰرաܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					default:
						assert(0);
					}
					break;
				case IN_MODIFY: // ǰ޸
				case IN_MODIFY|IN_CLOSE_WRITE:
					switch ( pei->m_nAction )
					{
					case IN_CREATE: // (ǰ޸)ǰ½ܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_DELETE: // (ǰ޸)ǰɾĵɾǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MODIFY: // (ǰ޸)ǰ޸ġԭ״޸
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, prv->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_FROM: // (ǰ޸)ǰƳϲ(ͨ)Ƴ(ͬɾ)
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_DELETE,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_DELETE;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_TO: // (ǰ޸)ǰ롪ϲΪ޸ġ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, prv->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_CLOSE_WRITE: // (ǰ޸)ǰرա
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, prv->m_nAction | pei->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction |= pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					default:
						assert(0);
					}
					break;
				case IN_MOVED_FROM: // ǰƳ
					switch ( pei->m_nAction )
					{
					case IN_CREATE: // (ǰƳ)ǰ½ϲΪ޸
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MODIFY,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_MODIFY;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_DELETE: // (ǰƳ)ǰɾܡǰ
					case IN_MODIFY: // (ǰƳ)ǰ޸ġܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_FROM: // (ǰƳ)ǰƳܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						prv->cookie = pei->cookie;
						cookieRet = pNofier->m_cookiemap.insert( make_pair( prv->cookie, prv ) );
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_TO: // (ǰƳ)ǰ롪ϲΪ޸
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MODIFY | IN_CLOSE_WRITE,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_MODIFY | IN_CLOSE_WRITE;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_CLOSE_WRITE: // (ǰƳ)ǰرաܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						pNofier->m_evtmap.erase( prv->m_szKey );
						pNofier->m_filter.remove( prv );
						pNofier->m_cookiemap.erase( prv->cookie );	
						delete prv;
						prv = NULL;
						delete pei;
						pei = NULL;
						continue;
					default:
						assert(0);
					}
					break;
				case IN_MOVED_TO: // ǰ
					switch ( pei->m_nAction )
					{
					case IN_CREATE:		// (ǰ)ǰ½ܡǰ
					case IN_MOVED_TO:	// (ǰ)ǰ롪пܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						prv->m_nAction = pei->m_nAction;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_DELETE: // (ǰ)ǰɾĵɾϲΪɾ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, pei->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_DELETE;
						delete pei;
						pei = NULL;
						continue;
					case IN_MODIFY: // (ǰ)ǰ޸ġϲΪ޸
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, pei->m_nAction,  prv->m_szFileName, prv->m_newFileName);
						prv->m_nAction = IN_MODIFY;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_MOVED_FROM: // (ǰ)ǰƳϲΪޡɾǰڣԵǰ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=0", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName );
						prv->m_nAction = IN_DELETE;
						prv->m_nTickCount = pei->m_nTickCount;
						delete pei;
						pei = NULL;
						continue;
					case IN_CLOSE_WRITE: // (ǰ)ǰرաܡǰ
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						pNofier->m_evtmap.erase( prv->m_szKey );
						pNofier->m_filter.remove( prv );
						delete prv;
						prv = NULL;
						delete pei;
						pei = NULL;
						continue;
					default:
						assert(0);
					}
					break;
					// ¼
				case IN_MOVED_FROM|IN_MOVED_TO: // ǰB->C
					// ע⴦KEY
					switch ( pei->m_nAction )
					{
					case IN_CREATE:		// (ǰ)ǰ½ӦǾļ޸ľļ+½ļ
						// ޸ľļ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s]+[%x][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MODIFY|IN_CLOSE_WRITE,  prv->m_szFileName, pei->m_nAction, prv->m_newFileName);
						prv->m_nAction = IN_MODIFY|IN_CLOSE_WRITE;
						prv->m_nTickCount = pei->m_nTickCount;
						strcpy( pei->m_szFileName, prv->m_newFileName );
						strcpy( prv->m_newFileName, "" );
						// ½ļ
						pei->m_nAction = IN_MODIFY|IN_CLOSE_WRITE;
						sNewKey = prv->m_szKey;
						GetAnotherKey( sNewKey, prv->m_szFileName, pei->m_szFileName );
						strcpy( pei->m_szKey, sNewKey.c_str() );
						// NEWKEY
						pNofier->m_evtmap.erase( sNewKey.c_str() );
						// ½¼
						continue;
					case IN_DELETE: // (ǰ)ǰɾӦļϲɾļ,ɾļ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s]+[%x][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_DELETE,  prv->m_szFileName, IN_DELETE, prv->m_newFileName);
						// NEWKEY
						pNofier->m_evtmap.erase( pei->m_szKey );
						// ɾļ
						prv->m_nAction = IN_DELETE;
						strcpy( prv->m_newFileName, "" );
						prv->m_nTickCount = pei->m_nTickCount;
						//ɾļ,peiΪɾ
						continue;
					case IN_MODIFY: // (ǰ)ǰ޸ġӦļɾļ+޸ļ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s]+[%x][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_DELETE,  prv->m_szFileName, IN_MODIFY | IN_CLOSE_WRITE, prv->m_newFileName);
						// NEWKEY
						pNofier->m_evtmap.erase( pei->m_szKey );
						// ɾļ
						prv->m_nAction = IN_DELETE;
						strcpy( prv->m_newFileName, "" );
						prv->m_nTickCount = pei->m_nTickCount;
						// ½ļ
						pei->m_nAction = IN_MODIFY | IN_CLOSE_WRITE;
						// ½¼
						continue;
					case IN_MOVED_FROM: // (ǰ)ǰƳӦļϲΪƳļ+ɾļ
						CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s]+[%x][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MOVED_FROM,  prv->m_szFileName, IN_DELETE, prv->m_newFileName);
						// NEWKEY
						pNofier->m_evtmap.erase( pei->m_szKey );
						// Ƴļ
						prv->m_nAction = IN_MOVED_FROM;
						strcpy( prv->m_newFileName, "" );
						prv->cookie = pei->cookie;
						cookieRet = pNofier->m_cookiemap.insert( make_pair( prv->cookie, prv ) );
						prv->m_nTickCount = pei->m_nTickCount;
						// ɾļ
						pei->m_nAction = IN_DELETE;
						pei->bInner = true;
						continue;
					case IN_MOVED_TO:	// (ǰ)ǰ롪Ǿļ(ųļ)޸ľļ+½ļ
						if ( strcmp( prv->m_szFileName, pei->m_szFileName ) == 0 )
						{
							//ļ 
							// ޸ľļ
							CGDLog::WriteNofierEvent( "+[%x][%s][%s]+[%x][%s][%s]=[%x][%s]+[%x][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName, pei->m_nAction,  pei->m_szFileName, pei->m_newFileName, IN_MODIFY|IN_CLOSE_WRITE,  prv->m_szFileName, IN_CREATE|IN_CLOSE_WRITE, prv->m_newFileName);
							prv->m_nAction = IN_MODIFY|IN_CLOSE_WRITE;
							prv->m_nTickCount = pei->m_nTickCount;
							strcpy( pei->m_szFileName, prv->m_newFileName );
							strcpy( prv->m_newFileName, "" );
							// ½ļ
							pei->m_nAction = IN_CREATE|IN_CLOSE_WRITE;
							sNewKey = prv->m_szKey;
							GetAnotherKey( sNewKey, prv->m_szFileName, pei->m_szFileName );
							strcpy( pei->m_szKey, sNewKey.c_str() );
							// NEWKEY
							pNofier->m_evtmap.erase( sNewKey.c_str() );
							// ½¼
							continue;
						}
						else //	ļ B->C; X->CɾB+޸->C
						{
							// OLDKEY
							sNewKey = prv->m_szKey;
							GetAnotherKey( sNewKey, prv->m_newFileName, prv->m_szFileName );
							pNofier->m_evtmap.erase( sNewKey.c_str() );
							//޸ļ	
							pei->m_nAction = IN_MODIFY | IN_CLOSE_WRITE;
							// ɾļ
							prv->m_nAction = IN_DELETE;
							strcpy( prv->m_newFileName, "" );
							prv->m_nTickCount = pei->m_nTickCount;
							// ǰ¼
							continue;
						}
					case IN_CLOSE_WRITE: // (ǰ)ǰرաܡǰ
						// NEWKEY
						CGDLog::WriteNofierEvent( "-[%x][%s][%s]", prv->m_nAction,  prv->m_szFileName, prv->m_newFileName );
						{
							sNewKey = prv->m_szKey;
							GetAnotherKey( sNewKey, prv->m_szFileName, prv->m_newFileName );
							pNofier->m_evtmap.erase( sNewKey.c_str() );
						}
						// ɾǰ
						pNofier->m_evtmap.erase( prv->m_szKey );
						pNofier->m_filter.remove( prv );
						delete prv;
						prv = NULL;
						// Եǰ
						delete pei;
						pei = NULL;
						continue;
					default:
						assert(0);
					}
					break;
				default:
					assert(0);
				}//switch
			}//while(pei)
		}//if
		else
		{
			// Ϣ
			GDMINSLEEP();
		}
		
		static unsigned long dwLastTime = GetTickCount();
		unsigned long dwCurrTime = GetTickCount();
		if ( dwLastTime + 300 <= dwCurrTime ) // 300һ¼
		{
			dwLastTime = dwCurrTime;
			
			// ˶
			CEventInfo* pei = NULL;
			while ( ! pNofier->m_filter.empty() )
			{
				pei = pNofier->m_filter.front();
				// жʱ
				if ( pei->m_nTickCount + pNofier->m_nMilliSeconds > dwNow )
				{
					// ʱ䲻
					break; 
				}
				
				if ( ( ( pei->m_nAction & IN_CREATE ) || ( pei->m_nAction & IN_MODIFY ) ) &&  !( pei->m_nAction & IN_CLOSE_WRITE ) )
				{
					pNofier->m_filter.pop_front();
					pei->m_nTickCount = GetTickCount();
					pNofier->m_filter.push_back( pei ); // ¼ĩβ
					break;
				}
				CGDLog::WriteNofierEvent( "OUT:[%x][%s][%s]", pei->m_nAction, pei->m_szFileName, pei->m_newFileName );
				pei->m_nAction &= (~IN_CLOSE_WRITE);
				
				// ʱˣ¼
				pNofier->m_filter.pop_front();
				pNofier->m_evtmap.erase( pei->m_szKey ); // ˴쳣by wang_jin at 2009-05-23
				
				// ж¼½Ŀ¼½ļɾĿ¼/ļ޸Ŀ¼޸ļĿ¼/ļ
				switch ( pei->m_nAction )
				{
				case IN_CREATE:
					pei->m_nAction = MONITOR_EVENT_NOFIER_CREATE;
					break;
				case IN_MOVED_TO:
					if ( FILE_ATTRIBUTE_DIRECTORY == pei->m_nAttribute )
					{
						pei->m_nAction = MONITOR_EVENT_NOFIER_CREATE;
					}
					else
					{	
						pei->m_nAction = MONITOR_EVENT_NOFIER_CHANGE;
					}
					break;
				case IN_DELETE:
					pei->m_nAction = MONITOR_EVENT_NOFIER_DELETE;
					break;
				case IN_MOVED_FROM:
					pNofier->m_cookiemap.erase(pei->cookie);	
					pei->m_nAction = MONITOR_EVENT_NOFIER_MOVEOUT;
					break;
				case IN_MODIFY:
					pei->m_nAction = MONITOR_EVENT_NOFIER_CHANGE;
					break;
				case IN_MOVED_FROM|IN_MOVED_TO:
					// NEWKEY
					{
						sNewKey = pei->m_szKey;
						GetAnotherKey( sNewKey, pei->m_szFileName, pei->m_newFileName );
						pNofier->m_evtmap.erase( sNewKey.c_str() );
					}
					pei->m_nAction = MONITOR_EVENT_NOFIER_RENAME;
					break;
				default:
					GDPrint( "δ֪¼[%d]", pei->m_nAction );
					CGDTrace::GDTrace( LOG_INF, "δ֪¼[%d]", pei->m_nAction );
					assert(0);
					break;
				}
				
				if ( pei )
				{
					// Ӧò
					try
					{
						bool bExclude = pei->m_pFileExclude->IsExcludeEvent( (eventType)pei->m_nAction, pei->m_szFileName );
						if ( bExclude && pei->m_nAction == MONITOR_EVENT_NOFIER_RENAME )
						{
							bExclude = pei->m_pFileExclude->IsExcludeEvent( (eventType)pei->m_nAction, pei->m_newFileName );			
						}	
						if ( !bExclude )
						{
							if ( ( true == pei->bInner ) && ( pei->m_nAction != IN_DELETE ) )
							{
								pei->bInner = false;
							}

							pNofier->m_queue.push_back( *pei );
							CGDLog::WriteNofierEvent( "END:[%x][%s][%s]", pei->m_nAction, pei->m_szFileName, pei->m_newFileName );
#ifdef WIN32
#ifndef NDEBUG
							if ( pei->m_nAction == MONITOR_EVENT_NOFIER_CREATE )
							{
								::InterlockedIncrement( &GnuAddCount[4] );
							}
							else if ( pei->m_nAction == MONITOR_EVENT_NOFIER_DELETE )
							{
								::InterlockedIncrement( &GnuRemoveCount[4] );
							}
							else if ( pei->m_nAction == MONITOR_EVENT_NOFIER_CHANGE )
							{
								::InterlockedIncrement( &GnuChangeCount[4] );
							}
							else if ( pei->m_nAction == MONITOR_EVENT_NOFIER_RENAME )
							{
								::InterlockedIncrement( &GnuRenameCount[4] );
							}
#endif
#endif
						}
					}
					catch ( CExceptionError )
					{
						//
					}
					catch ( ... )
					{
						//
					}
					// ɾ¼
					delete pei;
					pei = NULL;
				}// while ( ! pNofier->m_filter.empty() )
			}//for
		}//if
	}//while
	CGDLog::WriteThreadState("CNofier:FilterRoutine exited");//wu_binд߳״̬
	
	pthread_cond_signal( &pNofier->m_cond );
	
	return 0;
}

// ߳()˳(мͣزӰ)
THREADPROC CNofier::CompletionRoutine( void* lpParam )
{
	pthread_attr_t attr;
	threadPriorityConfig( &attr, 'h' );

	// nofier־
	CThreadData::SetCurrentThreadLogFile( "watch", true ); // ߳()־

	CGDTrace trace( LOG_L6, "CNofier:CompletionRoutine()" );
	
	CNofier* pNofier = (CNofier*)lpParam;
	
	int dwBytes = 0;
	epoll_event * events = (epoll_event*)new char[ sizeof(struct epoll_event) * MAX_EPOLL_EVENTS ];
	
	CGDTimer watchTimer(30);  //üʱ
	CGDLog::WriteThreadState("watch started"); //wu_binд߳״̬
	do
	{
		if (watchTimer.IsTimeout())
		{
			CGDLog::WriteThreadState("watch loop running(%d)...", watchTimer.GetMaxRunCount()); //wu_binд߳״̬
		}
		
#ifdef NDEBUG
#	define USE_TRY
#endif
		
#ifdef USE_TRY
		try
#endif
		{
			int nfds = epoll_wait( pNofier->m_nEPFD, events, MAX_EPOLL_EVENTS, -1 );
			if ( nfds <= 0 )
			{
				ErrCode dwErr = GetLastError();
#ifndef NDEBUG 
				GDPrint ( "epoll_wait() ret=[%d][%s]", dwErr, strerror(dwErr));
#endif
				CGDLog::WriteErrLog( "epoll_wait() ret=[%d]\n", nfds );
			}
			
			for ( int i=0; i<nfds; i++ )
			{
				CDirInfo * pDirInfo = (CDirInfo*)events[i].data.ptr;
				if ( ! pDirInfo )
				{
					assert(0);
					continue;
				}
				
				do
				{
					dwBytes = pDirInfo->ReadDirectoryChanges(); // ͬǰ
					
					if ( dwBytes > 0 )
					{
						if ( pDirInfo->m_evtBuf.offset )
						{
							dwBytes += pDirInfo->m_evtBuf.offset;
							pDirInfo->m_evtBuf.offset = 0;
						}
						ParseEvent( pNofier, pDirInfo, dwBytes );
					}
				} while ( dwBytes > 0 );
			}
		}
#ifdef USE_TRY
		catch ( ... )
		{
			CGDLog::WriteErrLog( "1082:CNofier:CompletionRoutine() catch ..." );
		}
#endif
		// while ( pDirInfo  );
	} while ( true  );
	
	delete [] events;
	events = NULL;
	
	CGDLog::WriteThreadState("nofier exited");//wu_binд߳״̬

	pthread_attr_destroy( &attr );
#ifdef WIN32
	return trace.SetRetValue( 0 );
#endif
}

/*		
#ifndef NDEBUG
{
static FILE * fp1 = fopen("c:\\tmp\\evt_1.log","a");
static int nCount1 = 0;
if ( fp1 )
{
fprintf(fp1, "%d: [%d] Buffer Len:[%d]\n", ++nCount1, GetTickCount(), dwBytes );
fflush(fp1);
}
}
#endif
*/
//	// 
//	if ( InterlockedCompareExchange( &pDirInfo->m_nParsing, 1, 0 ) == 0 )
//	{
// 
//		InterlockedExchange( &pDirInfo->m_nParsing, 0 );
//	}

/*
ssize_t read(int fd,void*buf,size_t count)
Linux²ļI/Oֵ£
1 ɹʵʶֽ
2 ĩβ0
3 -1
*/

