/************
 UAP ڴ鿴
 ************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "uap_fdecl.h"
#include "uap_gvdecl.h"
#include "gcps.h"
#include "z.h"

/************
 鿴ȫ
 ************/
int u_show_glob(void)
{
    UAP_GINF *p;

    int   nBasicLen;
    char  szBuf[64];

    nBasicLen = (int) ((long) (&((UAP_GINF *)0)->sCutOver));

    p = (UAP_GINF *)malloc(nBasicLen);
    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(p);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(p, u_pGInf, nBasicLen);

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(p);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    printf("ڴС  %d\n", p->nMemSize);
    z_get_dt(szBuf, 19, "l", p->tCreatTime);
    printf("ʱ  %s\n", szBuf);
    printf("(ID)%s(%d)\n", p->szUserName, p->nUserID);
    printf("źŵID  %d\n", p->nSemID);
    putchar('\n');

    printf("  ok?    ʹ                \n");
    printf("---------------------------------------------------------\n");
    printf("[ӵ   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_NODE], N_NODE, p->nNode, 100 * p->nNode / N_NODE);
    printf("[Э   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_PROT], N_PROT, p->nProt, 100 * p->nProt / N_PROT);
    printf("[IP     ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_IPA], N_IPA, p->nIP, 100 * p->nIP / N_IPA);
    printf("[û   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_USRA], N_USRA, p->nUser, 100 * p->nUser / N_USRA);
    printf("[ҵ   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_BUSI], N_BUSI, p->nBusi, 100 * p->nBusi / N_BUSI);
    printf("[űI  ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_FLOW], N_FLOW, p->nFlow, 100 * p->nFlow / N_FLOW);
    printf("[űD  ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_FLOW], N_SCRIPT, p->nFlowLen, 100 * p->nFlowLen / N_SCRIPT);
    printf("[Ŷ   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_H3], N_H3, p->nH3, 100 * p->nH3 / N_H3);

    sprintf(szBuf, "%d,%d,%d", p->nRCode, p->nRCode1, p->nRCode2);
    printf("[ ]   %d      %-8d  %-20s  %-2d %%\n",
        p->nValid[RN_RCODE], N_RCODE, szBuf,
        100 * (p->nRCode + p->nRCode1 + p->nRCode2) / N_RCODE);

    sprintf(szBuf, "%d,%d", p->nPMap, p->nPMap);
    printf("[ƷMap]   %d      %-8d  %-20s  %-2d %%\n",
        p->nValid[RN_PMAP], N_PMAP, szBuf,
        100 * (p->nPMap + p->nPMap) / N_PMAP);

    printf("[   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_CUTOVER], N_CUTOVER, p->nCutOver, 100 * p->nCutOver / N_CUTOVER);
    printf("[Ӧ   ]   %d      %-8d  %-20d  %-2d %%\n",
        p->nValid[RN_URGE], N_URGE, p->nUrge, 100 * p->nUrge / N_URGE);

    free(p);
    return(0);
}

/************
 鿴ӵ
 ************/
int u_show_node(const char *pID)
{
    UAP_NODE *pNode = NULL, *p;

    int i;

    // ڴ
    pNode = (UAP_NODE *) malloc(sizeof(u_pGInf->sNode));

    if( pNode == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pNode);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pNode, u_pGInf->sNode, sizeof(u_pGInf->sNode));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pNode);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pNode; i < N_NODE && p->szNodeID[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szNodeID, pID) == NULL ) continue;

        printf("%s|%s|%s|%d|%d|%s|%s|%s|%s|%d|%d\n",
            p->szNodeID, p->szProtID, p->szDefChanID, p->cAuthMode, p->cRouteBy,
            p->szRouteTag, p->szRouteScript, p->szEffTime, p->szExpTime,
            p->cLogLevel, p->nProtOffset);
    }

    free(pNode);
    return(0);
}

/************
 鿴Э
 ************/
int u_show_prot(const char *pID)
{
    UAP_PROT *pProt = NULL, *p;

    int i;

    // ڴ
    pProt = (UAP_PROT *) malloc(sizeof(u_pGInf->sProt));

    if( pProt == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pProt);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pProt, u_pGInf->sProt, sizeof(u_pGInf->sProt));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pProt);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pProt; i < N_PROT && p->szProtID[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szProtID, pID) == NULL ) continue;

        printf("%s|%s|%s|%s|%s|%d|%d|%s|%d|%d\n",
            p->szProtID, p->szQHeadID, p->szPHeadID,
            p->szEffTime, p->szExpTime, p->cProtType, p->cEncMode,
            p->szEncKey, p->nQHOffset, p->nPHOffset);
    }

    free(pProt);
    return(0);
}

/************
 鿴IP
 ************/
int u_show_IP(const char *pID)
{
    UAP_IPAUTH *pIP = NULL, *p;

    int i;

    // ڴ
    pIP = (UAP_IPAUTH *) malloc(sizeof(u_pGInf->sIP));

    if( pIP == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pIP);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pIP, u_pGInf->sIP, sizeof(u_pGInf->sIP));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pIP);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pIP; i < N_IPA && p->szIP[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szIP, pID) == NULL ) continue;

        printf("%s|%s|%s|%s\n", p->szNodeID, p->szIP, p->szEffTime, p->szExpTime);
    }

    free(pIP);
    return(0);
}

/************
 鿴û
 ************/
int u_show_user(const char *pID)
{
    UAP_USERAUTH *pUser = NULL, *p;

    int i;

    // ڴ
    pUser = (UAP_USERAUTH *) malloc(sizeof(u_pGInf->sUser));

    if( pUser == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pUser);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pUser, u_pGInf->sUser, sizeof(u_pGInf->sUser));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pUser);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pUser; i < N_USRA && p->szUser[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szUser, pID) == NULL ) continue;

        printf("%s|%s|%s|%d|%s|%s|%s\n",
            p->szNodeID, p->szUser, p->szPass, p->cEncryMode, p->szEncryKey,
            p->szEffTime, p->szExpTime);
    }

    free(pUser);
    return(0);
}

/************
 鿴ҵ
 ************/
int u_show_busi(const char *pID)
{
    UAP_BUSI *pBusi = NULL, *p;

    int i;

    // ڴ
    pBusi = (UAP_BUSI *) malloc(sizeof(u_pGInf->sBusi));

    if( pBusi == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pBusi);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pBusi, u_pGInf->sBusi, sizeof(u_pGInf->sBusi));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pBusi);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pBusi; i < N_BUSI && p->szBusiID[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szBusiID, pID) == NULL ) continue;

        printf("%s|%s|%s|%s|%s|%s|%s|%d|%d|%d|%d\n",
            p->szBusiID, p->szBusiType, p->szChanID, p->szProtID, p->szFlowID,
            p->szEffTime, p->szExpTime, p->cUrgencyUse, p->cLogLevel,
            p->nTimeout, p->nFlowOffset);
    }

    free(pBusi);
    return(0);
}

/************
 鿴ű
 ************/
int u_show_flow(const char *pID)
{
    UAP_FLOW *pF = NULL, *p;

    int i;

    // ڴ
    pF = (UAP_FLOW *) malloc(sizeof(u_pGInf->sFlow));

    if( pF == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pF);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pF, u_pGInf->sFlow, sizeof(u_pGInf->sFlow));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pF);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pF; i < N_FLOW && p->szFlowID[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szFlowID, pID) == NULL ) continue;

        printf("%s|%d|%d\n",  p->szFlowID, p->nTotalLen, p->nOffset);
    }

    free(pF);
    return(0);
}

/************
 鿴Ŷ
 ************/
int u_show_h3(const char *pID)
{
    UAP_H3 *pH3 = NULL, *p;

    int i;

    // ڴ
    pH3 = (UAP_H3 *) malloc(sizeof(u_pGInf->sH3));

    if( pH3 == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pH3);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pH3, u_pGInf->sH3, sizeof(u_pGInf->sH3));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pH3);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pH3; i < N_H3 && p->szBegH3[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szBegH3, pID) == NULL ) continue;

        printf("%s|%s|%d\n",  p->szBegH3, p->szEndH3, p->nRegion);
    }

    free(pH3);
    return(0);
}

/**************
 鿴
 **************/
int u_show_rcode(const char *pID)
{
    UAP_RCODE *pR = NULL, *p;

    int i;

    // ڴ
    pR = (UAP_RCODE *) malloc(sizeof(u_pGInf->sRCode));

    if( pR == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pR);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pR, u_pGInf->sRCode, sizeof(u_pGInf->sRCode));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pR);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pR; i < N_RCODE && p->szChanID[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szFromCode, pID) == NULL ) continue;

        printf("%s|%s|%s|%s|%s|%s\n",
            p->szChanID, p->szBusiID, p->szFromCode, p->szToCode, p->szRetMsg, p->szClass);
    }

    free(pR);
    return(0);
}

/****************
 鿴Ʒת
 ****************/
int u_show_pmap(const char *pID)
{
    UAP_PMAP *pM = NULL, *p;

    int i;

    // ڴ
    pM = (UAP_PMAP *) malloc(sizeof(u_pGInf->sPMap));

    if( pM == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pM);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pM, u_pGInf->sPMap, sizeof(u_pGInf->sPMap));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pM);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pM; i < N_PMAP && p->szProdID[0]; i++, p++ )
    {
        if( pID && *pID && strstr(p->szProdID, pID) == NULL ) continue;

        printf("%d|%s|%s|%s|%s|%d\n",
            p->nRegion, p->szOldPID, p->szProdID, p->szProdType,
            p->szBizCode, p->cOperType);
    }

    free(pM);
    return(0);
}

/************
 鿴
 ************/
int u_show_cutover(const char *pID)
{
    UAP_CUTOVER *pC = NULL, *p;

    int i, nR = -1;

    if( pID && *pID ) nR = atoi(pID);

    // ڴ
    pC = (UAP_CUTOVER *) malloc(sizeof(u_pGInf->sCutOver));

    if( pC == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pC);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pC, u_pGInf->sCutOver, sizeof(u_pGInf->sCutOver));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pC);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pC; i < N_CUTOVER && p->nRegion; i++, p++ )
    {
        if( nR != -1 && p->nRegion != nR ) continue;
        printf("%d|%d\n", p->nRegion, p->cCutOver);
    }

    free(pC);
    return(0);
}

/************
 鿴Ӧ
 ************/
int u_show_urge(const char *pID)
{
    UAP_URGE *pU = NULL, *p;

    int i, nR = -1;

    if( pID && *pID ) nR = atoi(pID);

    // ڴ
    pU = (UAP_URGE *) malloc(sizeof(u_pGInf->sUrge));

    if( pU == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 )
    {
        free(pU);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    memcpy(pU, u_pGInf->sUrge, sizeof(u_pGInf->sUrge));

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 )
    {
        free(pU);
        printf("󣺲鿴ʧ\n");
        return(-1);
    }

    // ʾϢ
    for( i = 0, p = pU; i < N_URGE && p->nRegion; i++, p++ )
    {
        if( nR != -1 && p->nRegion != nR ) continue;

        printf("У%4d  CRM=%d  BOSS=%d  RES=%d  =%d  ʱ䣺%s  %s  Ϣ%s\n",
            p->nRegion, p->cECrm, p->cEBoss, p->cERes, p->cMsgBlock,
            p->szETime, p->szChanID, p->szRepMsg);
    }

    free(pU);
    return(0);
}

/************************************
 鿴ָ
 ڲint           --  
           const char *  --  ޶ID
 ֵ  -1ʧ  0ɹ
 ************************************/
int u_show_zone(int aZone, const char *pID)
{
    switch( aZone )
    {
    case R_GLOB:
        u_show_glob();          break;

    case R_NODE:
        u_show_node(pID);       break;

    case R_PROT:
        u_show_prot(pID);       break;

    case R_IPA:
        u_show_IP(pID);         break;

    case R_USRA:
        u_show_user(pID);       break;

    case R_BUSI:
        u_show_busi(pID);       break;

    case R_FLOW:
        u_show_flow(pID);       break;

    case R_H3:
        u_show_h3(pID);         break;

    case R_RCODE:
        u_show_rcode(pID);      break;

    case R_PMAP:
        u_show_pmap(pID);       break;

    case R_CUTOVER:
        u_show_cutover(pID);    break;

    case R_URGE:
        u_show_urge(pID);       break;

    default:
        return(-1);
    }

    return(0);
}
