

#ifndef __SPICE_AUDIO_PRIVATE_H__
#define __SPICE_AUDIO_PRIVATE_H__

#include <glib.h>
#include <gio/gio.h>
#include "spice-session.h"

G_BEGIN_DECLS

struct _SpiceAudioPrivate {
    SpiceSession            *session;
    GMainContext            *main_context;
};

SpiceAudio *spice_audio_new_priv(SpiceSession *session, GMainContext *context,
                                 const char *name);

void spice_audio_get_playback_volume_info_async(SpiceAudio *audio, GCancellable *cancellable,
        SpiceMainChannel *main_channel, GAsyncReadyCallback callback, gpointer user_data);
gboolean spice_audio_get_playback_volume_info_finish(SpiceAudio *audio, GAsyncResult *res,
        gboolean *mute, guint8 *nchannels, guint16 **volume, GError **error);
void spice_audio_get_record_volume_info_async(SpiceAudio *audio, GCancellable *cancellable,
        SpiceMainChannel *main_channel, GAsyncReadyCallback callback, gpointer user_data);
gboolean spice_audio_get_record_volume_info_finish(SpiceAudio *audio, GAsyncResult *res,
        gboolean *mute, guint8 *nchannels, guint16 **volume, GError **error);
G_END_DECLS

#endif 

