

#ifndef __SPICE_URI_H__
#define __SPICE_URI_H__

#if !defined(__SPICE_CLIENT_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client.h> can be included directly"
#endif

#include <glib-object.h>

G_BEGIN_DECLS

#define SPICE_TYPE_URI (spice_uri_get_type ())
#define SPICE_URI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_URI, SpiceURI))
#define SPICE_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_URI, SpiceURIClass))
#define SPICE_IS_URI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_URI))
#define SPICE_IS_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_URI))
#define SPICE_URI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_URI, SpiceURIClass))


typedef struct _SpiceURI SpiceURI;


typedef struct _SpiceURIClass SpiceURIClass;
typedef struct _SpiceURIPrivate SpiceURIPrivate;

GType spice_uri_get_type(void) G_GNUC_CONST;

const gchar* spice_uri_get_scheme(SpiceURI* uri);
void spice_uri_set_scheme(SpiceURI* uri, const gchar* scheme);
const gchar* spice_uri_get_hostname(SpiceURI* uri);
void spice_uri_set_hostname(SpiceURI* uri, const gchar* hostname);
guint spice_uri_get_port(SpiceURI* uri);
void spice_uri_set_port(SpiceURI* uri, guint port);
gchar *spice_uri_to_string(SpiceURI* uri);
const gchar* spice_uri_get_user(SpiceURI* uri);
void spice_uri_set_user(SpiceURI* uri, const gchar* user);
const gchar* spice_uri_get_password(SpiceURI* uri);
void spice_uri_set_password(SpiceURI* uri, const gchar* password);

G_END_DECLS

#endif 

