/***********************************************************************
*
* ļ              PathTree.cpp
* ģĿģ      ʵĿ¼洢
* ߼ڣ        liu_yfeng 2008-04-01
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
***********************************************************************/

#pragma warning(disable:4786)

#include "SyncPathTree.h"
#include "EventInfoScanner.h"

#include "Base/MonitorInterface.h"
#include "GDLog/GDLog.h"

using namespace std;


namespace InforGuard{
namespace FileScanner{


CSyncPathTree::CSyncPathTree( CMonitorInformation& moniInfo ) : CPathTree( moniInfo )
{
}


CSyncPathTree::~CSyncPathTree()
{
	if ( NULL != m_pObjDir )
	{
		if ( m_oldRoot )
		{
			m_oldRoot = m_pObjDir->freeTree( m_oldRoot );
		}
		if ( m_curRoot )
		{
			m_curRoot = m_pObjDir->freeTree( m_curRoot );
		}
		
		delete m_pObjDir;
		m_pObjDir = NULL;
	}
}


void CSyncPathTree::Scan()
{
	try
	{
		CreateCur();
	}
	catch( CExceptionError& )
	{
		CGDLog::WriteErrLog( "1071:CSyncPathTree:Scan CreateCur catch CExceptionError" );
		return;
	}
	catch ( ... )
	{
		CGDLog::WriteErrLog( "1072:CSyncPathTree:Scan CreateCur catch ..." );
		return;
	}
	
	if ( NULL != m_oldRoot && NULL != m_curRoot )
	{
		Compare( m_curRoot, m_oldRoot, m_dir.c_str() );
	}
	CreateOld();
}


void CSyncPathTree::CreateOld()
{
	try
	{
		if ( NULL != m_oldRoot )
		{
			m_oldRoot = m_pObjDir->freeTree( m_oldRoot );
		}
		m_oldRoot = m_curRoot;
		m_curRoot = NULL;
	}
	catch ( ... )
	{
		CGDLog::WriteErrLog( "1073:CSyncPathTree:CreateOld catch ..." );
	}
}


void CSyncPathTree::Compare( PPATHNODE cur, PPATHNODE old, const char* rootPath )
{
	char filePathName[GD_MAX_PATH] = {0};
	char szTempPath[GD_MAX_PATH] = {0};
	// ѭѭһ
	while( cur && old )
	{
		// Ŀ¼
		int n = strcmp( cur->szName, old->szName );
		
		// ֯ǰĿ¼,ļλӽݹ
		if( ( strlen(cur->szName) > 1 && cur->szName[1]==':' )||cur->szName[0]=='/')
		{
			strcpy( szTempPath, rootPath );
		}
		else
		{
			sprintf( szTempPath, "%s%c%s", rootPath, C_PATHLASH, cur->szName );
		}

		if ( n < 0 )
		{
			// ɾĿ¼¼
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, old->szName );
			if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
			{
                CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
			}
			
			// ȱʧ
			old = old->bro;
		}
		else if ( n > 0 )
		{
			// ½Ŀ¼¼
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, cur->szName );
			if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
			{
                CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
			}
			cur = cur->bro;
		}
		else			// עһεһȵ
		{
			// Ŀ¼ͬ
			PFILENODE listcur = cur->list;
			PFILENODE listold = old->list;

			// ѭѭȽһļ
			while ( listcur && listold )
			{
				int m = strcmp( listcur->szName, listold->szName);
				if ( m < 0 )
				{
					// ɾļ¼
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listold->szName);
					if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
					}
					// ȱʧ
					listold = listold->link;
				}
				else if ( m > 0 )
				{
					// ½ļ¼
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listcur->szName);
					if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
					}
					listcur = listcur->link;
				}
				else
				{
					// ļͬ
					if ( listcur->time_LastWriteTime != listold->time_LastWriteTime )
					{
						// ޸ļ¼
						sprintf( filePathName, "%s%c%s",szTempPath, C_PATHLASH, listcur->szName );
						if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CHANGE, filePathName ) )
						{
							CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CHANGE, filePathName );
						}
					}
					else if ( listcur->size_Size != listold->size_Size )
					{
						// ޸ļ¼
						sprintf( filePathName, "%s%c%s",szTempPath, C_PATHLASH, listcur->szName );
						if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CHANGE, filePathName ) )
						{
							CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CHANGE, filePathName );
						}
					}
					// ͬ(һļ)
					listcur = listcur->link;
					listold = listold->link;
				}
			}
			if ( NULL == listcur && NULL != listold )
			{
				// ɾļ¼
				while ( listold )
				{
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listold->szName);
					if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
					}
					listold = listold->link;
				}
			}
			else if ( NULL == listold && NULL != listcur )
			{
				// ½ļ¼
				while ( listcur )
				{
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listcur->szName);
					if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
					}
					listcur = listcur->link;
				}
			}
			// ׼Ŀ¼ļбΪգһĿ¼ɣһ
			if ( cur->son || old->son )
			{
				// ӽݹ(һ)
				Compare( cur->son, old->son, szTempPath );
			}
			// Ӻѭֵ
			cur = cur->bro;
			old = old->bro;
		}
	}//while

	if ( NULL == cur && NULL != old )
	{
		// ɾĿ¼¼
		while ( old )
		{
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, old->szName );
			if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
			{
				CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
			}
			old = old->bro;
		}
	}
	else if ( NULL == old && NULL != cur )
	{
		// ½Ŀ¼¼
		while ( cur )
		{
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, cur->szName );
			if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
			{
				CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
			}
			cur = cur->bro;
		}
	}
	// ׼Ŀ¼ͬΪգ(һ)
}


}	// namespace FileScanner
}	// namespace InforGuard

