/***********************************************************************
*
* ļ Differ.cpp
* ģĿģ ļɨ
* ߼ڣ wu_bin 2009-08-1
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ wang_jin 2009-9-4
*
***********************************************************************/

#pragma warning ( disable : 4251 4786 )

#include "Common/Common.h"
#include "Common/GDString.h"
#include "Common/GDTimer.h"
#include "Common/ParamList.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"

#include "Differ.h"
#include "EventQueue.h"
#include "FileTreeComper.h"

#include <iostream>
#include <string>

using namespace std;


namespace InforGuard{
namespace FileScanner{


long CDiffer::m_delay;
std::map<std::string, CDirDiffer*> CDiffer::m_dirmap;


CDiffer::CDiffer()
{
}

CDiffer::~CDiffer()
{
}

bool CDiffer::Initialize(const char * sParams)
{
	CGDTrace trace( LOG_L6, "CDiffer:Initialize(%s)", sParams );

	CParamList paramList( sParams, "|" );
	m_delay = atoi( paramList.GetStringValue( "delay" ).c_str() );

	if ( m_delay > 60*60*24 )
	{
		m_delay = 60*60*24;
	}
	else if ( m_delay < 1 )
	{
		m_delay = 1;
	}

	CGDLog::WriteSysLog( "2038:CDiffer Initialize(%s) OK", sParams );

	return trace.SetRetResult( true );
}

bool CDiffer::Uninitialize()
{
	CGDTrace trace( LOG_L6, "CDiffer:Uninitialize" );

	CGDLog::WriteSysLog( "2039:CDiffer Uninitialize OK" );

	return trace.SetRetResult( true );
}

bool CDiffer::WatchDirectory( const CMonitorInformation & moniInfo )
{
	CGDTrace trace( LOG_L6, "CDiffer:WatchDirectory(%s)", moniInfo.m_monitorPath.c_str() );

	// жǷѾ
	std::map<std::string, CDirDiffer*>::iterator iter = m_dirmap.find( moniInfo.m_sDirId );
	if ( iter == m_dirmap.end() ) // ûнĿ¼ض
	{
		CDirDiffer* pDirDiffer = new CDirDiffer();
		if ( pDirDiffer )
		{
			pDirDiffer->SetPolicy( moniInfo );
			m_dirmap.insert( std::make_pair( moniInfo.m_sDirId, pDirDiffer ) );
			pDirDiffer->StartMonitor(); // ߳
			CGDLog::WriteSysLog( "2040:CDiffer::WatchDirectory start thread..." );
		}
		else
		{
			return trace.SetRetResult( false );
		}
	}
    else // ѾĿ¼ض
    {
        CDirDiffer* pDirDiffer = iter->second;
        if ( pDirDiffer )
        {
		    pDirDiffer->SetPolicy( moniInfo );
        }
		else
		{
			return trace.SetRetResult( false );
		}
    }

	return trace.SetRetResult( true );

}

bool CDiffer::UnwatchDirectory( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CDiffer:UnwatchDirectory(%s)", sDirId );

	// жǷѾ
	std::map<std::string, CDirDiffer*>::iterator iter = m_dirmap.find( sDirId );
	if ( iter == m_dirmap.end() ) // ûнĿ¼ض
	{
		return trace.SetRetResult( false );
	}
	else
	{
		// ֹͣ߳
		CGDLog::WriteSysLog( "2041:CDiffer::WatchDirectory stop thread..." );
		iter->second->StopMonitor();
		delete iter->second;
		m_dirmap.erase( iter );
		return trace.SetRetResult( true );
	}
}

bool CDiffer::IsWatched( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CDiffer:IsWatched(%s)", sDirId );

	// жǷѾ
	std::map<std::string, CDirDiffer*>::iterator iter = m_dirmap.find( sDirId );
	if ( iter == m_dirmap.end() ) // ûнĿ¼ض
	{
		return trace.SetRetResult( false );
	}
	else
	{
		// ״̬
		InforGuard::GDThreadPool::enumThreadStatus status = iter->second->GetStatus();
		bool bRet = ( InforGuard::GDThreadPool::TS_STARTING == status || InforGuard::GDThreadPool::TS_STARTED == status );
		return trace.SetRetResult( bRet );
	}
}

bool CDiffer::IsWatchedByWebsiteId( const char * sWebsiteId )
{
	CGDTrace trace( LOG_L6, "CDiffer:IsWatchedByWebsiteId(%s)", sWebsiteId );

	// жǷѾ
	bool bRet = false;

	CDirDiffer* pDirInfo = NULL;
	map < string, CDirDiffer* >::iterator iter = m_dirmap.begin();
	while( iter != m_dirmap.end() )
	{
		pDirInfo = (CDirDiffer*)iter->second;
		if( strcmp( sWebsiteId, pDirInfo->m_sDirId.c_str() ) == 0 )
		{
			bRet = true;
			break;
		}
		iter++;
	}
	if ( !bRet ) // ûнĿ¼ض
	{
		return trace.SetRetResult( false );
	}
	else
	{
		// ״̬
		InforGuard::GDThreadPool::enumThreadStatus status = iter->second->GetStatus();
		bool bRet = ( InforGuard::GDThreadPool::TS_STARTING == status || InforGuard::GDThreadPool::TS_STARTED == status );
		return trace.SetRetResult( bRet );
	}
}

bool CDiffer::ReadEvent( EVENT_S & event )
{
	static bool bHasEvent = false;

	// ¼ȡ¼
	if ( CEventQueue::Read( event ) )
	{
		if ( !bHasEvent )
		{
			CGDTrace trace( LOG_L6, "CDiffer:ReadEvent(%d,%s)", event.event_type, event.o_filepath );
			bHasEvent = true;
		}
	}
	else
	{
		if ( bHasEvent )
		{
			CGDTrace trace( LOG_L6, "CDiffer:ReadEvent()=false" );
			bHasEvent = false;
		}
	}

	return bHasEvent;
}


}	// namespace FileDiffer
}	// namespace InforGuard
