/******************************************************************************
*
* ļ              Service.cpp
* ģĿģ      ļͨѶ
* ߼ڣ        liu_yfeng 2008-6-19
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
******************************************************************************/


#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <tchar.h>
#include "GDLog/GDTrace.h"
#include "Common/ConvertString.h"
#include "Service.h"


CService::CService()
{
	m_hDriver = INVALID_HANDLE_VALUE;
}

CService::~CService()
{
}


bool CService::Create( const TCHAR* Name )
{
	CGDTrace trace( LOG_L6, "CService:Create(%s)",Name);
	
	TCHAR    completeDeviceName[64] = {0};
	wsprintf( completeDeviceName, TEXT("\\\\.\\%s"), Name ); // use user32.lib

	if ( INVALID_HANDLE_VALUE == m_hDriver )
	{
		m_hDriver = CreateFile(completeDeviceName,
							 GENERIC_READ | GENERIC_WRITE,
							 0,
							 NULL,
							 OPEN_EXISTING,
							 FILE_ATTRIBUTE_NORMAL,
							 NULL);
		if ( INVALID_HANDLE_VALUE == m_hDriver )
		{
			//DWORD err = GetLastError();
			return trace.SetRetResult( false );
		}
	}
	
	return trace.SetRetResult( true );
}


bool CService::Close()
{
		CGDTrace trace( LOG_L6, "CService:Close()" );
	if ( INVALID_HANDLE_VALUE != m_hDriver )
	{
		if ( CloseHandle( m_hDriver ) == 0 )
		{
			return trace.SetRetResult( false );
		}
		else
		{
			m_hDriver = INVALID_HANDLE_VALUE;
			return trace.SetRetResult( true );
		}
	}
	return trace.SetRetResult( false );
}


bool CService::ClearEvent()
{
	CGDTrace trace( LOG_L6, "CService:ClearEvent()" );
	
	if ( INVALID_HANDLE_VALUE == m_hDriver )
	{
		return trace.SetRetResult( false );
	}

	DWORD dwBytesReturned;
	// Enable I/O port access for this process		//IOCTL_WINIO_ENABLEDIRECTIO
	if ( 0 == DeviceIoControl(m_hDriver, GuardFileDriver_clearEvent, NULL,
                         0, NULL, 0, &dwBytesReturned, NULL))
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}


DWORD CService::HookDrives( const TCHAR* DriveList )
{
	CGDTrace trace( LOG_L6, "CService:HookDrives(%s)",DriveList);
	
	TCHAR	name[32];
	UINT	drivetype;
	DWORD	CurDriveSet = 0;
	int		DriveNum = 0;

	if( INVALID_HANDLE_VALUE == m_hDriver )
	{
		return trace.SetRetValue( FALSE );
	}
	
	if( DriveList )
	{
		DriveNum = lstrlen(DriveList);
	}
	
	if( DriveNum > 26 )
	{
		//
		// ٶ߼̷26Ӣĸ֤
		//
		return trace.SetRetValue( 0 );
	}
	
	for( int i = 0; i < DriveNum; i++ )  
	{
		if( DriveList[i] < 'A' || DriveList[i] > 'Z' )
		{
			continue;
		}

		_stprintf( name, _T("%c:\\"), DriveList[i] );

		drivetype = GetDriveType( name );
		if( drivetype == DRIVE_FIXED 
			|| drivetype == DRIVE_REMOTE
			|| drivetype == DRIVE_RAMDISK )
		{
			int pos = DriveList[i] - 'A';
			
			CurDriveSet |= (1 << pos);
		}
	}
	
	//
	// ӦôDriverListΪNULLΪ""Ҫ߼
	//
	if( CurDriveSet || !DriveNum )
	{
		//
		// üص
		//
		DWORD	nb;
		if ( ! DeviceIoControl(	m_hDriver, GuardFileDriver_setDisk,
								&CurDriveSet, sizeof(CurDriveSet),
								&CurDriveSet, sizeof(CurDriveSet),
								&nb, NULL ) )
		{
			return trace.SetRetValue( 0 ); 
		}
	}

	return trace.SetRetValue( CurDriveSet );
}

bool CService::ClearDisk()
{
	CGDTrace trace( LOG_L6, "CService:ClearDisk()");
	
	if ( INVALID_HANDLE_VALUE == m_hDriver )
	{
		return trace.SetRetResult( false );
	}

	DWORD	nb;
	// Disable I/O port access	//  IOCTL_WINIO_DISABLEDIRECTIO
	if ( 0 == DeviceIoControl(m_hDriver, GuardFileDriver_clearDisk, NULL,
                  0, NULL, 0, &nb, NULL) )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}

bool CService::SetPolicy( const TCHAR* pPathInfo, long len )
{
	CGDTrace trace( LOG_L6, "CService:SetPolicy(,%d)", len );

	
	// ù˹
	DWORD	nb;
	if ( ! DeviceIoControl(	m_hDriver, GuardFileDriver_setPolicy,
							(void*)pPathInfo, len, NULL, 
							0, &nb, NULL ) )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}


bool CService::SetSuperProcess( const TCHAR* superProcess, long len )
{
	CGDTrace trace( LOG_L6, "CService:SetSuperProcess(%s,%d)", superProcess, len );
	
	DWORD	nb;
	if ( ! DeviceIoControl(	m_hDriver, GuardFileDriver_setSuperProcess,
							(void*)superProcess, len,
							NULL,  0,
							&nb, NULL ) )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}


bool CService::StartFilter()
{
	CGDTrace trace( LOG_L6, "CService:StartFilter()");
	
	if( INVALID_HANDLE_VALUE == m_hDriver )
	{
		return trace.SetRetResult( false );
	}

	DWORD	nb;
	if( ! DeviceIoControl( m_hDriver, 
							GuardFileDriver_startFilter,
							NULL, 0, NULL, 0, &nb, NULL ) )
	{
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( true );
}

bool CService::StopFilter()
{
	CGDTrace trace( LOG_L6, "CService:StopFilter()");
	
	if( INVALID_HANDLE_VALUE == m_hDriver)
	{
		return trace.SetRetResult( false );
	}

	DWORD	nb;
	if( ! DeviceIoControl( m_hDriver, 
							GuardFileDriver_stopFilter,
							NULL, 0, NULL, 0, &nb, NULL ) )
	{
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( true );
}

bool CService::GetBlockEvent( EVENT_S& event)
{
	//CGDTrace trace( LOG_L6, "CService:GetBlockEvent(%d,%s)", event.event_type, event.o_filepath );
	EVENT_ITEM eventTemp = {0};
	DWORD	eventLen = 0;

	if( INVALID_HANDLE_VALUE == m_hDriver )
	{
		return false;
	}

	if ( ! DeviceIoControl(	m_hDriver, GuardFileDriver_getEvent,
							NULL, 0, &eventTemp, sizeof(EVENT_ITEM),
							&eventLen, NULL ) )
	{
		return false;
	}

	if( !eventLen )
	{
		return false;
	}
	
	FILETIME fTime;
	memcpy(&fTime, &(eventTemp.time), sizeof(FILETIME));
	FileTimeToSystemTime(&fTime, &(event.evt_time));

	event.pid = eventTemp.pid;
	strcpy(event.o_filepath, eventTemp.path);
	event.event_type = eventTemp.type;
	return true;
}

