// TestMonitorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestMonitor.h"
#include "TestMonitorDlg.h"

#if 1
#	include "FileWatcher/FileWatcher.h"
#	pragma comment( lib, "FileWatcher" )
#elif 0
#	include "FileScanner/FileScanner.h"
#	pragma comment( lib, "FileScanner" )
	using namespace InforGuard::FileScanner;
#elif 0
#	include "FileFilter/FileFilter.h"
#	pragma comment( lib, "FileFilter" )
#else
#	include "FileDriver/FileDriver.h"
#	pragma comment( lib, "FileDriver" )
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_MY_NOTIFICATION WM_USER+100

/////////////////////////////////////////////////////////////////////////////
// CTestMonitorDlg dialog

CTestMonitorDlg::CTestMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMonitorDlg::IDD, pParent),
	m_pMonitor( new CFileWatcher() )
//	m_pMonitor( new CFileScanner() )
//	m_pMonitor( new CFileScanner() )
//	m_pMonitor( new CFileDriver() )
{
	//{{AFX_DATA_INIT(CTestMonitorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nIndex = 0;
}

void CTestMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestMonitorDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestMonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CTestMonitorDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_MONITOR, OnButtonMonitor)
	ON_MESSAGE(WM_MY_NOTIFICATION, OnMyNotify)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMonitorDlg message handlers

BOOL CTestMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetDlgItemText( IDC_EDIT1, "D:\\wJin\\apache\\apache-2.0.54\\htdocs" );
	//SetDlgItemText( IDC_EDIT1, "D:\\wJin\\apache" );

	SetTimer( 1001, 1000, NULL );

	m_pMonitor->Initialize();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CTestMonitorDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pMonitor->Uninitialize();

	return CDialog::DestroyWindow();
}

void CTestMonitorDlg::OnButtonMonitor() 
{
	// TODO: Add extra validation here
	// ͣ
	CString text;
	GetDlgItemText( IDC_BUTTON_MONITOR, text );
	if ( text == "" )
	{
		CMonitorInformation moniInfo;
		GetDlgItemText( IDC_EDIT1, text );
		moniInfo.m_monitorPath = text.GetBuffer(0);
		if ( m_pMonitor->WatchDirectory( moniInfo ) )
		{
			SetDlgItemText( IDC_BUTTON_MONITOR, "ֹͣ" );
		}
		else
		{
			AfxMessageBox( "WatchDirectory() fail" );
		}
	}
	else
	{
		GetDlgItemText( IDC_EDIT1, text );
		m_pMonitor->UnwatchDirectory( text );
		SetDlgItemText( IDC_BUTTON_MONITOR, "" );
	}
}

LRESULT CTestMonitorDlg::OnMyNotify(WPARAM wParam, LPARAM lParam)
{
	CString buf;
	buf.Format( "[%5d][%x][%d]", ++m_nIndex, wParam, lParam );
	m_list.AddString( buf );
	return 0;
}

void CTestMonitorDlg::OnButtonClear() 
{
	// б
	m_list.ResetContent();
	m_nIndex = 0;
}

void CTestMonitorDlg::OnTimer(UINT nIDEvent) 
{
	// ʱ
	KillTimer( nIDEvent );
	EVENT_S event = {0};
	while ( m_pMonitor->ReadEvent( event ) )
	{
		CString buf;
		buf.Format( "[%5d][%x][%s]", ++m_nIndex, event.event_type, event.o_filepath );
		m_list.AddString( buf );
	}
	SetTimer( nIDEvent, 1, NULL );
	
	CDialog::OnTimer(nIDEvent);
}
