

#ifndef __SPICE_USB_DEVICE_MANAGER_PRIV_H__
#define __SPICE_USB_DEVICE_MANAGER_PRIV_H__

#include "usb-device-manager.h"

G_BEGIN_DECLS

gboolean spice_usb_device_manager_start_event_listening(
    SpiceUsbDeviceManager *manager, GError **err);

void spice_usb_device_manager_stop_event_listening(
    SpiceUsbDeviceManager *manager);

#ifdef USE_USBREDIR
#include <libusb.h>
void spice_usb_device_manager_device_error(
    SpiceUsbDeviceManager *manager, SpiceUsbDevice *device, GError *err);

guint8 spice_usb_device_get_busnum(const SpiceUsbDevice *device);
guint8 spice_usb_device_get_devaddr(const SpiceUsbDevice *device);
guint16 spice_usb_device_get_vid(const SpiceUsbDevice *device);
guint16 spice_usb_device_get_pid(const SpiceUsbDevice *device);
gboolean spice_usb_device_is_isochronous(const SpiceUsbDevice *device);

#endif

G_END_DECLS

#endif 

