#include "jbbhpage.h"

JbbhPage* JbbhPage::jbbhInstance = NULL;
JbbhPage::JbbhPage(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    jbbhsub = JbbhSubPage::getJbbhSubInstance();
}

JbbhPage* JbbhPage::getJbbhInstance()
{
    if (jbbhInstance == NULL)
        jbbhInstance = new JbbhPage();

    return jbbhInstance;
}

void JbbhPage::setWidget(QWidget *jbbh, QStackedWidget *stack, QWidget *next)
{
    jbbhPage = jbbh;
    nextPage = next;
    stackWidget = stack;

    topImage = new QLabel(jbbhPage);
    btnHeng = new ImageButton(jbbhPage);
    btnShu = new ImageButton(jbbhPage);
    btnPie = new ImageButton(jbbhPage);
    btnNa = new ImageButton(jbbhPage);
    btnDian = new ImageButton(jbbhPage);
    btnTi = new ImageButton(jbbhPage);
    btnZhe = new ImageButton(jbbhPage);
    btnGou = new ImageButton(jbbhPage);
    btnBack = new ImageButton(jbbhPage);

    connect(btnHeng, SIGNAL(clicked()), this, SLOT(onHengClicked()));
    connect(btnShu, SIGNAL(clicked()), this, SLOT(onShuClicked()));
    connect(btnPie, SIGNAL(clicked()), this, SLOT(onPieClicked()));
    connect(btnNa, SIGNAL(clicked()), this, SLOT(onNaClicked()));
    connect(btnDian, SIGNAL(clicked()), this, SLOT(onDianClicked()));
    connect(btnTi, SIGNAL(clicked()), this, SLOT(onTiClicked()));
    connect(btnZhe, SIGNAL(clicked()), this, SLOT(onZheClicked()));
    connect(btnGou, SIGNAL(clicked()), this, SLOT(onGouClicked()));
    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClicked()));
}

void JbbhPage::setJbbhPage(QWidget *parent, ImageButton *btnP)
{
    parentPage = parent;
    btnParent =btnP;

    setBackGround();
    setButtons();
}

void JbbhPage::setBackGround()
{
    jbbhPage->setStyleSheet("QWidget#jbbhPage{image:url(:/jbbh/bj_06.png)}");
    topImage->setGeometry(352,47,290,87);
    topImage->setStyleSheet("image:url(:/jbbh/jbbh_bt.png)");
}

void JbbhPage::setButtons()
{
    // 横
    btnHeng->setGeometry(219,196,113,87);
    QPixmap hengP1(":/jbbh/bh_h01.png");
    QPixmap hengP2(":/jbbh/bh_h02.png");
    btnHeng->setNormalImage(hengP1);
    btnHeng->setPressImage(hengP2);
    btnHeng->setCursor(QCursor(Qt::PointingHandCursor));

    // 竖
    btnShu->setGeometry(366,196,113,87);
    QPixmap shuP1(":/jbbh/bh_s01.png");
    QPixmap shuP2(":/jbbh/bh_s02.png");
    btnShu->setNormalImage(shuP1);
    btnShu->setPressImage(shuP2);
    btnShu->setCursor(QCursor(Qt::PointingHandCursor));

    // 撇
    btnPie->setGeometry(515,196,113,87);
    QPixmap pieP1(":/jbbh/bh_p01.png");
    QPixmap pieP2(":/jbbh/bh_p02.png");
    btnPie->setNormalImage(pieP1);
    btnPie->setPressImage(pieP2);
    btnPie->setCursor(QCursor(Qt::PointingHandCursor));

    // 捺
    btnNa->setGeometry(662,196,113,87);
    QPixmap naP1(":/jbbh/bh_n01.png");
    QPixmap naP2(":/jbbh/bh_n02.png");
    btnNa->setNormalImage(naP1);
    btnNa->setPressImage(naP2);
    btnNa->setCursor(QCursor(Qt::PointingHandCursor));

    // 点
    btnDian->setGeometry(219,329,113,87);
    QPixmap dianP1(":/jbbh/bh_d01.png");
    QPixmap dianP2(":/jbbh/bh_d02.png");
    btnDian->setNormalImage(dianP1);
    btnDian->setPressImage(dianP2);
    btnDian->setCursor(QCursor(Qt::PointingHandCursor));

    // 提
    btnTi->setGeometry(366,329,113,87);
    QPixmap tiP1(":/jbbh/bh_t01.png");
    QPixmap tiP2(":/jbbh/bh_t02.png");
    btnTi->setNormalImage(tiP1);
    btnTi->setPressImage(tiP2);
    btnTi->setCursor(QCursor(Qt::PointingHandCursor));

    // 折
    btnZhe->setGeometry(515,329,113,87);
    QPixmap zheP1(":/jbbh/bh_z01.png");
    QPixmap zheP2(":/jbbh/bh_z02.png");
    btnZhe->setNormalImage(zheP1);
    btnZhe->setPressImage(zheP2);
    btnZhe->setCursor(QCursor(Qt::PointingHandCursor));

    // 钩
    btnGou->setGeometry(662,329,113,87);
    QPixmap gouP1(":/jbbh/bh_g01.png");
    QPixmap gouP2(":/jbbh/bh_g02.png");
    btnGou->setNormalImage(gouP1);
    btnGou->setPressImage(gouP2);
    btnGou->setCursor(QCursor(Qt::PointingHandCursor));

    // 返回
    btnBack->setGeometry(686,450,248,208);
    QPixmap backP1(":/jbbh/fh_05.png");
    QPixmap backP2(":/jbbh/fh_06.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));
}

void JbbhPage::onHengClicked()
{
    btnHeng->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "heng", "横", btnHeng);
}

void JbbhPage::onShuClicked()
{
    btnShu->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "shu", "竖", btnShu);
}

void JbbhPage::onPieClicked()
{
    btnPie->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "pie", "撇", btnPie);
}

void JbbhPage::onNaClicked()
{
    btnNa->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "na", "捺", btnNa);
}

void JbbhPage::onDianClicked()
{
    btnDian->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "dian", "点", btnDian);
}

void JbbhPage::onTiClicked()
{
    btnTi->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "ti", "提", btnTi);
}

void JbbhPage::onZheClicked()
{
    btnZhe->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "zhe", "折", btnZhe);
}

void JbbhPage::onGouClicked()
{
    btnGou->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    jbbhsub->setJbbhSubPage(jbbhPage, "gou", "钩", btnGou);
}

void JbbhPage::onBackClicked()
{
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
}
