#ifndef JBBHVIDEOPAGE_H
#define JBBHVIDEOPAGE_H

#include <QWidget>
#include <QStackedWidget>
#include <QLabel>
#include <QListWidget>
#include <QSlider>
#include <QTimer>
#include "video.h"
#include "imagebutton.h"
#include "middle.h"
#include "video.h"
#include "mylabel.h"
#include "common.h"

class JbbhVideoPage : public QWidget
{
    Q_OBJECT
public:
    explicit JbbhVideoPage(QWidget *parent = 0);
    static JbbhVideoPage* getJbbhVideoPageInstance();

    void setWidget(QWidget *jbbhVideo, QStackedWidget *stack, QWidget *root,
                   MyLabel *video, QSlider *slider, QLabel *timeLabel, QLabel *lenLabel, QSlider *_volSlider,
                   ImageButton *play, ImageButton *vol, ImageButton *full, QLabel *ctlRect);
    void setJbbhVideoPage(QWidget *parent, QList<QString> bihuaInfo, QListWidget *listWidgetP);
    void setBackGround(QString image);
    void setVideo();
    void setText(QString note, QString feature);
    void setButtons();
    bool eventFilter(QObject *obj, QEvent *event);
    void initVideoCtl();
    void showVideoCtl();
    void setVideoCtl();
    void initVolCtl();
    void setPlayIcon();
    void setPauseIcon();

signals:
    void fullScreen();
    void showNormal();

private:
    static JbbhVideoPage *jbbhVideoInstance;
    Middle *middle = NULL;
    Video *video = NULL;

    QStackedWidget *stackWidget = NULL;
    QWidget *parentPage = NULL;
    MyLabel *videoLabel = NULL;
    QListWidget *listWidgetParent = NULL;
    QWidget *jbbhVideoPage = NULL;
    QWidget *rootWidget = NULL;

    QString fbVideo, qbVideo, mbVideo;
    int fbVideoSize, qbVideoSize, mbVideoSize;
    bool isFullScreen;
    bool videoStop;

    QTimer *timer;
    QTimer *videoCtlTimer;
    QSlider *posSlider = NULL;
    QLabel *curTimeLabel = NULL;
    QLabel *lengthLabel = NULL;

    // 页面元素
    QLabel *BgLabel = NULL;
    QLabel *topImage = NULL;
    QLabel *bihuaImage = NULL;
    QLabel *noteLabel = NULL;
    QListView *featureView = NULL;
    ImageButton *btnFb = NULL;
    ImageButton *btnQb = NULL;
    ImageButton *btnMb = NULL;
    ImageButton *btnBack = NULL;

    QLabel *videoBgLabel = NULL;
    QSlider *volSlider = NULL;
    ImageButton *btnPlay = NULL;
    ImageButton *btnVol = NULL;
    ImageButton *btnFull = NULL;
    QLabel *videoCtlRect = NULL;

public slots:
    void onFbClick();
    void onQbClick();
    void onMbClick();
    void onBackClick();
    void onVideoDoubleClick();
    void onVideoClick();
    void changePosition(int pos);
    void updateInfo();
    void onPressed();
    void resizeVideo();
//    void updateVideoCtl();
    void onMouseMove();

    void onVideoEndReached();
    void hideVideoCtl();
    void onVolClick();
    void onVolSliderMoved(int pos);
};

#endif // JBBHVIDEOPAGE_H
