#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QWidget>
#include <QMenu>
#include <QAction>
#include <QResizeEvent>
#include <QSlider>
#include "middle.h"
#include "video.h"
#include "wordpage.h"
#include "login.h"
#include "welcomepage.h"
#include "coursepage.h"
#include "articlelistpage.h"
#include "articlepage.h"
#include "xzzspage.h"
#include "jbbhpage.h"
#include "jbbhsubpage.h"
#include "jbbhvideopage.h"
#include "sfktpage.h"
#include "sfkt2page.h"
#include "sfkt3page.h"
#include "sfktvideopage.h"
#include "szzbpage.h"
#include "szzbsubpage.h"
#include "ppbspage.h"
#include "ppbssubpage.h"
#include "sxzfpage.h"
#include "sxzf2page.h"
#include "sxzf3page.h"
#include "sxzfvideopage.h"
#include "querypage.h"
#include "querysubpage.h"
#include "sfxspage.h"
#include "mylabel.h"
#include "videopage.h"
#include "download.h"
#include "sztxpage.h"
#include "sztxsubpage.h"
#include "swjzpage.h"
#include "flashpage.h"
#include "queryplaypage.h"
#include "whrpage.h"
#include "articlesubpage.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void closeEvent(QCloseEvent *event);
    void resizeEvent(QResizeEvent* event);

//    void setMenu();

signals:
    void resizeWindow();

private slots:
    void mainWindowFullScreen();
    void mainWindowShowNormal();

    void download(QAction *action);

private:
    Ui::MainWindow *ui;
    MyLabel *videoLabel = NULL;
    MyLabel *wordVideoLabel = NULL;
    MyLabel *jbbhVideoLabel = NULL;
    MyLabel *sfktVideoLabel = NULL;
    MyLabel *sxzfVideoLabel = NULL;
    QAxWidget *flash = NULL;

    QSlider *wordVideoSlider = NULL;
    QSlider *videoSlider = NULL;
    QSlider *jbbhVideoSlider = NULL;
    QSlider *sfktVideoSlider = NULL;
    QSlider *sxzfVideoSlider = NULL;
    QSlider *wordVolSlider = NULL;
    QSlider *volSlider = NULL;
    QSlider *jbbhVolSlider = NULL;
    QSlider *sfktVolSlider = NULL;
    QSlider *sxzfVolSlider = NULL;
    QLabel *timeLabel = NULL;
    QLabel *lengthLabel = NULL;

    ImageButton *btnPlay = NULL;
    ImageButton *btnVol = NULL;
    ImageButton *btnFull = NULL;
    ImageButton *btnJbbhPlay = NULL;
    ImageButton *btnJbbhVol = NULL;
    ImageButton *btnJbbhFull = NULL;
    ImageButton *btnSfktPlay = NULL;
    ImageButton *btnSfktVol = NULL;
    ImageButton *btnSfktFull = NULL;
    ImageButton *btnSxzfPlay = NULL;
    ImageButton *btnSxzfVol = NULL;
    ImageButton *btnSxzfFull = NULL;
    ImageButton *btnWordPlay = NULL;
    ImageButton *btnWordVol = NULL;
    ImageButton *btnWordFull = NULL;


    QLabel *videoCtlRect = NULL;

    Middle *middle = NULL;
    Login *login = NULL;
    WelcomePage *welcome = NULL;
    Video *video = NULL;
    WordPage *wordPage = NULL;
    CoursePage *coursePage = NULL;
    ArticleListPage *articleListPage = NULL;
    ArticlePage *articlePage = NULL;
    XzzsPage *xzzsPage = NULL;
    JbbhPage *jbbhPage = NULL;
    JbbhSubPage *jbbhSubPage = NULL;
    JbbhVideoPage *jbbhVideoPage = NULL;
    SfktPage *sfktPage = NULL;
    Sfkt2Page *sfkt2Page = NULL;
    Sfkt3Page *sfkt3Page = NULL;
    SfktVideoPage *sfktVideoPage = NULL;
    SzzbPage *szzbPage = NULL;
    SzzbSubPage *szzbSubPage = NULL;
    PpbsPage *ppbsPage = NULL;
    PpbsSubPage *ppbssubPage = NULL;
    SxzfPage *sxzfPage = NULL;
    Sxzf2Page *sxzf2Page = NULL;
    Sxzf3Page *sxzf3Page = NULL;
    SxzfVideoPage *sxzfVideoPage = NULL;
    QueryPage *queryPage = NULL;
    QuerySubPage *querySubPage = NULL;
    SfxsPage *sfxsPage = NULL;
    VideoPage *videoPage = NULL;
    SztxPage *sztxPage = NULL;
    SztxSubPage *sztxSubPage = NULL;
    SwjzPage *swjzPage = NULL;
    FlashPage *flashPage = NULL;
    QueryPlayPage *queryPlayPage = NULL;
    WhrPage *whrPage = NULL;
    ArticleSubPage *articleSubPage = NULL;

    void setUpdate();
    void setMainPage();
    void setLoginPage();
 public:
    void autoLoin();    //自动登录
};

#endif // MAINWINDOW_H
