#include "sxzf3page.h"
#include <QDebug>
#include <QScrollBar>

Sxzf3Page* Sxzf3Page::sxzf3Instance = NULL;

Sxzf3Page::Sxzf3Page(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    sxzfVideoPage = SxzfVideoPage::getSxzfVideoInstance();
}

Sxzf3Page* Sxzf3Page::getSxzf3Instance()
{
    if (sxzf3Instance == NULL)
        sxzf3Instance = new Sxzf3Page();

    return sxzf3Instance;
}

void Sxzf3Page::setWidget(QWidget *sxzf3, QStackedWidget *stack, QWidget *next)
{
    sxzf3Page = sxzf3;
    nextPage = next;
    stackWidget = stack;

    // 页面元素初始化
    topImageLabel = new QLabel(sxzf3Page);
    leftImageLabel = new QLabel(sxzf3Page);
    scrollArea = new QScrollArea(sxzf3Page);
    btnWidget = new QWidget(sxzf3Page);
    vlayout = new QVBoxLayout(sxzf3Page);
    btnBack = new ImageButton(sxzf3Page);
    btn1 = new ImageButton(sxzf3Page);
    btn2 = new ImageButton(sxzf3Page);
    btn3 = new ImageButton(sxzf3Page);
    btn4 = new ImageButton(sxzf3Page);
    btn5 = new ImageButton(sxzf3Page);
    btn6 = new ImageButton(sxzf3Page);
    btn7 = new ImageButton(sxzf3Page);
    btn8 = new ImageButton(sxzf3Page);
    btnSQ = new ImageButton(sxzf3Page);
    btnXQ = new ImageButton(sxzf3Page);

    connect(btnSQ, SIGNAL(clicked()), this, SLOT(onSQClick()));
    connect(btnXQ, SIGNAL(clicked()), this, SLOT(onXQClick()));
    connect(btn1, SIGNAL(clicked()), this, SLOT(on1Click()));
    connect(btn2, SIGNAL(clicked()), this, SLOT(on2Click()));
    connect(btn3, SIGNAL(clicked()), this, SLOT(on3Click()));
    connect(btn4, SIGNAL(clicked()), this, SLOT(on4Click()));
    connect(btn5, SIGNAL(clicked()), this, SLOT(on5Click()));
    connect(btn6, SIGNAL(clicked()), this, SLOT(on6Click()));
    connect(btn7, SIGNAL(clicked()), this, SLOT(on7Click()));
    connect(btn8, SIGNAL(clicked()), this, SLOT(on8Click()));
    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
}

void Sxzf3Page::setSxzf3Page(QWidget *parent, QListView *view, QList<QString> info)
{
    parentPage = parent;
    listView = view;

    QList<QVariant> list;
    poemList.clear();
    list = middle->getClassicalItem(info[1]);
    foreach (QVariant tmp, list) {
        QList<QString> info;
        info.append(tmp.toMap()["img_url"].toString());
        info.append(tmp.toMap()["video_url"].toString());
        info.append(tmp.toMap()["video_size"].toString());
        poemList.append(info);
    }

    scrollArea->hide();
    setBackGround(info);
    setButtons();
}

void Sxzf3Page::setBackGround(QList<QString> info)
{
    sxzf3Page->setStyleSheet("QWidget#sxzf3Page{image:url(:/sxzf/bj_19.jpg)}");

    topImageLabel->setGeometry(675,80,199,50);
    topImageLabel->setStyleSheet("image:url(:sxzf/erji/sxzf_tb2.png)");

    leftImageLabel->setGeometry(95,85,470,530);
    if (info.length() == 2) {
        QPixmap image;
        if (middle->getClientMode()) {
            image.load(middle->getImageFile2(info[0], "/poem/"));
        } else {
            image.loadFromData(middle->getImageData(info[0]));
        }
        image = image.scaled(QSize(470,530),Qt::KeepAspectRatio);
        leftImageLabel->setPixmap(image);
    }
}

void Sxzf3Page::setButtons()
{
    // 上阙
    btnSQ->setFixedSize(171,62);
    QPixmap jsP1(":/sxzf/erji/sxzf_sq01.png");
    QPixmap jsP2(":/sxzf/erji/sxzf_sq02.png");
    btnSQ->setNormalImage(jsP1);
    btnSQ->setPressImage(jsP2);
    btnSQ->setCursor(QCursor(Qt::PointingHandCursor));

    // 下阕
    btnXQ->setFixedSize(171,62);
    QPixmap jxP1(":/sxzf/erji/sxzf_xq01.png");
    QPixmap jxP2(":/sxzf/erji/sxzf_xq02.png");
    btnXQ->setNormalImage(jxP1);
    btnXQ->setPressImage(jxP2);
    btnXQ->setCursor(QCursor(Qt::PointingHandCursor));

    // 第一句
    btn1->setFixedSize(171,62);
    QPixmap j1P1(":/sxzf/erji/sxzf_1j01.png");
    QPixmap j1P2(":/sxzf/erji/sxzf_1j02.png");
    btn1->setNormalImage(j1P1);
    btn1->setPressImage(j1P2);
    btn1->setCursor(QCursor(Qt::PointingHandCursor));

    // 第二句
    btn2->setFixedSize(171,62);
    QPixmap j2P1(":/sxzf/erji/sxzf_2j01.png");
    QPixmap j2P2(":/sxzf/erji/sxzf_2j02.png");
    btn2->setNormalImage(j2P1);
    btn2->setPressImage(j2P2);
    btn2->setCursor(QCursor(Qt::PointingHandCursor));

    // 第三句
    btn3->setFixedSize(171,62);
    QPixmap j3P1(":/sxzf/erji/sxzf_3j01.png");
    QPixmap j3P2(":/sxzf/erji/sxzf_3j02.png");
    btn3->setNormalImage(j3P1);
    btn3->setPressImage(j3P2);
    btn3->setCursor(QCursor(Qt::PointingHandCursor));

    // 第四句
    btn4->setFixedSize(171,62);
    QPixmap j4P1(":/sxzf/erji/sxzf_4j01.png");
    QPixmap j4P2(":/sxzf/erji/sxzf_4j02.png");
    btn4->setNormalImage(j4P1);
    btn4->setPressImage(j4P2);
    btn4->setCursor(QCursor(Qt::PointingHandCursor));

    // 第五句
    btn5->setFixedSize(171,62);
    QPixmap j5P1(":/sxzf/erji/sxzf_5j01.png");
    QPixmap j5P2(":/sxzf/erji/sxzf_5j02.png");
    btn5->setNormalImage(j5P1);
    btn5->setPressImage(j5P2);
    btn5->setCursor(QCursor(Qt::PointingHandCursor));

    // 第六句
    btn6->setFixedSize(171,62);
    QPixmap j6P1(":/sxzf/erji/sxzf_6j01.png");
    QPixmap j6P2(":/sxzf/erji/sxzf_6j02.png");
    btn6->setNormalImage(j6P1);
    btn6->setPressImage(j6P2);
    btn6->setCursor(QCursor(Qt::PointingHandCursor));

    // 第七句
    btn7->setFixedSize(171,62);
    QPixmap j7P1(":/sxzf/erji/sxzf_7j01.png");
    QPixmap j7P2(":/sxzf/erji/sxzf_7j07.png");
    btn7->setNormalImage(j7P1);
    btn7->setPressImage(j7P2);
    btn7->setCursor(QCursor(Qt::PointingHandCursor));

    // 第八句
    btn8->setFixedSize(171,62);
    QPixmap j8P1(":/sxzf/erji/sxzf_8j01.png");
    QPixmap j8P2(":/sxzf/erji/sxzf_8j02.png");
    btn8->setNormalImage(j8P1);
    btn8->setPressImage(j8P2);
    btn8->setCursor(QCursor(Qt::PointingHandCursor));

    // 返回
    btnBack->setGeometry(646,522,283,95);
    QPixmap backP1(":/sxzf/fh_09.png");
    QPixmap backP2(":/sxzf/fh_09.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));

    // 动态布局
//    QScrollArea *scrollArea = new QScrollArea(sxzf3Page);
//    QWidget *btnWidget = new QWidget(sxzf3Page);
//    QVBoxLayout *vlayout = new QVBoxLayout(sxzf3Page);
    vlayout->setSizeConstraint(QVBoxLayout::SetMinAndMaxSize);

    qDebug() << __FUNCTION__  << poemList.count() ;
    if (poemList.count() == 2) {
        btn1->hide();
        btn2->hide();
        btn3->hide();
        btn4->hide();
        btn5->hide();
        btn6->hide();
        btn7->hide();
        btn8->hide();
        btnSQ->show();
        btnXQ->show();

        vlayout->addWidget(btnSQ);
        vlayout->addWidget(btnXQ);
    } else if (poemList.count() == 4) {
        btnSQ->hide();
        btnXQ->hide();
        btn1->show();
        btn2->show();
        btn3->show();
        btn4->show();
        btn5->hide();
        btn6->hide();
        btn7->hide();
        btn8->hide();

        vlayout->addWidget(btn1);
        vlayout->addWidget(btn2);
        vlayout->addWidget(btn3);
        vlayout->addWidget(btn4);
    }else if (poemList.count() == 5) {
        btnSQ->hide();
        btnXQ->hide();
        btn1->show();
        btn2->show();
        btn3->show();
        btn4->show();
        btn5->show();
        btn6->hide();
        btn7->hide();
        btn8->hide();

        vlayout->addWidget(btn1);
        vlayout->addWidget(btn2);
        vlayout->addWidget(btn3);
        vlayout->addWidget(btn4);
        vlayout->addWidget(btn5);
    } else if (poemList.count() == 6) {
        btnSQ->hide();
        btnXQ->hide();
        btn1->show();
        btn2->show();
        btn3->show();
        btn4->show();
        btn5->show();
        btn6->show();
        btn7->hide();
        btn8->hide();

        vlayout->addWidget(btn1);
        vlayout->addWidget(btn2);
        vlayout->addWidget(btn3);
        vlayout->addWidget(btn4);
        vlayout->addWidget(btn5);
        vlayout->addWidget(btn6);
    } else if (poemList.count() == 8) {
        btnSQ->hide();
        btnXQ->hide();
        btn1->show();
        btn2->show();
        btn3->show();
        btn4->show();
        btn5->show();
        btn6->show();
        btn7->show();
        btn8->show();

        vlayout->addWidget(btn1);
        vlayout->addWidget(btn2);
        vlayout->addWidget(btn3);
        vlayout->addWidget(btn4);
        vlayout->addWidget(btn5);
        vlayout->addWidget(btn6);
        vlayout->addWidget(btn7);
        vlayout->addWidget(btn8);
    }

    btnWidget->setGeometry(685,165,171,260);
    btnWidget->setLayout(vlayout);

    scrollArea->show();
    scrollArea->setGeometry(685,165,220,300);
    scrollArea->setFrameShape(QFrame::NoFrame);
    scrollArea->setStyleSheet("background-color:white");
    scrollArea->setWidget(btnWidget);
    scrollArea->verticalScrollBar()->setStyleSheet("QScrollBar:vertical{width:6px;background:transparent;background-color:rgb(248, 248, 248);margin:0px,0px,0px,0px;padding-top:10px;padding-bottom:10px;}"
                       "QScrollBar::handle:vertical{width:6px;background:lightgray ;border-radius:5px;min-height:20px;}"
                       "QScrollBar::handle:vertical:hover{width:6px;background:gray;border-radius:5px;min-height:20px;}"
                       "QScrollBar::add-line:vertical{height:10px;width:10px;border-image:url(:/button/images/button/down.png);subcontrol-position:bottom;}"
                       "QScrollBar::sub-line:vertical{height:10px;width:10px;border-image:url(:/button/images/button/up.png);subcontrol-position:top;}"
                       "QScrollBar::add-line:vertical:hover{height:10px;width:10px;border-image:url(:/button/images/button/down_mouseDown.png);subcontrol-position:bottom;}"
                       "QScrollBar::sub-line:vertical:hover{height:10px;width:10px;border-image:url(:/button/images/button/up_mouseDown.png);subcontrol-position:top;}"
                       "QScrollBar::add-page:vertical,QScrollBar::sub-page:vertical{background:transparent;border-radius:5px;}");
}

void Sxzf3Page::onBackClick()
{
    listView->blockSignals(false);
    listView->clearSelection();
    stackWidget->setCurrentWidget(parentPage);
    leftImageLabel->clear();

    scrollArea->hide();
}

void Sxzf3Page::onSQClick()
{
    qDebug() << __FUNCTION__  << poemList[0];
    QString videoUrl = poemList[0][1];
    QString imageUrl =poemList[0][0];
    int videoSize = poemList[0][2].toInt();

    btnSQ->blockSignals(true);

    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btnSQ, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::onXQClick()
{
    QString videoUrl = poemList[1][1];
    QString imageUrl =poemList[1][0];
    int videoSize = poemList[1][2].toInt();

    btnXQ->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btnXQ, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on1Click()
{
    qDebug() << __FUNCTION__  << poemList[0];
    QString videoUrl = poemList[0][1];
    QString imageUrl =poemList[0][0];
    int videoSize = poemList[0][2].toInt();

    btn1->blockSignals(true);

    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn1, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on2Click()
{
    QString videoUrl = poemList[1][1];
    QString imageUrl =poemList[1][0];
    int videoSize = poemList[1][2].toInt();

    btn2->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn2, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on3Click()
{
    QString videoUrl = poemList[2][1];
    QString imageUrl =poemList[2][0];
    int videoSize = poemList[2][2].toInt();

    btn3->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn3, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on4Click()
{
    QString videoUrl = poemList[3][1];
    QString imageUrl =poemList[3][0];
    int videoSize = poemList[3][2].toInt();

    btn4->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn4, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on5Click()
{
    QString videoUrl = poemList[4][1];
    QString imageUrl =poemList[4][0];
    int videoSize = poemList[4][2].toInt();

    btn5->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn5, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on6Click()
{
    QString videoUrl = poemList[5][1];
    QString imageUrl =poemList[5][0];
    int videoSize = poemList[5][2].toInt();

    btn6->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn6, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on7Click()
{
    QString videoUrl = poemList[6][1];
    QString imageUrl =poemList[6][0];
    int videoSize = poemList[6][2].toInt();

    btn7->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn7, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}

void Sxzf3Page::on8Click()
{
    QString videoUrl = poemList[7][1];
    QString imageUrl =poemList[7][0];
    int videoSize = poemList[7][2].toInt();

    btn8->blockSignals(true);
    sxzfVideoPage->setSxzfVideoPage(sxzf3Page, btn8, videoUrl, videoSize, "image:url(:/sxzf/sxzf_tb1.png)", imageUrl, QRect(270,70,455,350));
    stackWidget->setCurrentWidget(nextPage);
}
