#include "sxzfpage.h"
#include <QDebug>

SxzfPage* SxzfPage::sxzfInstance = NULL;

SxzfPage::SxzfPage(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    sxzf2Page = Sxzf2Page::getSxzf2Instance();
    sxzfVdeoPage = SxzfVideoPage::getSxzfVideoInstance();
}

SxzfPage* SxzfPage::getSxzfInstance()
{
    if (sxzfInstance == NULL)
        sxzfInstance = new SxzfPage();

    return sxzfInstance;
}

void SxzfPage::setWidget(QWidget *sxzf, QStackedWidget *stack, QWidget *next, QWidget *video)
{
    sxzfPage = sxzf;
    nextPage = next;
    videoPage = video;
    stackWidget = stack;

    // 页面元素初始化
    topImageLabel = new QLabel(sxzfPage);
    btnSxyl = new ImageButton(sxzfPage);
    btn1 = new ImageButton(sxzfPage);
    btn2 = new ImageButton(sxzfPage);
    btn3 = new ImageButton(sxzfPage);
    btn4 = new ImageButton(sxzfPage);
    btn5 = new ImageButton(sxzfPage);
    btn6 = new ImageButton(sxzfPage);
    btnBack = new ImageButton(sxzfPage);

    connect(btnSxyl, SIGNAL(clicked()), this, SLOT(onSxylClick()));
    connect(btn1, SIGNAL(clicked()), this, SLOT(on1NjClick()));
    connect(btn2, SIGNAL(clicked()), this, SLOT(on2NjClick()));
    connect(btn3, SIGNAL(clicked()), this, SLOT(on3NjClick()));
    connect(btn4, SIGNAL(clicked()), this, SLOT(on4NjClick()));
    connect(btn5, SIGNAL(clicked()), this, SLOT(on5NjClick()));
    connect(btn6, SIGNAL(clicked()), this, SLOT(on6NjClick()));
    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
}

void SxzfPage::setSxzfPage(QWidget *parent, ImageButton *btnP)
{
    parentPage = parent;
    btnParent = btnP;

    setBackGround();
    setButtons();
}

void SxzfPage::setBackGround()
{
    sxzfPage->setStyleSheet("image:url(:/sxzf/bj_13.jpg)");
    topImageLabel->setGeometry(99,99,331,81);
    topImageLabel->setStyleSheet("image:url(:sxzf/sxzf_gssx.png)");
}

void SxzfPage::setButtons()
{
    // 书写要领
    btnSxyl->setGeometry(497,124,180,68);
    QPixmap sxylP1(":/sxzf/sxzf_sxyl02.png");
    QPixmap sxylP2(":/sxzf/sxzf_sxyl01.png");
    btnSxyl->setNormalImage(sxylP1);
    btnSxyl->setPressImage(sxylP2);
    btnSxyl->setCursor(QCursor(Qt::PointingHandCursor));


    // 一年级
    btn1->setGeometry(441,247,193,70);
    QPixmap nj1P1(":/sxzf/sxzf_1nj01.png");
    QPixmap nj1P2(":/sxzf/sxzf_1nj02.png");
    btn1->setNormalImage(nj1P1);
    btn1->setPressImage(nj1P2);
    btn1->setCursor(QCursor(Qt::PointingHandCursor));


    // 二年级
    btn2->setGeometry(678,247,193,70);
    QPixmap nj2P1(":/sxzf/sxzf_2nj01.png");
    QPixmap nj2P2(":/sxzf/sxzf_2nj02.png");
    btn2->setNormalImage(nj2P1);
    btn2->setPressImage(nj2P2);
    btn2->setCursor(QCursor(Qt::PointingHandCursor));


    // 三年级
    btn3->setGeometry(441,345,193,70);
    QPixmap nj3P1(":/sxzf/sxzf_3nj01.png");
    QPixmap nj3P2(":/sxzf/sxzf_3nj02.png");
    btn3->setNormalImage(nj3P1);
    btn3->setPressImage(nj3P2);
    btn3->setCursor(QCursor(Qt::PointingHandCursor));


    // 四年级
    btn4->setGeometry(678,345,193,70);
    QPixmap nj4P1(":/sxzf/sxzf_4nj01.png");
    QPixmap nj4P2(":/sxzf/sxzf_4nj02.png");
    btn4->setNormalImage(nj4P1);
    btn4->setPressImage(nj4P2);
    btn4->setCursor(QCursor(Qt::PointingHandCursor));


    // 五年级
    btn5->setGeometry(441,444,193,70);
    QPixmap nj5P1(":/sxzf/sxzf_5nj01.png");
    QPixmap nj5P2(":/sxzf/sxzf_5nj02.png");
    btn5->setNormalImage(nj5P1);
    btn5->setPressImage(nj5P2);
    btn5->setCursor(QCursor(Qt::PointingHandCursor));


    // 六年级
    btn6->setGeometry(678,444,193,70);
    QPixmap nj6P1(":/sxzf/sxzf_6nj01.png");
    QPixmap nj6P2(":/sxzf/sxzf_6nj02.png");
    btn6->setNormalImage(nj6P1);
    btn6->setPressImage(nj6P2);
    btn6->setCursor(QCursor(Qt::PointingHandCursor));


    // 返回
    btnBack->setGeometry(646,522,283,95);
    QPixmap backP1(":/sxzf/fh_09.png");
    QPixmap backP2(":/sxzf/fh_09.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));

}

void SxzfPage::onSxylClick()
{
    QString videoUrl = middle->getOption("klxz_writegist");

    qDebug() << __FUNCTION__  << "videoUrl" << videoUrl;
    btnSxyl->blockSignals(true);

    sxzfVdeoPage->setSxzfVideoPage(sxzfPage, btnSxyl, videoUrl, -1, "image:url(:/sxzf/sxzf_tb.png)", "", QRect(200,90,610,430));
    stackWidget->setCurrentWidget(videoPage);
}

void SxzfPage::on1NjClick()
{
    btn1->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sxzf2Page->setSxzf2Page(sxzfPage, btn1, "1");
}

void SxzfPage::on2NjClick()
{
    btn2->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sxzf2Page->setSxzf2Page(sxzfPage, btn2, "2");
}

void SxzfPage::on3NjClick()
{
    btn3->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sxzf2Page->setSxzf2Page(sxzfPage, btn3, "3");
}

void SxzfPage::on4NjClick()
{
    btn4->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sxzf2Page->setSxzf2Page(sxzfPage, btn4, "4");
}

void SxzfPage::on5NjClick()
{
    btn5->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sxzf2Page->setSxzf2Page(sxzfPage, btn5, "5");
}

void SxzfPage::on6NjClick()
{
    btn6->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sxzf2Page->setSxzf2Page(sxzfPage, btn6, "6");
}

void SxzfPage::onBackClick()
{
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
}
