#include "xzzspage.h"
#include <QPainter>
#include <QLabel>
#include <QDebug>

XzzsPage* XzzsPage::xzzsInstance = NULL;
XzzsPage::XzzsPage(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    video = VideoPage::getVideoPageInstance();
}

XzzsPage* XzzsPage::getXzzsInstance()
{
    if (xzzsInstance == NULL) {
        xzzsInstance = new XzzsPage();
    }

    return xzzsInstance;
}

void XzzsPage::setWidget(QWidget *xzzs, QStackedWidget *stack, QWidget *next)
{
    xzzsPage = xzzs;
    nextPage = next;
    stackWidget = stack;

    topImageLabel = new QLabel(xzzsPage);
    btnZqwb = new ImageButton(xzzsPage);
    btnWbjz = new ImageButton(xzzsPage);
    btnJkzz = new ImageButton(xzzsPage);
    btnJx3fz = new ImageButton(xzzsPage);
    btnBack = new ImageButton(xzzsPage);

    connect(btnZqwb, SIGNAL(clicked()), this, SLOT(onZqwbClicked()));
    connect(btnWbjz, SIGNAL(clicked()), this, SLOT(onWbjzClicked()));
    connect(btnJkzz, SIGNAL(clicked()), this, SLOT(onJkzzClicked()));
    connect(btnJx3fz, SIGNAL(clicked()), this, SLOT(onJx3fzClicked()));
    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
}

void XzzsPage::setXzzsPage(QWidget *parent, ImageButton *btnP)
{
    parentPage = parent;
    btnParent = btnP;

    setBackGround();
    setButtons();
}

void XzzsPage::setBackGround()
{
    xzzsPage->setStyleSheet("QWidget#xzzsPage{image:url(:/xzzs/bj_10.jpg)}");
    topImageLabel->setGeometry(338,37,331,104);
    topImageLabel->setStyleSheet("image:url(:/xzzs/xzzs_bt.png)");
}

void XzzsPage::setButtons()
{
    // 正确握笔
    btnZqwb->setGeometry(246,217,216,62);
    QPixmap zqwbP1(":/xzzs/xzzs_zqwb01.png");
    QPixmap zqwbP2(":/xzzs/xzzs_zqwb02.png");
    btnZqwb->setNormalImage(zqwbP1);
    btnZqwb->setPressImage(zqwbP2);
    btnZqwb->setCursor(QCursor(Qt::PointingHandCursor));

    // 握笔纠正
    btnWbjz->setGeometry(546,217,216,62);
    QPixmap wbjzP1(":/xzzs/xzzs_wbjz01.png");
    QPixmap wbjzP2(":/xzzs/xzzs_wbjz02.png");
    btnWbjz->setNormalImage(wbjzP1);
    btnWbjz->setPressImage(wbjzP2);
    btnWbjz->setCursor(QCursor(Qt::PointingHandCursor));

    // 健康坐姿
    btnJkzz->setGeometry(246,307,216,62);
    QPixmap jkzzP1(":/xzzs/xzzs_jkzi01.png");
    QPixmap jkzzP2(":/xzzs/xzzs_jkzi02.png");
    btnJkzz->setNormalImage(jkzzP1);
    btnJkzz->setPressImage(jkzzP2);
    btnJkzz->setCursor(QCursor(Qt::PointingHandCursor));

    // 静心三分钟
    btnJx3fz->setGeometry(546,307,216,62);
    QPixmap jx3fzP1(":/xzzs/xzzs_jxsfz01.png");
    QPixmap jx3fzP2(":/xzzs/xzzs_jxsfz02.png");
    btnJx3fz->setNormalImage(jx3fzP1);
    btnJx3fz->setPressImage(jx3fzP2);
    btnJx3fz->setCursor(QCursor(Qt::PointingHandCursor));

    // 返回按钮
    btnBack->setGeometry(624,446,248,208);
    QPixmap backP1(":/jbbh/fh_05.png");
    QPixmap backP2(":/jbbh/fh_06.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));
}

void XzzsPage::onZqwbClicked()
{
    QString videoUrl;
    int videoSize;

    QString tmp = middle->getXieZiZiShiVideoUrl("zqwb");
    QStringList list = tmp.split(",");

    if (list.count() == 2) {
        videoUrl = list[0];
        videoSize = list[1].toInt();
    } else {
        videoUrl = "";
        videoSize = 0;
    }
    qDebug() << __FUNCTION__  << videoUrl;

    btnZqwb->blockSignals(true);
    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "",
                            "image:url(:/xzzs/wbtj_bt.png)", "image:url(:/xzzs/sjqp.png)",
                            videoUrl, videoSize, btnZqwb, xzzsPage, "ggxz");

    stackWidget->setCurrentWidget(nextPage);
}

void XzzsPage::onWbjzClicked()
{
    QString videoUrl;
    int videoSize;

    QString tmp = middle->getXieZiZiShiVideoUrl("wbjz");
    QStringList list = tmp.split(",");

    if (list.count() == 2) {
        videoUrl = list[0];
        videoSize = list[1].toInt();
    } else {
        videoUrl = "";
        videoSize = 0;
    }
    qDebug() << __FUNCTION__  << videoUrl;

    btnWbjz->blockSignals(true);
    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "image:url(:/xzzs/zxxser_wbjz.png)",
                            "", "image:url(:/xzzs/sjqp.png)",
                            videoUrl, videoSize, btnWbjz, xzzsPage, "ggxz");

    stackWidget->setCurrentWidget(nextPage);
}

void XzzsPage::onJkzzClicked()
{
    QString videoUrl;
    int videoSize;

    QString tmp = middle->getXieZiZiShiVideoUrl("jkzz");
    QStringList list = tmp.split(",");

    if (list.count() == 2) {
        videoUrl = list[0];
        videoSize = list[1].toInt();
    } else {
        videoUrl = "";
        videoSize = 0;
    }
    qDebug() << __FUNCTION__  << videoUrl;

    btnJkzz->blockSignals(true);
    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "image:url(:/xzzs/jkzz_bt.png)",
                            "", "image:url(:/xzzs/sjqp.png)",
                            videoUrl, videoSize, btnJkzz, xzzsPage, "ggxz");

    stackWidget->setCurrentWidget(nextPage);
}

void XzzsPage::onJx3fzClicked()
{
    QString videoUrl;
    int videoSize;

    QString tmp = middle->getXieZiZiShiVideoUrl("jx3fz");
    QStringList list = tmp.split(",");

    if (list.count() == 2) {
        videoUrl = list[0];
        videoSize = list[1].toInt();
    } else {
        videoUrl = "";
        videoSize = 0;
    }
    qDebug() << __FUNCTION__  << videoUrl;

    btnJx3fz->blockSignals(true);
    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "image:url(:/xzzs/jx_bt.png)",
                            "", "image:url(:/xzzs/sjqp.png)",
                            videoUrl, videoSize, btnJx3fz, xzzsPage, "ggxz");

    stackWidget->setCurrentWidget(nextPage);
}

void XzzsPage::onBackClick()
{
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
}
