/***********************************************************************
*
* ļ        XmlConfig.cpp
* ģĿģù
* ߼ڣ  wu_bin 2009-05-26
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning ( disable : 4786 )

#include "XmlConfig.h"

#include <stdio.h> // for NULL


CXmlConfig::CXmlConfig()
{}

CXmlConfig::~CXmlConfig()
{}


void CXmlConfig::InitXmlText( GDConfig * pConfig, TiXmlElement* pNode, const string& top )
{
	TiXmlAttribute* pAttr = pNode->FirstAttribute();
	while ( pAttr )
	{
		string var = top + "." + pNode->Value() + "." + pAttr->Name();
		
		pConfig->cfgMap.insert( make_pair<string>(var, pAttr->Value()) );
		
		pAttr = pAttr->Next();
	}
	
	TiXmlElement* pChild = pNode->FirstChildElement();
	while ( pChild )
	{
		InitXmlText( pConfig, pChild, top+"."+pNode->Value() );
		pChild = pChild->NextSiblingElement();
	}
}

void CXmlConfig::LoadXmlFile( const char* szFileName )
{
	// һXMLĵ
    TiXmlDocument * xmlDoc = new TiXmlDocument( szFileName );
    if ( xmlDoc->LoadFile() )
	{
		// øԪ
		TiXmlElement * pRootElement = xmlDoc->RootElement();
		// Ԫ
		if ( pRootElement )
		{
			GDConfig * pConfig = new GDConfig;
			
			pConfig->sCfgFile = szFileName;
			
			InitXmlText( pConfig, pRootElement, "" );
			
			m_config.insert( make_pair(szFileName, pConfig) );
			map< string, GDConfig* >::iterator itor = m_config.find( szFileName );
			if ( itor != m_config.end() )
			{
				printf("OK");
			}
		}
	}
}

bool CXmlConfig::LoadConfig( const char* sCfgFile , bool bForce )
{
	//Ѽ,ټ
	map< string, GDConfig* >::iterator itor = m_config.find( sCfgFile );
	//ǿ¼ļ
	if ( itor != m_config.end() )
	{
		UnloadConfig( sCfgFile );
	}
	
	//ڴ
	long nRet = 0;
	//·е"/""\\"滻Ϊ*
	string pathToChar = sCfgFile;
	CGDString::ReplaceChar( pathToChar, C_PATHLASH, '/');
	cfgBuffer = new CSharedBuffer();
	nRet = cfgBuffer->CreateBuffer( pathToChar.c_str(), 32 );
	if ( 0 != nRet )    //0 = NO_ERROR
	{
		printf( "CreateMemory() fail\n" );
		return false;
	}
    //ڴݣ轫mapݼӵڴ
	bool test = cfgBuffer->IsOwner();
	if ( cfgBuffer->IsOwner() || bForce )
	{
		LoadXmlFile( sCfgFile );
		SetConfigBuffer( sCfgFile );
	}
	else 
	{
		GetConfigBuffer( sCfgFile );
	}
	return true;
}

bool CXmlConfig::UnloadConfig( const char* sCfgFile )
{
	map< string, GDConfig* >::iterator itor = m_config.find( sCfgFile );
	if ( itor != m_config.end() )
	{
		GDConfig * pConfig = itor->second;
		delete pConfig;
		m_config.erase( itor );
	}
	/*
	//ͷŹڴ
	if ( cfgBuffer )
	{
		cfgBuffer->ReleaseBuffer();
	    //delete cfgBuffer;            //жʱͷŹڴ棿 
	}
	*/   
	return true;
}

const char* CXmlConfig::GetConfigString( const char* sCfgFile, const char* sItemPath )
{
	map< string, GDConfig* >::iterator itor = m_config.find( sCfgFile );
	if ( itor != m_config.end() )
	{
		GDConfig * pConfig = itor->second; 
		map< string, string >::iterator it = pConfig->cfgMap.find( sItemPath );
		if ( it != pConfig->cfgMap.end() )
		{
			return (it->second).c_str();
		}
	}
	
	return NULL;
}
int CXmlConfig::GetConfigInteger( const char* sCfgFile, const char* sItemPath )
{
	map< string, GDConfig* >::iterator itor = m_config.find( sCfgFile );
	if ( itor != m_config.end() )
	{
		GDConfig * pConfig = itor->second;
		map< string, string >::iterator it = pConfig->cfgMap.find( sItemPath );
		if ( it != pConfig->cfgMap.end() )
		{
			return atoi( (it->second).c_str() );
		}
	}
	
	return 0;
}

void CXmlConfig::WalkConfig( const char* sCfgFile, CallbackFunc2 pFunc, void* pvoid )
{
	map< string, GDConfig* >::iterator itor1 = m_config.find( sCfgFile );
	if ( itor1 != m_config.end() )
	{
		printf("OK");
	}
	map< string, GDConfig* >::iterator itor = m_config.find( sCfgFile );
	if ( itor != m_config.end() )
	{
		GDConfig * pConfig = itor->second;
		map< string, string >::iterator it = pConfig->cfgMap.begin();
		while ( it != pConfig->cfgMap.end() )
		{
			(*pFunc) ( it->first.c_str(), it->second.c_str(), pvoid );
			it ++;
		}
	}
}

//mapݼصڴ
long CXmlConfig::SetConfigBuffer( const char* sCfgFile)
{ 
	map< string, GDConfig* >::iterator itor1 = m_config.find( sCfgFile );
	if ( itor1 != m_config.end() )
	{
		printf("OK");
	}
	map< string, GDConfig* >::iterator itor = m_config.find( sCfgFile );
	
	//дڴ
	long nRet = 0;
	if ( itor != m_config.end() )
	{
		GDConfig * pConfig = itor->second; 
		map< string, string >::iterator it = pConfig->cfgMap.begin();
		string  strCfg;       
		while ( it != pConfig->cfgMap.end() )
		{
            strCfg += it->first + "=" + it->second + "|";	    //ļȫŵһַ
			
			printf( "%s=%s\n",it->first.c_str(),it->second.c_str() );        //Դӡڴ
			it ++;
		}
		nRet = cfgBuffer->SetData((void*)strCfg.c_str(),strCfg.length()+1);              //дڴ
		if (nRet != 0)               //0 = NO_ERROR
		{
			return nRet;
		}
	}
	if ( cfgBuffer )
	{
		cfgBuffer->ReleaseBuffer();
		delete cfgBuffer;            //жعڴ
	}
	return 0;                        //0 = NO_ERROR
	
}

//ȡڴ,дmap
long CXmlConfig::GetConfigBuffer( const char* szFileName )
{
	//ȡڴݴС
	long nSize = 0;
	cfgBuffer->GetData(NULL,nSize);	
	char* pBuff = new char[nSize + 1];
	long nRet = cfgBuffer->GetData( (void*)pBuff, nSize );
	if ( 0 != nRet )               //0 = NO_ERROR
	{
		delete []pBuff;
		pBuff = NULL;
		return nRet;
	}
    
	GDConfig * pConfig = new GDConfig;
	pConfig->sCfgFile = szFileName;
	
    string  cfgTmp = pBuff;
	string strTmp;
	string::size_type pos1,pos2;
	while (true)
	{
		pos1 = cfgTmp.find("|");
		if (pos1 == string::npos)
		{
			break;
		}
		strTmp = cfgTmp.substr(0,pos1);
		cfgTmp = cfgTmp.substr(pos1+1);
		
		//ļеÿԪؼӵmap
		pos2 = strTmp.find("=");
		if (pos2 == string::npos)
		{
			printf("find = error!\n");
		}
		string cfgMapFirst = strTmp.substr(0,pos2);
		string cfgMapSecond = strTmp.substr(pos2+1);

		printf( "%s=%s\n",cfgMapFirst.c_str(),cfgMapSecond.c_str() );        //Դӡڴ
		pConfig->cfgMap.insert( make_pair(cfgMapFirst,cfgMapSecond) );
	}
	
	m_config.insert(make_pair( szFileName,pConfig ));
	
	return 0;       //0 = NO_ERROR
}